﻿Imports XCM
Imports XSP
Imports LST.clsLST010F010
Imports System.Windows.Forms

''' ---------------------------------------------
''' <summary>
''' 統計_統計表選択
''' </summary>
''' <remarks>
''' Copyright 2010 FUJITSU SHIKOKU SYSTEMS LIMITED All rights reserved.<BR/>
''' FUJITSU SHIKOKU SYSTEMS LIMITED CONFIDENTIAL<BR/>
''' </remarks>
''' ---------------------------------------------
Public Class LST010F010

#Region "コンスタント"

	Private Const CST_INT_ZERO As Integer = 0
	Private Const CST_STR_COMMA As String = ","
	Private Const CST_STR_UNDERBAR As String = "_"
	Private Const CST_FMT_YYYY As String = "yyyy"
	Private Const CST_FMT_YYYYMM As String = "yyyyMM"
	Private Const CST_FMT_YYYYMM_AddSlash As String = "yyyy/MM"
	'日付チェック
	Private Const DT_EMPTYDATE As String = Nothing
	Private Const MSG_PRM_FROM As String = "日付From"
	Private Const MSG_PRM_TO As String = "日付To"
	Private Const MSG_PRM_FROM_TO As String = "日付From、日付To"
	Private Const MSG_PRM_DATE_COMP As String = "対象期間　日付From＞対象期間　日付To"
	Private Const REP_STR_DATE As String = "日付"
	Private Const REP_STR_INTERVAL As String = "対象期間"
	' 必須の前景色
	Private CR_NEEDFORECOLOR As System.Drawing.Color = clsConst.CST_REQUIRED_COLOR
	'シート名の列名
	Private Const CST_COL_SHEETNM As String = "SHEET_NM"
	'事象の型
	Private Enum Enum_Event As Integer
		Initialize			'初期設定時
		PrintModeSelect		'帳票選択時
		Update				'修正時
		Save				'保存時
		Cancel				'取消時
	End Enum
	'帳票種類に対する定義コード
	Private PrefixDefinitionCd() As String = { _
	 Nothing, "80000010", "80000020", "80000030", "80000040", "80000050" _
	}
	'前回値取得・保存コントロール名
	Private LastValueCtl() As String = { _
	 "cmb003LST010F010", _
	 "dte007LST010F010", "dte009LST010F010", _
	 "dte039LST010F010", "dte041LST010F010" _
	}
	'フォルダ指定ダイアログ用
	Private Const CST_CSV_FILENM As String = "帳票タイトル[管理物]_年月日時分秒" & clsCSV.CST_CSV_EXTENTION
	Private Const CST_CSV_TITLE As String = "帳票タイトル"
	Private Const CST_CSV_MNGITEM As String = "管理物"
	Private Const CST_CSV_DATE As String = "年月日時分秒"
	Private Const CST_CSV_HEADER As String = _
	 "連番,患者番号,管理物コード,管理物名称,区分１コード,区分１名称,区分２コード,区分２名称," _
	 & "物番号,伝票コード,貸出日,返却予定日,返却督促日,返却日,借用者コード,帯出者コード," _
	 & "縦軸コード,縦軸名,横軸コード,横軸名"
	'CSV出力項目（共通）
	Private csvCommon() As String = New String() _
	   { _
	   sqlLST010F010.itmSEQ, _
	   sqlLST010F010.itmPATIENT_NO, _
	   sqlLST010F010.itmMNGITEM_CD, _
	   sqlLST010F010.itmMNGITEM_NM, _
	   sqlLST010F010.itmDIV1_CD, _
	   sqlLST010F010.itmDIV1_NM, _
	   sqlLST010F010.itmDIV2_CD, _
	   sqlLST010F010.itmDIV2_NM, _
	   sqlLST010F010.itmBYOREKI_NO, _
	   sqlLST010F010.itmSLIP_CD, _
	   sqlLST010F010.itmISSUE_DT, _
	   sqlLST010F010.itmEXPECTBACK_DT, _
	   sqlLST010F010.itmURGEDBACK_DT, _
	   sqlLST010F010.itmBACK_DT, _
	   sqlLST010F010.itmBORROWER_CD, _
	   sqlLST010F010.itmTAKER_CD _
	   }
	'CSV出力項目（帳票種類に対する項目）
	Private csv_L_DivByPurpose() As String = New String() _
	   { _
	   sqlLST010F010.itmSTAFFDIV_CD, _
	   sqlLST010F010.itmSTAFFDIV_NM, _
	   sqlLST010F010.itmLENDAIM_CD, _
	   sqlLST010F010.itmLENDAIM_NM _
	   }
	Private csv_L_PurposeByMonth() As String = New String() _
	   { _
	   sqlLST010F010.itmLENDAIM_CD, _
	   sqlLST010F010.itmLENDAIM_NM, _
	   sqlLST010F010.itmISSUE_DT_YM, _
	   sqlLST010F010.itmISSUE_DT_YM_NM _
	   }
	Private csv_U_DivByMonth() As String = New String() _
	   { _
	   sqlLST010F010.itmSTAFFDIV_CD, _
	   sqlLST010F010.itmSTAFFDIV_NM, _
	   sqlLST010F010.itmISSUE_DT_YM, _
	   sqlLST010F010.itmISSUE_DT_YM_NM _
	   }
	Private csv_U_BorrowerByMonth() As String = New String() _
	   { _
	   sqlLST010F010.itmBORROWER_NM, _
	   sqlLST010F010.itmSTAFF_NM, _
	   sqlLST010F010.itmISSUE_DT_YM, _
	   sqlLST010F010.itmISSUE_DT_YM_NM _
	   }
	'実行中文言
	Private Const CST_MSG_EXEC_PREVIEW As String = "プレビュー実行中です。"
	Private Const CST_MSG_EXEC_PRINT As String = "印刷実行中です。"
	Private Const CST_MSG_EXEC_EXCEL As String = "EXCEL出力実行中です。"
	Private Const CST_MSG_EXEC_CSV As String = "CSV出力実行中です。"

'(A) STR V4-14047-000 003 20130812 ID)平井(貸出管理レベルアップ２次開発　大規模病院への対応　グループ検索)
	Private Const C_XSP240F010_ID As String = "XSP240F010"
'(A) END V4-14047-000 003 20130812

#End Region

#Region "変数"

	Private cliCom As clsCom
	Private cliCombo As clsComboCom
	Private cliExcelFunc As clsExcelFunc
	Private cliLTM_LENDAIM As clsLTM_LENDAIM
	Private cliLTM_MNGITEM As clsLTM_MNGITEM
	Private cliXTM_STAFFDIV As clsXTM_STAFFDIV
	Private cliXTM_STAFF As clsXTM_STAFF
	Private cliLST010F010 As clsLST010F010
	Private cliBmp As clsBmp
	Private cliXTM_USER As clsXTM_USER
	' 重複起動
	Private pbExclusive As Boolean = False
	' 出力帳票の種類
	Private pPrintMode As Enum_PrintMode
	' 統計ゼロ置換文字
	Private pRepZeroChr As String
	' 統計定義更新用データ領域
	Private datDefinitionSave As datLST010F010_STATISTICS_DEFINITION
	' 変更前データ（初期化・取消クリック時のチェック用）
	Private datDefinitionBefore As datLST010F010_STATISTICS_DEFINITION
	Private dtSheetNmCmbData As DataTable
	' 縦軸・横軸用
	Private cliTate As List(Of clsLST010F010.clsTate)
	Private cliYoko As List(Of clsLST010F010.clsYoko)
	' シートサイズチェック用変数
	Private pCntYoko As Integer
	Private pCntTate As Integer
	' 事象
	Private pEvent As Enum_Event
	' 前回値設定
	Private pbLoadlastValue As Boolean = False

'(A) STR V4-14047-000 003 20130812 ID)平井(貸出管理レベルアップ２次開発　大規模病院への対応　グループ検索)
	Private frmXSP240F010 As XSP240F010			'管理物グループ検索
'(A) END V4-14047-000 003 20130812

#End Region

#Region "コンストラクタ"

	''' ---------------------------------------------
	''' <summary>
	''' コンストラクタ
	''' </summary>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Sub New()

		' この呼び出しは、Windows フォーム デザイナで必要です。
		InitializeComponent()

		' InitializeComponent() 呼び出しの後で初期化を追加します。

	End Sub

#End Region

#Region "イベント"

	''' ---------------------------------------------
	''' <summary>
	''' 画面ロード
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub LST010F010_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
		log(clsSysMst.logLevel.NRM, "LST010F010_Load", "画面ロード Start")
		Try
			cliCom = New clsCom
			cliCombo = New clsComboCom
			cliExcelFunc = New clsExcelFunc
			cliLTM_LENDAIM = New clsLTM_LENDAIM
			cliLTM_MNGITEM = New clsLTM_MNGITEM
			cliXTM_STAFFDIV = New clsXTM_STAFFDIV
			cliXTM_STAFF = New clsXTM_STAFF
			cliLST010F010 = New clsLST010F010
			cliBmp = New clsBmp
			cliTate = New List(Of clsLST010F010.clsTate)
			cliYoko = New List(Of clsLST010F010.clsYoko)
			cliXTM_USER = New clsXTM_USER
			datDefinitionSave = New datLST010F010_STATISTICS_DEFINITION
			datDefinitionBefore = New datLST010F010_STATISTICS_DEFINITION
			dtSheetNmCmbData = New DataTable
			'イメージ設定
			Me.btn063LST010F010.Image = cliBmp.getBmp(clsBmp.Enum_BmpType.OpenFolder)
			'必須項目色設定
			Me.lbl052LST010F010.ForeColor = CR_NEEDFORECOLOR
			Me.lbl055LST010F010.ForeColor = CR_NEEDFORECOLOR
			Me.lbl058LST010F010.ForeColor = CR_NEEDFORECOLOR
			'項目の操作制御
			pEvent = Enum_Event.Initialize
			SetControlStyle(pEvent)
			'コンボの候補設定
			Using db As clsDB = New clsDB(clsSysMst.ctlConfigData)
'(M) STR V4-15007-000 004 2014/03/03 ID)鐘井 貸出管理レベルアップ４次開発　共通管理物の対応
'				Me.cmb003LST010F010.DataSource = cliCombo.getCombo(db, clsComboCom.Enum_ComboType.Enum_L_MngItem)
				cliLTM_MNGITEM.setMngItemCmb(db, Me.cmb003LST010F010, clsComboCom.Enum_ComboType.Enum_L_MngItem_NoComFlg)
'(M) END V4-15007-000 004 2014/03/03 ID)鐘井 貸出管理レベルアップ４次開発　共通管理物の対応
			End Using
			Me.cmb053LST010F010.DataSource = clsConst.getDspZeroRow()
			Me.cmb056LST010F010.DataSource = clsConst.getDspZeroRow()
			Me.cmb059LST010F010.DataSource = clsConst.getImpDsporder()
			Me.cmb065LST010F010.DataSource = Nothing
			' BT_MultiComboBox表示幅の設定
			Me.cmb003LST010F010.setDropDownWidth()
			Me.cmb053LST010F010.setDropDownWidth()
			Me.cmb056LST010F010.setDropDownWidth()
			Me.cmb059LST010F010.setDropDownWidth()
			Me.cmb065LST010F010.setDropDownWidth()
			'日付の初期値設定
			Dim prevYear As Integer = CInt(Now().ToString(CST_FMT_YYYY)) - 1
			Dim defaultDateFrom As Date = New Date(prevYear, 1, 1)
			Dim defaultDateTo As Date = New Date(prevYear, 12, 31)
			Me.dte007LST010F010.DateValue = defaultDateFrom
			Me.dte009LST010F010.DateValue = defaultDateTo
			Me.dte039LST010F010.DateValue = defaultDateFrom
			Me.dte041LST010F010.DateValue = defaultDateTo
			defaultDateFrom = Nothing
			defaultDateTo = Nothing
			'動作環境設定マスタ取得（統計ゼロ置換文字）
			pRepZeroChr = clsSysMst.ctlEnvData.getEnv(datEnv.Enum_ENV.ENV_00089)
			' 排他制御登録
			If Me.setStartStatus(True) = False Then
				setCancelFlg(True)
				EndProc()
				Exit Sub
			End If
			pbExclusive = True
		Catch ex As Exception
			ErrorProc(ex)
			setCancelFlg(True)
			EndProc()
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' フォームが開いた時
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub LST010F010_Shown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shown
		log(clsSysMst.logLevel.NRM, "LST010F010_Shown", "フォームが開いた時 Start")
		Try
			' 前回設定値取得
			LoadLastValue(LastValueCtl)
			pbLoadlastValue = True
		Catch ex As Exception
			ErrorProc(ex)
			EndProc()
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' フォームを閉じる時
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub LST010F010_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
		log(clsSysMst.logLevel.NRM, "LST010F010_FormClosing", "フォームを閉じる時 Start")
		Try
			setCloseFlg()
			' 排他制御削除（排他エラー時は削除しない）
			If pbExclusive Then
				' 排他情報を削除
				Me.delStartStatus()
			End If
			If pbLoadlastValue Then
				' 前回設定値保存
				SaveLastValue(LastValueCtl)
			End If
		Catch ex As Exception
			ErrorProc(ex)
		Finally
			' 開放処理
			' Class
			cliCom = Nothing
			cliCombo = Nothing
			cliExcelFunc = Nothing
			cliLTM_LENDAIM = Nothing
			cliLTM_MNGITEM = Nothing
			cliXTM_STAFFDIV = Nothing
			cliXTM_STAFF = Nothing
			cliLST010F010 = Nothing
			cliBmp = Nothing
			cliTate = Nothing
			cliYoko = Nothing
			cliXTM_USER = Nothing
			datDefinitionSave = Nothing
			datDefinitionBefore = Nothing
			If dtSheetNmCmbData IsNot Nothing Then dtSheetNmCmbData.Dispose()
			dtSheetNmCmbData = Nothing
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' 帳票選択変更時（貸出件数:借用者部門×貸出目的）
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub rdo021LST010F010_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdo021LST010F010.CheckedChanged
		Dim rdo As BT_RadioButton = CType(sender, BT_RadioButton)
		If rdo.Focused = True Then
			log(clsSysMst.logLevel.NRM, "rdo021LST010F010_CheckedChanged", "帳票選択変更時（貸出件数:借用者部門×貸出目的） Start")
		Else
			log(clsSysMst.logLevel.DBG, "rdo021LST010F010_CheckedChanged", "帳票選択変更時（貸出件数:借用者部門×貸出目的） Start")
		End If
		Try
			pEvent = Enum_Event.PrintModeSelect
			If rdo.Checked Then
				SetControlStyle(pEvent, Enum_PrintMode.L_DivByPurpose)
			End If
		Catch ex As Exception
			ErrorProc(ex)
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' 帳票選択変更時（貸出件数:貸出目的×貸出月）
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub rdo023LST010F010_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdo023LST010F010.CheckedChanged
		Dim rdo As BT_RadioButton = CType(sender, BT_RadioButton)
		If rdo.Focused = True Then
			log(clsSysMst.logLevel.NRM, "rdo023LST010F010_CheckedChanged", "帳票選択変更時（貸出件数:貸出目的×貸出月） Start")
		Else
			log(clsSysMst.logLevel.DBG, "rdo023LST010F010_CheckedChanged", "帳票選択変更時（貸出件数:貸出目的×貸出月） Start")
		End If
		Try
			pEvent = Enum_Event.PrintModeSelect
			If rdo.Checked Then
				SetControlStyle(pEvent, Enum_PrintMode.L_PurposeByMonth)
			End If
		Catch ex As Exception
			ErrorProc(ex)
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' 帳票選択変更時（未返却件数:借用者部門×貸出月）
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub rdo033LST010F010_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdo033LST010F010.CheckedChanged
		Dim rdo As BT_RadioButton = CType(sender, BT_RadioButton)
		If rdo.Focused = True Then
			log(clsSysMst.logLevel.NRM, "rdo033LST010F010_CheckedChanged", "帳票選択変更時（未返却件数:借用者部門×貸出月） Start")
		Else
			log(clsSysMst.logLevel.DBG, "rdo033LST010F010_CheckedChanged", "帳票選択変更時（未返却件数:借用者部門×貸出月） Start")
		End If
		Try
			pEvent = Enum_Event.PrintModeSelect
			If rdo.Checked Then
				SetControlStyle(pEvent, Enum_PrintMode.U_DivByMonth)
			End If
		Catch ex As Exception
			ErrorProc(ex)
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' 帳票選択変更時（未返却件数:貸出目的×貸出月）
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub rdo035LST010F010_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdo035LST010F010.CheckedChanged
		Dim rdo As BT_RadioButton = CType(sender, BT_RadioButton)
		If rdo.Focused = True Then
			log(clsSysMst.logLevel.NRM, "rdo035LST010F010_CheckedChanged", "帳票選択変更時（未返却件数:貸出目的×貸出月） Start")
		Else
			log(clsSysMst.logLevel.DBG, "rdo035LST010F010_CheckedChanged", "帳票選択変更時（未返却件数:貸出目的×貸出月） Start")
		End If
		Try
			pEvent = Enum_Event.PrintModeSelect
			If rdo.Checked Then
				SetControlStyle(pEvent, Enum_PrintMode.U_BorrowerByMonth)
			End If
		Catch ex As Exception
			ErrorProc(ex)
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' 帳票選択変更時（業務量統計）
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub rdo042LST010F010_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdo042LST010F010.CheckedChanged
		Dim rdo As BT_RadioButton = CType(sender, BT_RadioButton)
		If rdo.Focused = True Then
			log(clsSysMst.logLevel.NRM, "rdo042LST010F010_CheckedChanged", "帳票選択変更時（業務量統計） Start")
		Else
			log(clsSysMst.logLevel.DBG, "rdo042LST010F010_CheckedChanged", "帳票選択変更時（業務量統計） Start")
		End If
		Try
			pEvent = Enum_Event.PrintModeSelect
			If rdo.Checked Then
				SetControlStyle(pEvent, Enum_PrintMode.Stat_OnBusiness)
			End If
		Catch ex As Exception
			ErrorProc(ex)
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' 修正ボタンクリック時
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub btn047LST010F010_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn047LST010F010.Click
		log(clsSysMst.logLevel.NRM, "btn047LST010F010_Click", "修正ボタンクリック時 Start")
		Try
			Me.Cursor = Cursors.WaitCursor
			pEvent = Enum_Event.Update
			'コントロール制御
			SetControlStyle(pEvent)
			'修正前の個別設定情報の内容を保持
			Me.datDefinitionBefore = GetIndividualData()
			'シート名コンボのデータも退避
			If Me.cmb065LST010F010.DataSource IsNot Nothing Then
				Me.dtSheetNmCmbData = Nothing
			Else
				Me.dtSheetNmCmbData = CType(Me.cmb065LST010F010.DataSource, DataTable)
			End If
		Catch ex As Exception
			ErrorProc(ex)
		Finally
			Me.Cursor = Cursors.Default
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' 初期化ボタンクリック時
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub btn048LST010F010_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn048LST010F010.Click
		log(clsSysMst.logLevel.NRM, "btn048LST010F010_Click", "初期化ボタンクリック時 Start")
		Try
			Me.Cursor = Cursors.WaitCursor
			pEvent = Enum_Event.Initialize
			'修正前と値が異なる場合の処理続行確認
'(M) STR V4-12053-000 006 2012/12/14 ID 病歴大将V4PKG 管理No.49 確認メッセージ「OK/キャンセル」→「はい/いいえ」に修正
			'If IsDifferentIndivisualData() AndAlso _
			'   confMsg("Q0001", "内容が変更されています。初期化しても", Nothing) = MsgBoxResult.Cancel Then
			If IsDifferentIndivisualData() AndAlso _
			   confMsg("Q0001", "内容が変更されています。初期化しても", Nothing) = MsgBoxResult.No Then
'(M) END V4-12053-000 006 2012/12/14 ID
				Exit Sub
			End If
			'統計定義マスタの取得及びコントロール設定
			SetControlValueFromDefinition(False)
		Catch ex As Exception
			ErrorProc(ex)
		Finally
			Me.Cursor = Cursors.Default
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' 保存ボタンクリック時
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub btn049LST010F010_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn049LST010F010.Click
		log(clsSysMst.logLevel.NRM, "btn049LST010F010_Click", "保存ボタンクリック時 Start")
		Try
			Me.Cursor = Cursors.WaitCursor
			pEvent = Enum_Event.Save
			' コントロール値確定
			If Not Me.ValidateChildren() Then
				Exit Sub
			End If
			'個別設定情報のチェック
			If Not ChkIndividualData() Then
				'エラー画面へ
				nextErrForm()
				Exit Sub
			End If
			'保存処理
			If Not UpdStatisticsDefinition() Then
				showMsg("E0013", "保存", Nothing)
				Exit Sub
			End If
			'コントロール制御
			SetControlStyle(pEvent)
		Catch ex As Exception
			ErrorProc(ex)
		Finally
			Me.Cursor = Cursors.Default
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' 取消ボタンクリック時
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub btn050LST010F010_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn050LST010F010.Click
		log(clsSysMst.logLevel.NRM, "btn050LST010F010_Click", "取消ボタンクリック時 Start")
		Try
			Me.Cursor = Cursors.WaitCursor
			pEvent = Enum_Event.Cancel
			'修正前と値が異なる場合の処理続行確認
'(M) STR V4-12053-000 006 2012/12/14 ID 病歴大将V4PKG 管理No.49 確認メッセージ「OK/キャンセル」→「はい/いいえ」に修正
			'If IsDifferentIndivisualData() AndAlso _
			'   confMsg("Q0001", "内容が変更されています。取消しても", Nothing) = MsgBoxResult.Cancel Then
			If IsDifferentIndivisualData() AndAlso _
			   confMsg("Q0001", "内容が変更されています。取消しても", Nothing) = MsgBoxResult.No Then
'(M) END V4-12053-000 006 2012/12/14 ID
				Exit Sub
			End If
			'コントロール制御
			SetControlStyle(pEvent)
		Catch ex As Exception
			ErrorProc(ex)
		Finally
			Me.Cursor = Cursors.Default
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' テンプレートファイルダイアログクリック時
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub btn063LST010F010_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn063LST010F010.Click
		log(clsSysMst.logLevel.NRM, "btn063LST010F010_Click", "テンプレートファイルダイアログクリック時 Start")
		Try
			Me.Cursor = Cursors.WaitCursor
			Dim sGetPath As String = Me.cliCom.getFilePath( _
			 cliLST010F010.GetFileNmForStatistics(Me, Me.txt062LST010F010.Text, True), _
			 clsCom.Enum_FileDialogType.eExcelBookOrTemplate)
			If Not String.IsNullOrEmpty(sGetPath) Then
				If sGetPath.Length > Me.txt062LST010F010.MaxLength Then
					showMsg("E0027")
				Else
					Me.txt062LST010F010.Text = cliLST010F010.GetFileNmForStatistics(Me, sGetPath, False)
					'シート名のコンボを設定
					SetSheetCombo(cliLST010F010.GetFileNmForStatistics(Me, Me.txt062LST010F010.Text, True))
				End If
			End If
		Catch ex As Exception
			ErrorProc(ex)
		Finally
			Me.Cursor = Cursors.Default
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' テンプレートファイル名検証後
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub txt062LST010F010_Validated(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt062LST010F010.Validated
		If CType(sender, BT_TextBox).CanFocus = True Then
			log(clsSysMst.logLevel.NRM, "txt062LST010F010_Validated", "テンプレートファイル名検証後 Start")
		Else
			log(clsSysMst.logLevel.DBG, "txt062LST010F010_Validated", "テンプレートファイル名検証後 Start")
		End If
		Try
			If pEvent = Enum_Event.Update Then
				'修正ボタンクリック時のみコンボ設定を行う（妥当性チェックについては保存・プレビュー等ボタンクリック時に行う）
				'シート名のコンボを設定
				If Not SetSheetCombo(cliLST010F010.GetFileNmForStatistics(Me, Me.txt062LST010F010.Text, True)) Then
					CType(sender, BT_TextBox).Focus()
				End If
			End If
		Catch ex As Exception
			ErrorProc(ex)
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' プレビューボタンクリック時
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub btn004LST000F010_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn004LST000F010.Click
		log(clsSysMst.logLevel.NRM, "btn004LST000F010_Click", "プレビューボタンクリック時 Start")
		Try
			'チェック
			If Not ChkPrintCondition() Then
				Exit Sub
			End If
			Me.Cursor = Cursors.WaitCursor
			'実行中メッセージ表示
			Me.tsl002frmBase.Text = CST_MSG_EXEC_PREVIEW
			Application.DoEvents()
			Dim bComplete As Boolean
			'統計データ取得
			bComplete = GetStatisticsData()
			If bComplete Then
				'Excel出力（プレビュー）
				bComplete = PutExcel(Me.cliTate, False)
			End If
		Catch ex As Exception
			ErrorProc(ex)
		Finally
			Me.tsl002frmBase.Text = Nothing
			Me.Cursor = Cursors.Default
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' 印刷ボタンクリック時
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub btn005LST000F010_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn005LST000F010.Click
		log(clsSysMst.logLevel.NRM, "btn005LST000F010_Click", "印刷ボタンクリック時 Start")
		Try
			'チェック
			If Not ChkPrintCondition() Then
				Exit Sub
			End If
			Me.Cursor = Cursors.WaitCursor
			'実行中メッセージ表示
			Me.tsl002frmBase.Text = CST_MSG_EXEC_PRINT
			Application.DoEvents()
			Dim bComplete As Boolean
			'統計データ取得
			bComplete = GetStatisticsData()
			If bComplete Then
				'Excel出力（印刷）
				bComplete = PutExcel(Me.cliTate, True)
				If bComplete Then
					cliExcelFunc.putCompleateMsg(True)
				End If
			End If
		Catch ex As Exception
			ErrorProc(ex)
		Finally
			Me.tsl002frmBase.Text = Nothing
			Me.Cursor = Cursors.Default
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' EXCELボタンクリック時
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub btn006LST000F010_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn006LST000F010.Click
		log(clsSysMst.logLevel.NRM, "btn006LST000F010_Click", "EXCELボタンクリック時 Start")
		Try
			'チェック
			If Not ChkPrintCondition() Then
				Exit Sub
			End If
			Me.Cursor = Cursors.WaitCursor
			'実行中メッセージ表示
			Me.tsl002frmBase.Text = CST_MSG_EXEC_EXCEL
			Application.DoEvents()
			Dim bComplete As Boolean
			'統計データ取得
			bComplete = GetStatisticsData()
			If bComplete Then
				'各種情報をパラメータ情報に設定
				Me.cliLST010F010.SetVariousInfo(Me, pRepZeroChr, True)
				'Excel出力
				Using eLST020E010 As New LST020E010(Me)
					bComplete = eLST020E010.ExePutExcel(Me.cliLST010F010.pPrmShtData, Me.cliTate, Me.txt062LST010F010.Text, Me.cmb065LST010F010.Text)
					If bComplete Then
						cliExcelFunc.putCompleateMsg(False)
					End If
				End Using
			End If
		Catch ex As Exception
			ErrorProc(ex)
		Finally
			Me.tsl002frmBase.Text = Nothing
			Me.Cursor = Cursors.Default
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' CSV出力ボタンクリック時
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub btn007LST000F010_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn007LST000F010.Click
		log(clsSysMst.logLevel.NRM, "btn007LST000F010_Click", "CSV出力ボタンクリック時 Start")
		Try
			'チェック
			If Not ChkPrintCondition() Then
				Exit Sub
			End If
			Me.Cursor = Cursors.WaitCursor
			'実行中メッセージ表示
			Me.tsl002frmBase.Text = CST_MSG_EXEC_CSV
			Application.DoEvents()
			'出力先フォルダの取得
			Dim sCsvPath As String = cliCom.getFolderPath(cliCom.getTokeCsvFolder())
			If String.IsNullOrEmpty(sCsvPath) Then
				Me.tsl002frmBase.Text = Nothing
				Exit Sub
			End If
			Dim sCsvFileNm As String = GetFileNmForCSV()
			Dim bComplete As Boolean
			Dim dtCsvData As New DataTable
			'統計データ取得(CSV)
			bComplete = GetStatisticsDataForCsv(dtCsvData)
			If bComplete Then
				'CSV出力
				bComplete = PutCSV(sCsvPath, sCsvFileNm, dtCsvData)
			End If
			If dtCsvData IsNot Nothing Then dtCsvData.Dispose()
			dtCsvData = Nothing
		Catch ex As Exception
			ErrorProc(ex)
		Finally
			Me.tsl002frmBase.Text = Nothing
			Me.Cursor = Cursors.Default
		End Try
	End Sub

'(A) STR V4-14047-000 024 20130812 ID)平井(貸出管理レベルアップ２次開発　大規模病院への対応　グループ検索)
	''' ---------------------------------------------
	''' <summary>
	''' 管理物ボタンクリック
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2013/08/12 新規作成　ID)平井<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub btn66LST010F010_Click(sender As System.Object, e As System.EventArgs) Handles btn66LST010F010.Click
		CType(Me.TopLevelControl, frmBase).log(clsSysMst.logLevel.NRM, "btn66LST010F010_Click", "管理物ボタンクリックイベント")
		Try
			Me.Cursor = Cursors.WaitCursor
'(M) STR V4-15007-000 004 2014/03/03 ID)鐘井 貸出管理レベルアップ４次開発　共通管理物の対応
'			frmXSP240F010 = New XSP240F010
			frmXSP240F010 = New XSP240F010(False)
'(M) END V4-15007-000 004 2014/03/03 ID)鐘井 貸出管理レベルアップ４次開発　共通管理物の対応
			CType(Me.TopLevelControl, frmBase).nextForm(frmXSP240F010)
		Catch ex As Exception
			CType(Me.TopLevelControl, frmBase).ErrorProc(ex)
		Finally
			Me.Cursor = Cursors.Default
		End Try
	End Sub
'(A) END V4-14047-000 024 20130812

#End Region

#Region "メソッド"

	''' ---------------------------------------------
	''' <summary>
	''' コントロールスタイル設定
	''' </summary>
	''' <param name="eventType">事象の型</param>
	''' <param name="printType">帳票種類</param>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub SetControlStyle(ByVal eventType As Enum_Event, Optional ByVal printType As Enum_PrintMode = Enum_PrintMode.None)
		log(clsSysMst.logLevel.DBG, "SetControlStyle", "コントロールスタイル設定 Start")
		Try
			'ヘッダ部
			Me.btn004LST000F010.Enabled = True
			Me.btn005LST000F010.Enabled = True
			Me.btn006LST000F010.Enabled = True
			Me.btn007LST000F010.Enabled = True
			Me.btn008LST000F010.Enabled = True
			'グループ１
			Me.cmb003LST010F010.Enabled = True
			Me.dte007LST010F010.Enabled = True
			Me.dte009LST010F010.Enabled = True
			Me.chk011LST010F010.Enabled = True
			Me.rdo021LST010F010.Enabled = True
			Me.rdo023LST010F010.Enabled = True
			Me.rdo033LST010F010.Enabled = True
			Me.rdo035LST010F010.Enabled = True
			'グループ２
			Me.dte039LST010F010.Enabled = True
			Me.dte041LST010F010.Enabled = True
			Me.rdo042LST010F010.Enabled = True
			'個別設定
			If cliXTM_USER.getAuthority(clsXTM_USER.Enum_Authority.DETI_L_Toukei) Then
				'統計個別設定使用可
				Me.btn047LST010F010.Enabled = True
			Else
				'統計個別設定使用不可
				Me.btn047LST010F010.Enabled = False
			End If
			Me.btn048LST010F010.Enabled = True
			Me.btn049LST010F010.Enabled = True
			Me.btn050LST010F010.Enabled = True
			Me.txt051LST010F010.Enabled = True
			Me.cmb053LST010F010.Enabled = True
			Me.cmb056LST010F010.Enabled = True
			Me.cmb059LST010F010.Enabled = True
			Me.txt062LST010F010.Enabled = True
			Me.btn063LST010F010.Enabled = True
			Me.cmb065LST010F010.Enabled = True
			Select Case eventType
				Case Enum_Event.Initialize
					'初期設定時
					'ヘッダ部
					Me.btn004LST000F010.Enabled = False
					Me.btn005LST000F010.Enabled = False
					Me.btn006LST000F010.Enabled = False
					Me.btn007LST000F010.Enabled = False
					'個別設定
					Me.btn047LST010F010.Enabled = False
					Me.btn048LST010F010.Enabled = False
					Me.btn049LST010F010.Enabled = False
					Me.btn050LST010F010.Enabled = False
					Me.txt051LST010F010.Enabled = False
					Me.cmb053LST010F010.Enabled = False
					Me.cmb056LST010F010.Enabled = False
					Me.cmb059LST010F010.Enabled = False
					Me.txt062LST010F010.Enabled = False
					Me.btn063LST010F010.Enabled = False
					Me.cmb065LST010F010.Enabled = False
					'帳票選択のクリア
					ClearRadioButton(Me.tlp012LST010F010)
					ClearRadioButton(Me.tlp025LST010F010)
					Me.rdo042LST010F010.Checked = False
					'印刷モード
					pPrintMode = Enum_PrintMode.None

				Case Enum_Event.PrintModeSelect
					'帳票選択ラジオボタンクリック時
					'個別設定
					Me.btn048LST010F010.Enabled = False
					Me.btn049LST010F010.Enabled = False
					Me.btn050LST010F010.Enabled = False
					Me.txt051LST010F010.Enabled = False
					Me.cmb053LST010F010.Enabled = False
					Me.cmb056LST010F010.Enabled = False
					Me.cmb059LST010F010.Enabled = False
					Me.txt062LST010F010.Enabled = False
					Me.btn063LST010F010.Enabled = False
					Me.cmb065LST010F010.Enabled = False
					'印刷モード
					pPrintMode = printType
					'帳票種類に対する表示制御
					Select Case printType
						Case Enum_PrintMode.L_DivByPurpose
							'表示設定
							ClearRadioButton(Me.tlp025LST010F010)
							Me.lbl044LST010F010.Text = Me.lbl020LST010F010.Text
							Me.lbl046LST010F010.Text = Me.lbl019LST010F010.Text
							Me.rdo042LST010F010.Checked = False
							Me.rdo042LST010F010.Checked = False
						Case Enum_PrintMode.L_PurposeByMonth
							'表示設定
							ClearRadioButton(Me.tlp025LST010F010)
							Me.lbl044LST010F010.Text = Me.lbl022LST010F010.Text
							Me.lbl046LST010F010.Text = Me.lbl018LST010F010.Text
							Me.rdo042LST010F010.Checked = False
							Me.rdo042LST010F010.Checked = False
						Case Enum_PrintMode.U_DivByMonth
							'表示設定
							ClearRadioButton(Me.tlp012LST010F010)
							Me.lbl044LST010F010.Text = Me.lbl032LST010F010.Text
							Me.lbl046LST010F010.Text = Me.lbl031LST010F010.Text
							Me.rdo042LST010F010.Checked = False
						Case Enum_PrintMode.U_BorrowerByMonth
							'表示設定
							ClearRadioButton(Me.tlp012LST010F010)
							Me.lbl044LST010F010.Text = Me.lbl034LST010F010.Text
							Me.lbl046LST010F010.Text = Me.lbl031LST010F010.Text
							Me.rdo042LST010F010.Checked = False
						Case Enum_PrintMode.Stat_OnBusiness
							'表示設定
							ClearRadioButton(Me.tlp012LST010F010)
							ClearRadioButton(Me.tlp025LST010F010)
							Me.lbl044LST010F010.Text = Me.rdo042LST010F010.Text
							Me.lbl046LST010F010.Text = Nothing
						Case Else
							'未選択
							'印刷モード
							pPrintMode = Enum_PrintMode.None
							'表示設定
							Me.lbl044LST010F010.Text = Nothing
							Me.lbl046LST010F010.Text = Nothing
					End Select
					'統計定義マスタの取得及びコントロール設定
					If pPrintMode <> Enum_PrintMode.None Then
						SetControlValueFromDefinition(True)
					End If
				Case Enum_Event.Update
					'修正ボタンクリック時
					'ヘッダ部
					Me.btn004LST000F010.Enabled = False
					Me.btn005LST000F010.Enabled = False
					Me.btn006LST000F010.Enabled = False
					Me.btn007LST000F010.Enabled = False
					Me.btn008LST000F010.Enabled = False
					'グループ１
					Me.cmb003LST010F010.Enabled = False
					Me.dte007LST010F010.Enabled = False
					Me.dte009LST010F010.Enabled = False
					Me.chk011LST010F010.Enabled = False
					Me.rdo021LST010F010.Enabled = False
					Me.rdo023LST010F010.Enabled = False
					Me.rdo033LST010F010.Enabled = False
					Me.rdo035LST010F010.Enabled = False
					'グループ２
					Me.dte039LST010F010.Enabled = False
					Me.dte041LST010F010.Enabled = False
					Me.rdo042LST010F010.Enabled = False
					'個別設定
					Me.btn047LST010F010.Enabled = False
				Case Enum_Event.Cancel
					'取消ボタンクリック時
					'個別設定
					Me.btn048LST010F010.Enabled = False
					Me.btn049LST010F010.Enabled = False
					Me.btn050LST010F010.Enabled = False
					Me.txt051LST010F010.Enabled = False
					Me.cmb053LST010F010.Enabled = False
					Me.cmb056LST010F010.Enabled = False
					Me.cmb059LST010F010.Enabled = False
					Me.txt062LST010F010.Enabled = False
					Me.btn063LST010F010.Enabled = False
					Me.cmb065LST010F010.Enabled = False
					'統計定義マスタの取得及びコントロール設定（変更前データより取得）
					Me.cmb065LST010F010.DataSource = Me.dtSheetNmCmbData
					With datDefinitionBefore
						Me.txt051LST010F010.Text = .LEDGERSHEET_TITLE
						Me.cmb053LST010F010.Text = .ZEROLINE_DSP
						Me.cmb056LST010F010.Text = .RNM_DSP
						Me.cmb059LST010F010.Text = .DSPORDER
						Me.txt062LST010F010.Text = .FILE_NM
						Me.cmb065LST010F010.Text = .SHEET_NM
					End With
				Case Else
					'保存ボタンクリック時
					'個別設定
					Me.btn048LST010F010.Enabled = False
					Me.btn049LST010F010.Enabled = False
					Me.btn050LST010F010.Enabled = False
					Me.txt051LST010F010.Enabled = False
					Me.cmb053LST010F010.Enabled = False
					Me.cmb056LST010F010.Enabled = False
					Me.cmb059LST010F010.Enabled = False
					Me.txt062LST010F010.Enabled = False
					Me.btn063LST010F010.Enabled = False
					Me.cmb065LST010F010.Enabled = False
			End Select
			'業務量統計ラジオボタン選択時、CSV出力(T)を使用不可にする
			If Me.rdo042LST010F010.Checked Then
				btn007LST000F010.Enabled = False
			End If
		Catch ex As Exception
			Throw
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' 表選択クリア
	''' </summary>
	''' <param name="tlp">表</param>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub ClearRadioButton(ByVal tlp As TableLayoutPanel)
		log(clsSysMst.logLevel.DBG, "ClearRadioButton", "表選択クリア Start")
		Try
			For Each ctl As Control In tlp.Controls
				If TypeOf ctl Is BT_RadioButton Then
					CType(ctl, BT_RadioButton).Checked = False
				End If
			Next
			Me.lbl044LST010F010.Text = Nothing
			Me.lbl046LST010F010.Text = Nothing
		Catch ex As Exception
			Throw
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' 統計定義マスタ取得及びコントロール設定処理
	''' </summary>
	''' <param name="pbPriorToDefault">初期値より保存値を優先する(True:優先する、False:優先しない)</param>
	''' <returns>処理結果(True:正常、False:エラーメッセージあり)</returns>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Function SetControlValueFromDefinition(ByVal pbPriorToDefault As Boolean) As Boolean
		log(clsSysMst.logLevel.DBG, "SetControlValueFromDefinition", "統計定義マスタ取得及びコントロール設定処理 Start")
		Dim bResult As Boolean
		Dim arData As ArrayList = Nothing
		Dim datDefault As datLST010F010_STATISTICS_DEFINITION = Nothing
		Dim datSave As datLST010F010_STATISTICS_DEFINITION = Nothing
		Try
			'コントロールの初期値設定
			With Me.datDefinitionSave
				Me.txt051LST010F010.Text = Nothing
				Me.cmb053LST010F010.Text = CInt(clsConst.Enum_DspZeroRow.NonDsp).ToString
				Me.cmb056LST010F010.Text = CInt(clsConst.Enum_DspZeroRow.Dsp).ToString
				Me.cmb059LST010F010.Text = CInt(clsConst.Enum_ImpDspOrder.Dsp).ToString
				Me.txt062LST010F010.Text = Nothing
				Me.cmb065LST010F010.DataSource = Nothing
				Me.cmb065LST010F010.setDropDownWidth()
			End With
			Dim prefixDefCd As String
			'印刷モードより検索用の定義コードを設定
			prefixDefCd = PrefixDefinitionCd(CInt(pPrintMode))
			'データを取得
			arData = GetStatisticsDefinition(prefixDefCd)
			datDefault = New datLST010F010_STATISTICS_DEFINITION
			datSave = New datLST010F010_STATISTICS_DEFINITION
			Dim bExistDefaultData As Boolean = False
			Dim bExistSaveData As Boolean = False
			If arData.Count > 0 Then
				For i As Integer = 0 To arData.Count - 1
					If CType(arData(i), datLST010F010_STATISTICS_DEFINITION).DEFINITION_CD.ToString.EndsWith(sqlLST010F010.CST_ENDING_LEND_DEFAULT) Then
						datDefault = CType(arData(i), datLST010F010_STATISTICS_DEFINITION)
						bExistDefaultData = True
					ElseIf CType(arData(i), datLST010F010_STATISTICS_DEFINITION).DEFINITION_CD.ToString.EndsWith(sqlLST010F010.CST_ENDING_LEND_SAVE) Then
						datSave = CType(arData(i), datLST010F010_STATISTICS_DEFINITION)
						bExistSaveData = True
					End If
				Next
			End If
			If (pbPriorToDefault AndAlso (Not bExistDefaultData And Not bExistSaveData)) OrElse _
			  (Not pbPriorToDefault AndAlso Not bExistDefaultData) Then
				'保存値優先で統計定義が１件もない場合、あるいは、保存値優先でなく統計定義の初期値がない場合はエラー
				'データが取得できない場合はエラー
				showMsg("E0015", "統計定義マスタ", Nothing)
				bResult = False
				Return bResult
			End If
			'統計定義情報の確定
			If pbPriorToDefault AndAlso bExistSaveData Then
				Me.datDefinitionSave = datSave
			Else
				Me.datDefinitionSave = datDefault
			End If
			'シート名の候補取得
			If SetSheetCombo(cliLST010F010.GetFileNmForStatistics(Me, Me.datDefinitionSave.FILE_NM, True)) = False Then
				bResult = False
				Return bResult
			End If
			'コントロールの値設定
			With Me.datDefinitionSave
				Me.txt051LST010F010.Text = .LEDGERSHEET_TITLE
				Me.cmb053LST010F010.Text = .ZEROLINE_DSP
				Me.cmb056LST010F010.Text = .RNM_DSP
				Me.cmb059LST010F010.Text = .DSPORDER
				Me.txt062LST010F010.Text = .FILE_NM
				Me.cmb065LST010F010.Text = .SHEET_NM
			End With
		Catch ex As Exception
			Throw
		Finally
			arData = Nothing
			datDefault = Nothing
			datSave = Nothing
		End Try
		Return bResult
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' シート名設定処理
	''' </summary>
	''' <param name="pFilename">ファイル名</param>
	''' <returns>処理結果(True:正常、False:エラーメッセージあり)</returns>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Function SetSheetCombo(ByVal pFilename As String) As Boolean
		log(clsSysMst.logLevel.DBG, "SetSheetCombo", "シート名設定処理 Start")
		Dim bResult As Boolean
		Dim arSheetName As ArrayList = Nothing
		Dim dtCombo As New DataTable
		Dim dtRow As DataRow
		Try
			'チェック処理
			Dim errMsgCd As String = Nothing
			Dim errMsgParm() As String = Nothing
			If Not cliExcelFunc.chkFileName(pFilename, errMsgCd, errMsgParm) Then
				showMsg(errMsgCd, errMsgParm)
				bResult = False
				Return bResult
			End If
			'初期化
			Me.cmb065LST010F010.DataSource = Nothing
			Me.cmb065LST010F010.setDropDownWidth()
			'シート名を取得
			arSheetName = cliExcelFunc.getSheetNames(pFilename)
			'コンボ候補用データテーブルを作成
			'列定義
			dtCombo.Columns.Add(CST_COL_SHEETNM, GetType(String))
			'先頭空白追加
			dtRow = dtCombo.NewRow
			dtRow.Item(0) = String.Empty
			dtCombo.Rows.Add(dtRow)
			'シート名の配列からデータを設定
			For i As Integer = 0 To arSheetName.Count - 1
				dtRow = dtCombo.NewRow
				dtRow.Item(0) = arSheetName(i).ToString
				dtCombo.Rows.Add(dtRow)
			Next
			Me.cmb065LST010F010.DataSource = dtCombo.Copy
			Me.cmb065LST010F010.DisplayMember = CST_COL_SHEETNM
			Me.cmb065LST010F010.ValueMember = CST_COL_SHEETNM
			Me.cmb065LST010F010.setDropDownWidth()
			bResult = True
		Catch ex As Exception
			Throw
		Finally
			dtRow = Nothing
			arSheetName = Nothing
			If dtCombo IsNot Nothing Then dtCombo.Dispose()
			dtCombo = Nothing
		End Try
		Return bResult
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' 個別設定情報取得
	''' </summary>
	''' <param name="pOrigin">元のデータ</param>
	''' <returns>個別設定情報（統計定義データ形式）</returns>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Function GetIndividualData(Optional ByVal pOrigin As datLST010F010_STATISTICS_DEFINITION = Nothing) As datLST010F010_STATISTICS_DEFINITION
		log(clsSysMst.logLevel.DBG, "GetIndividualData", "個別設定情報取得 Start")
		Dim datResult As New datLST010F010_STATISTICS_DEFINITION
		Try
			If pOrigin Is Nothing Then
				'印刷モードより定義コードを設定
				datResult.DEFINITION_CD = CDbl(PrefixDefinitionCd(CInt(pPrintMode)) & sqlLST010F010.CST_ENDING_LEND_SAVE)
			Else
				datResult = pOrigin
			End If
			'個別設定情報からコントロール値を取得
			With datResult
				.LEDGERSHEET_TITLE = Me.txt051LST010F010.Text
				.ZEROLINE_DSP = Me.cmb053LST010F010.Text
				.RNM_DSP = Me.cmb056LST010F010.Text
				.DSPORDER = Me.cmb059LST010F010.Text
				.FILE_NM = Me.txt062LST010F010.Text
				.SHEET_NM = Me.cmb065LST010F010.Text
				.LASTUPDUSER_CD = Me._userID
				.LASTUPD_DT = Now
			End With
		Catch ex As Exception
			Throw
		End Try
		Return datResult
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' 個別設定情報の比較（修正前との相違）
	''' </summary>
	''' <returns>比較結果（True:相違あり、False:相違なし）</returns>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Function IsDifferentIndivisualData() As Boolean
		log(clsSysMst.logLevel.DBG, "IsDifferentIndivisualData", "個別設定情報取得 Start")
		Dim bResult As Boolean = False
		Dim datAfter As datLST010F010_STATISTICS_DEFINITION
		Try
			datAfter = GetIndividualData()
			With datAfter
				If Me.datDefinitionBefore.LEDGERSHEET_TITLE <> .LEDGERSHEET_TITLE OrElse _
				 Me.datDefinitionBefore.ZEROLINE_DSP <> .ZEROLINE_DSP OrElse _
				 Me.datDefinitionBefore.RNM_DSP <> .RNM_DSP OrElse _
				 Me.datDefinitionBefore.DSPORDER <> .DSPORDER OrElse _
				 Me.datDefinitionBefore.FILE_NM <> .FILE_NM OrElse _
				 Me.datDefinitionBefore.SHEET_NM <> .SHEET_NM _
				 Then
					bResult = True
				End If
			End With
		Catch ex As Exception
			Throw
		Finally
			datAfter = Nothing
		End Try
		Return bResult
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' 出力条件のチェック
	''' </summary>
	''' <returns>チェック結果（True:OK、False:NG）</returns>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Function ChkPrintCondition() As Boolean
		log(clsSysMst.logLevel.DBG, "ChkPrintCondition", "出力条件のチェック Start")
		Dim bResult As Boolean = False
		Try
			'日付等のチェック
			Select Case pPrintMode
				Case Enum_PrintMode.Stat_OnBusiness
					'業務量統計の場合
					ChkPrintConditionDate(Me.lbl038LST010F010.Text, Me.lbl037LST010F010.Text, Me.dte039LST010F010, Me.dte041LST010F010)
				Case Else
					'業務量統計以外の場合
					If String.IsNullOrEmpty(Me.cmb003LST010F010.Text) Then
						addErrList("E0001", Me.cmb003LST010F010.Name, Me.lbl002LST010F010.Text, Nothing)
					End If
					ChkPrintConditionDate(Me.lbl006LST010F010.Text, Me.lbl005LST010F010.Text, Me.dte007LST010F010, Me.dte009LST010F010)
			End Select
			'個別設定情報のチェック
			ChkIndividualData()
			If getErrCount() > 0 Then
				'エラー画面へ
				nextErrForm()
				bResult = False
			Else
				bResult = True
			End If
		Catch ex As Exception
			Throw
		End Try
		Return bResult
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' 出力条件（日付）のチェック
	''' </summary>
	''' <param name="pDateText">日付のラベル値</param>
	''' <param name="pIntervalText">対象期間のラベル値</param>
	''' <param name="pDteFrom">日付From</param>
	''' <param name="pDteTo">日付To</param>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub ChkPrintConditionDate(ByVal pDateText As String, ByVal pIntervalText As String, ByRef pDteFrom As BT_Date, ByRef pDteTo As BT_Date)
		log(clsSysMst.logLevel.DBG, "ChkPrintConditionDate", "出力条件（日付）のチェック Start")
		Try
			'日付のチェック
			If pDteFrom.Text = DT_EMPTYDATE Then
				addErrList("E0001", pDteFrom.Name, MSG_PRM_FROM.Replace(REP_STR_DATE, pDateText), Nothing)
			End If
			If pDteTo.Text = DT_EMPTYDATE Then
				addErrList("E0001", pDteTo.Name, MSG_PRM_TO.Replace(REP_STR_DATE, pDateText), Nothing)
			End If
			If Not String.IsNullOrEmpty(pDteFrom.Text) AndAlso Not String.IsNullOrEmpty(pDteTo.Text) Then
				If pDteFrom.DateValue > pDteTo.DateValue Then
					addErrList("E0003", pDteFrom.Name, MSG_PRM_FROM_TO.Replace(REP_STR_DATE, pDateText), _
					  MSG_PRM_DATE_COMP.Replace(REP_STR_DATE, pDateText).Replace(REP_STR_INTERVAL, pIntervalText), "出力", Nothing)
				End If
			End If
		Catch ex As Exception
			Throw
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' 個別設定情報のチェック
	''' </summary>
	''' <returns>比較結果（True:相違あり、False:相違なし）</returns>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Function ChkIndividualData() As Boolean
		log(clsSysMst.logLevel.DBG, "ChkIndividualData", "個別設定情報のチェック Start")
		Dim bResult As Boolean = True
		Try
			'帳票タイトル
			If String.IsNullOrEmpty(Me.txt051LST010F010.Text) Then
				addErrList("E0001", Me.txt051LST010F010.Name, "帳票タイトル", Nothing)
				bResult = False
			End If
			'ゼロ行表示
			If String.IsNullOrEmpty(Me.cmb053LST010F010.Text) Then
				addErrList("E0001", Me.cmb053LST010F010.Name, Me.lbl052LST010F010.Text.Trim, Nothing)
				bResult = False
			End If
			'略称表示
			If String.IsNullOrEmpty(Me.cmb056LST010F010.Text) Then
				addErrList("E0001", Me.cmb056LST010F010.Name, Me.lbl055LST010F010.Text.Trim, Nothing)
				bResult = False
			End If
			'表示順
			If String.IsNullOrEmpty(Me.cmb059LST010F010.Text) Then
				addErrList("E0001", Me.cmb059LST010F010.Name, Me.lbl058LST010F010.Text.Trim, Nothing)
				bResult = False
			End If
			'テンプレートファイル名
			If Not String.IsNullOrEmpty(Me.txt062LST010F010.Text) Then
				Dim errMsgCd As String = Nothing
				Dim errMsgParm() As String = Nothing
				If Not cliExcelFunc.chkFileName(cliLST010F010.GetFileNmForStatistics(Me, Me.txt062LST010F010.Text, True), errMsgCd, errMsgParm) Then
					addErrList(errMsgCd, Me.txt062LST010F010.Name, Me.lbl061LST010F010.Text, errMsgParm)
					bResult = False
				End If
			End If
		Catch ex As Exception
			Throw
		End Try
		Return bResult
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' 統計定義の更新
	''' </summary>
	''' <returns>結果（True:OK、False:NG）</returns>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Function UpdStatisticsDefinition() As Boolean
		log(clsSysMst.logLevel.DBG, "UpdStatisticsDefinition", "統計定義の更新 Start")
		Dim bResult As Boolean = False
		Try
			'更新対象データの設定
			If String.IsNullOrEmpty(Me.datDefinitionSave.DEFINITION_CD.ToString) OrElse Me.datDefinitionSave.DEFINITION_CD = 0 Then
				Me.datDefinitionSave = GetIndividualData()
			Else
				Me.datDefinitionSave = GetIndividualData(Me.datDefinitionSave)
			End If
			Me.datDefinitionSave.DEFINITION_CD = CDbl(PrefixDefinitionCd(CInt(pPrintMode)) & sqlLST010F010.CST_ENDING_LEND_SAVE)

			If UpdStatisticsDefinition(Me.datDefinitionSave) Then
				bResult = True
			Else
				bResult = False
			End If
		Catch ex As Exception
			Throw
		End Try
		Return bResult
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' 統計データ取得
	''' </summary>
	''' <returns>結果（True:OK、False:NG）</returns>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Function GetStatisticsData() As Boolean
		log(clsSysMst.logLevel.DBG, "GetStatisticsData", "統計データ取得 Start")
		Dim bResult As Boolean = False
		Try
			cliTate = New List(Of clsLST010F010.clsTate)
			cliYoko = New List(Of clsLST010F010.clsYoko)
			'横軸配列の作成
			If CreateArrayYoko() Then
				'縦軸配列の作成
				If CreateArrayTate() Then
					'データを取得し縦軸配列に件数を設定
					If SetCountToTate() Then
						bResult = True
					End If
				End If
			End If
		Catch ex As Exception
			Throw
		End Try
		Return bResult
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' 貸出目的の取得
	''' </summary>
	''' <param name="pbDspAbbreviatedNm">略称表示の制御有無</param>
	''' <returns>データテーブル</returns>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Function GetLendAim(ByVal pbDspAbbreviatedNm As Boolean) As DataTable
		log(clsSysMst.logLevel.DBG, "GetLendAim", "貸出目的の取得 Start")
		Dim dtResult As DataTable = Nothing
		Try
			dtResult = New DataTable
			'列定義
			dtResult.Columns.Add(sqlLTM_LENDAIM.itmLENDAIM_CD, GetType(String))
			dtResult.Columns.Add(sqlLTM_LENDAIM.itmLENDAIM_NM, GetType(String))
			dtResult.Rows.Clear()
			' 略称表示による取得項目の制御
			Dim setItemNm As String
			If pbDspAbbreviatedNm AndAlso Me.cmb056LST010F010.Text = CInt(clsConst.Enum_DspZeroRow.Dsp).ToString Then
				setItemNm = sqlLTM_LENDAIM.itmLENDAIM_RNM
			Else
				setItemNm = sqlLTM_LENDAIM.itmLENDAIM_NM
			End If
			'データの取得
			Using dt As DataTable = cliLTM_LENDAIM.getLendAimList
				If dt IsNot Nothing AndAlso dt.Rows.Count > 0 Then
					Dim row As DataRow
					Using dv As DataView = dt.DefaultView
						'表示順がコード順の場合はソート
						If cmb059LST010F010.Text = CInt(clsConst.Enum_ImpDspOrder.Cd) Then
							dv.Sort = sqlLTM_LENDAIM.itmLENDAIM_CD
						End If
						For Each drv As DataRowView In dv
							row = dtResult.NewRow
							row.Item(sqlLTM_LENDAIM.itmLENDAIM_CD) = drv.Item(sqlLTM_LENDAIM.itmLENDAIM_CD).ToString
							row.Item(sqlLTM_LENDAIM.itmLENDAIM_NM) = drv.Item(setItemNm).ToString
							dtResult.Rows.Add(row)
						Next
					End Using
				Else
					'データがないときはエラー
					showMsg("E0015", "貸出目的マスタ", Nothing)
					dtResult.Rows.Clear()
				End If
			End Using
		Catch ex As Exception
			Throw
		End Try
		Return dtResult
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' 管理物コードの取得
	''' </summary>
	''' <returns>データテーブル</returns>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Function GetMngItem() As DataTable
		log(clsSysMst.logLevel.DBG, "GetMngItem", "管理物コードの取得 Start")
		Dim dtResult As DataTable = Nothing
		Try
			dtResult = New DataTable
			'列定義
			dtResult.Columns.Add(sqlLTM_MNGITEM.itmMNGITEM_CD, GetType(String))
			dtResult.Columns.Add(sqlLST010F010.itmMNGITEM_NM, GetType(String))
			dtResult.Rows.Clear()
			' 略称表示による取得項目の制御
			Dim setItemNm As String
			If Me.cmb056LST010F010.Text = CInt(clsConst.Enum_DspZeroRow.Dsp).ToString Then
				setItemNm = sqlLST010F010.itmMNGITEM_RNM
			Else
				setItemNm = sqlLST010F010.itmMNGITEM_NM
			End If
			'データの取得
			Using dt As DataTable = cliLTM_MNGITEM.getMngItemList
				If dt IsNot Nothing AndAlso dt.Rows.Count > 0 Then
					Dim row As DataRow
					Using dv As DataView = dt.DefaultView
						'表示順がコード順の場合はコード順でソート
						If cmb059LST010F010.Text = CInt(clsConst.Enum_ImpDspOrder.Cd) Then
							dv.Sort = sqlLTM_MNGITEM.itmMNGITEM_CD
						Else
							dv.Sort = sqlLST010F010.itmDSPORDER & CST_STR_COMMA & sqlLTM_MNGITEM.itmMNGITEM_CD
						End If
						For Each drv As DataRowView In dv
							row = dtResult.NewRow
							row.Item(sqlLTM_MNGITEM.itmMNGITEM_CD) = drv.Item(sqlLTM_MNGITEM.itmMNGITEM_CD).ToString
							row.Item(sqlLST010F010.itmMNGITEM_NM) = drv.Item(setItemNm).ToString
							dtResult.Rows.Add(row)
						Next
					End Using
				Else
					'データがないときはエラー
					showMsg("E0015", "管理物マスタ", Nothing)
					dtResult.Rows.Clear()
				End If
			End Using
		Catch ex As Exception
			Throw
		End Try
		Return dtResult
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' 借用者部門の取得
	''' </summary>
	''' <returns>データテーブル</returns>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Function GetBorrowerDiv() As DataTable
		log(clsSysMst.logLevel.DBG, "GetBorrowerDiv", "借用者部門の取得 Start")
		Dim dtResult As DataTable = Nothing
		Try
			dtResult = New DataTable
			'列定義
			dtResult.Columns.Add(sqlLST010F010.itmSTAFFDIV_CD, GetType(String))
			dtResult.Columns.Add(sqlLST010F010.itmSTAFFDIV_NM, GetType(String))
			dtResult.Rows.Clear()
			'データの取得
			Using dt As DataTable = cliXTM_STAFFDIV.getAllStaffDiv
				If dt IsNot Nothing AndAlso dt.Rows.Count > 0 Then
					Dim row As DataRow
					Using dv As DataView = dt.DefaultView
						'表示順がコード順の場合はソート
						If cmb059LST010F010.Text = CInt(clsConst.Enum_ImpDspOrder.Cd) Then
							dv.Sort = sqlLST010F010.itmSTAFFDIV_CD
						End If
						For Each drv As DataRowView In dv
							row = dtResult.NewRow
							row.Item(sqlLST010F010.itmSTAFFDIV_CD) = drv.Item(sqlLST010F010.itmSTAFFDIV_CD).ToString
							row.Item(sqlLST010F010.itmSTAFFDIV_NM) = drv.Item(sqlLST010F010.itmSTAFFDIV_NM).ToString
							dtResult.Rows.Add(row)
						Next
					End Using
				Else
					'データがないときはエラー
					showMsg("E0015", "職員部門マスタ", Nothing)
					dtResult.Rows.Clear()
				End If
			End Using
		Catch ex As Exception
			Throw
		End Try
		Return dtResult
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' 職員の取得
	''' </summary>
	''' <returns>データテーブル</returns>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Function GetStaff() As DataTable
		log(clsSysMst.logLevel.DBG, "GetStaff", "職員の取得 Start")
		Dim dtResult As DataTable = Nothing
		Try
			dtResult = New DataTable
			'列定義
			dtResult.Columns.Add(sqlXTM_STAFF.itmSTAFF_CD, GetType(String))
			dtResult.Columns.Add(sqlXTM_STAFF.itmSTAFF_NM, GetType(String))
			dtResult.Rows.Clear()
			'データの取得
			Using dt As DataTable = cliXTM_STAFF.getStaffAllList
				If dt IsNot Nothing AndAlso dt.Rows.Count > 0 Then
					Dim row As DataRow
					Using dv As DataView = dt.DefaultView
						'表示順がコード順の場合はソート
						If cmb059LST010F010.Text = CInt(clsConst.Enum_ImpDspOrder.Cd) Then
							dv.Sort = sqlXTM_STAFF.itmSTAFF_CD
						End If
						For Each drv As DataRowView In dv
							row = dtResult.NewRow
							row.Item(sqlXTM_STAFF.itmSTAFF_CD) = drv.Item(sqlXTM_STAFF.itmSTAFF_CD).ToString
							row.Item(sqlXTM_STAFF.itmSTAFF_NM) = drv.Item(sqlXTM_STAFF.itmSTAFF_NM).ToString
							dtResult.Rows.Add(row)
						Next
					End Using
				Else
					'データがないときはエラー
					showMsg("E0015", "職員マスタ", Nothing)
					dtResult.Rows.Clear()
				End If
			End Using
		Catch ex As Exception
			Throw
		End Try
		Return dtResult
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' 件数を取得（業務量統計以外）
	''' </summary>
	''' <param name="pSql">SQL文</param>
	''' <param name="pbBackDtNull">未返却のみ抽出するか(True:する、False:しない)</param>
	''' <returns></returns>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Function GetCount(ByVal pSql As String, ByVal pbBackDtNull As Boolean) As DataTable
		log(clsSysMst.logLevel.DBG, "GetCount", "件数を取得（業務量統計以外） Start")
		Dim dtData As DataTable = Nothing
		Try
			dtData = New DataTable
			Using db As clsDB = New clsDB(clsSysMst.ctlConfigData)
				Dim sSql As String
				If pbBackDtNull Then
					sSql = pSql
				Else
					'全てが対象の場合は未返却を指定する条件を除去する
					sSql = pSql.Replace(sqlLST010F010.sqlBack_Dt_Null, Nothing)
				End If
				'SELECT文設定
				db.setSQLDa(sSql)
				' 管理物コード
				db.setParamDa(sqlLST010F010.prmMNGITEM_CD, clsDB.Enum_dbType.dbNVarChar)
				db.setValDa(sqlLST010F010.prmMNGITEM_CD, Me.cmb003LST010F010.Text)
				' 貸出日From
				db.setParamDa(sqlLST010F010.prmISSUE_DT_From, clsDB.Enum_dbType.dbDateTime)
				db.setValDa(sqlLST010F010.prmISSUE_DT_From, Me.dte007LST010F010.DateValue)
				' 貸出日To
				db.setParamDa(sqlLST010F010.prmISSUE_DT_To, clsDB.Enum_dbType.dbDateTime)
				db.setValDa(sqlLST010F010.prmISSUE_DT_To, Me.dte009LST010F010.DateValue)
				'値取得
				db.execQueryDa(dtData)
			End Using
		Catch ex As Exception
			Throw
		End Try
		Return dtData
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' 件数を取得（業務量統計用）
	''' </summary>
	''' <param name="pSql">SQL文</param>
	''' <returns></returns>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Function GetCountStatisticsOnBusiness(ByVal pSql As String) As DataTable
		log(clsSysMst.logLevel.DBG, "GetCountStatisticsOnBusiness", "件数を取得（業務量統計用） Start")
		Dim dtData As DataTable = Nothing
		Try
			dtData = New DataTable
			Using db As clsDB = New clsDB(clsSysMst.ctlConfigData)
				'SELECT文設定
				db.setSQLDa(pSql)
				' 基準日From
				db.setParamDa(sqlLST010F010.prmBASE_DT_From, clsDB.Enum_dbType.dbDateTime)
				db.setValDa(sqlLST010F010.prmBASE_DT_From, Me.dte039LST010F010.DateValue)
				' 基準日To
				db.setParamDa(sqlLST010F010.prmBASE_DT_To, clsDB.Enum_dbType.dbDateTime)
				db.setValDa(sqlLST010F010.prmBASE_DT_To, Me.dte041LST010F010.DateValue)
				'値取得
				db.execQueryDa(dtData)
			End Using
		Catch ex As Exception
			Throw
		End Try
		Return dtData
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' Excel作成
	''' </summary>
	''' <param name="cTate">取得データクラス</param>
	''' <param name="pPrintFlg">TRUE:印刷 FALSE:プレビュー</param>
	''' <returns>結果</returns>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Function PutExcel(ByVal cTate As List(Of clsLST010F010.clsTate), ByVal pPrintFlg As Boolean) As Boolean
		log(clsSysMst.logLevel.DBG, "PutExcel", "Excel作成 Start")
		Dim bResult As Boolean = False
		Try
			'各種情報をパラメータ情報に設定
			Me.cliLST010F010.SetVariousInfo(Me, pRepZeroChr, False)
			bResult = cliLST010F010.ExePrint(Me, Me.cliLST010F010.pPrmShtData, cTate, pPrintFlg)
		Catch ex As Exception
			Throw
		End Try
		Return bResult
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' CSV出力先ファイル名取得
	''' </summary>
	''' <returns>ファイル名</returns>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Function GetFileNmForCSV() As String
		log(clsSysMst.logLevel.DBG, "GetFileNmForCSV", "CSV出力先ファイル名取得 Start")
		Dim bResult As String = Nothing
		Try
			bResult = CST_CSV_FILENM.Replace(CST_CSV_TITLE, Me.txt051LST010F010.Text.Trim) _
			 .Replace(CST_CSV_MNGITEM, Me.lbl004LST010F010.Text.Trim).Replace(CST_CSV_DATE, Now.ToString("yyyyMMddHHmmss"))
		Catch ex As Exception
			Throw
		End Try
		Return bResult
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' 統計データ取得（CSV用）
	''' </summary>
	''' <param name="dtCsvData">取得したCSV出力用データ</param>
	''' <returns>結果（True:OK、False:NG）</returns>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Function GetStatisticsDataForCsv(ByRef dtCsvData As DataTable) As Boolean
		log(clsSysMst.logLevel.DBG, "GetStatisticsDataForCsv", "統計データ取得（CSV用） Start")
		Dim bResult As Boolean = False
		Try
			Dim bBackDtNull As Boolean
			Dim sSql As String = sqlLST010F010.sqlSelCSV
			Dim sOrderBy As String = Nothing
			Select Case pPrintMode
				Case Enum_PrintMode.L_DivByPurpose
					bBackDtNull = Me.chk011LST010F010.Checked
					sOrderBy = sqlLST010F010.sqlOrderL_DivByPurpose
				Case Enum_PrintMode.L_PurposeByMonth
					bBackDtNull = Me.chk011LST010F010.Checked
					sOrderBy = sqlLST010F010.sqlOrderL_PurposeByMonth
				Case Enum_PrintMode.U_DivByMonth
					bBackDtNull = True
					sOrderBy = sqlLST010F010.sqlOrderU_DivByMonth
				Case Else
					'借用者×貸出月
					bBackDtNull = True
					sOrderBy = sqlLST010F010.sqlOrderU_BorrowerByMonth
			End Select
			'ORDER BY句を置換
			If cmb059LST010F010.Text = CInt(clsConst.Enum_ImpDspOrder.Cd) Then
				'表示順がコード順の場合は表示順を除去
				sOrderBy = sOrderBy.Replace(sqlLST010F010.sqlOmitDSPORDER_LENDAIM, Nothing) _
				 .Replace(sqlLST010F010.sqlOmitDSPORDER_STAFF, Nothing) _
				 .Replace(sqlLST010F010.sqlOmitDSPORDER_STAFFDIV, Nothing)
			End If
			sSql = sSql.Replace(sqlLST010F010.sqlReplaceOrder, sOrderBy)
			'WHERE句を置換
			If Not bBackDtNull Then
				'全てが対象の場合は未返却を指定する条件を除去
				sSql = sSql.Replace(sqlLST010F010.sqlBack_Dt_Null, Nothing)
			End If
			'データの取得
			Using db As clsDB = New clsDB(clsSysMst.ctlConfigData)
				'SELECT文設定
				db.setSQLDa(sSql)
				' 管理物コード
				db.setParamDa(sqlLST010F010.prmMNGITEM_CD, clsDB.Enum_dbType.dbNVarChar)
				db.setValDa(sqlLST010F010.prmMNGITEM_CD, Me.cmb003LST010F010.Text)
				' 貸出日From
				db.setParamDa(sqlLST010F010.prmISSUE_DT_From, clsDB.Enum_dbType.dbDateTime)
				db.setValDa(sqlLST010F010.prmISSUE_DT_From, Me.dte007LST010F010.DateValue)
				' 貸出日To
				db.setParamDa(sqlLST010F010.prmISSUE_DT_To, clsDB.Enum_dbType.dbDateTime)
				db.setValDa(sqlLST010F010.prmISSUE_DT_To, Me.dte009LST010F010.DateValue)
				'値取得
				db.execQueryDa(dtCsvData)
			End Using
			If dtCsvData IsNot Nothing AndAlso dtCsvData.Rows.Count > 0 Then
				bResult = True
			Else
				showMsg("E0004")
				bResult = False
			End If
		Catch ex As Exception
			Throw
		End Try
		Return bResult
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' CSV出力
	''' </summary>
	''' <param name="pFilePath">出力ディレクトリ</param>
	''' <param name="pFileNm">出力ファイル名</param>
	''' <param name="dtCsvData">CSV出力用データ</param>
	''' <returns>結果</returns>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Function PutCSV(ByVal pFilePath As String, ByVal pFileNm As String, ByVal dtCsvData As DataTable) As Boolean
		log(clsSysMst.logLevel.DBG, "PutCSV", "CSV出力 Start")
		Dim bResult As Boolean = False
		Dim arData As ArrayList = Nothing
		Dim arDataDetails As ArrayList = Nothing
		Try
			arData = New ArrayList
			'出力パスと出力ファイル名を定義して、CSVクラスをインスタンス化
			Using cliCSV As New clsCSV(pFileNm, pFilePath)
				If cliCSV.chkFileFind Then
					'結果ファイル削除
					If cliCSV.chkFileFind Then cliCSV.delFile()
				End If
				'ヘッダ出力
				cliCSV.putCSV(Split(CST_CSV_HEADER, CST_STR_COMMA))
				'データ部出力
				For Each pRow As DataRow In dtCsvData.Rows
					'明細インスタンス化
					arDataDetails = New ArrayList
					'明細部出力
					SetDetailToArray(pRow, arDataDetails)
					'メインにAdd
					arData.Add(arDataDetails.Clone)
					'解放
					arDataDetails.Clear()
					arDataDetails = Nothing
				Next
				'明細出力
				cliCSV.putCSV_Array(arData)
				'完了メッセージ
				showMsg("I0006", "CSV出力", "出力場所：" & cliCSV.getCSVPutPath)
				bResult = True
			End Using
		Catch ex As Exception
			Throw
		Finally
			If arData IsNot Nothing Then arData.Clear()
			If arDataDetails IsNot Nothing Then arDataDetails.Clear()
			arData = Nothing
			arDataDetails = Nothing
		End Try
		Return bResult
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' 明細を配列に設定
	''' </summary>
	''' <param name="pDataRow">明細行データ</param>
	''' <param name="pArData">配列</param>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub SetDetailToArray(ByVal pDataRow As DataRow, ByRef pArData As ArrayList)
		log(clsSysMst.logLevel.DBG, "SetDetailToArray", "明細を配列に設定 Start")
		Try
			'出力項目をADDする
			With pDataRow
				'共通項目
				For idx As Integer = 0 To csvCommon.Length - 1
					pArData.Add(ConvComma(.Item(csvCommon(idx)).ToString))
				Next
				'帳票種類別個別項目
				Select Case pPrintMode
					Case Enum_PrintMode.L_DivByPurpose
						For idx As Integer = 0 To csv_L_DivByPurpose.Length - 1
							'横軸略称対応
							If Me.cmb056LST010F010.Text = CInt(clsConst.Enum_DspZeroRow.Dsp).ToString AndAlso csvCommon(idx) = sqlLST010F010.itmLENDAIM_NM Then
								pArData.Add(ConvComma(.Item(sqlLST010F010.itmLENDAIM_RNM).ToString))
							Else
								pArData.Add(ConvComma(.Item(csv_L_DivByPurpose(idx)).ToString))
							End If
						Next
					Case Enum_PrintMode.L_PurposeByMonth
						For idx As Integer = 0 To csv_L_PurposeByMonth.Length - 1
							pArData.Add(ConvComma(.Item(csv_L_PurposeByMonth(idx)).ToString))
						Next
					Case Enum_PrintMode.U_DivByMonth
						For idx As Integer = 0 To csv_U_DivByMonth.Length - 1
							pArData.Add(ConvComma(.Item(csv_U_DivByMonth(idx)).ToString))
						Next
					Case Else
						'借用者×貸出月
						For idx As Integer = 0 To csv_U_BorrowerByMonth.Length - 1
							pArData.Add(ConvComma(.Item(csv_U_BorrowerByMonth(idx)).ToString))
						Next
				End Select
			End With
		Catch ex As Exception
			Throw
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' カンマをアンダーバーに変更
	''' </summary>
	''' <param name="pPrevString">変換前文字列</param>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Function ConvComma(ByVal pPrevString As String) As String
		log(clsSysMst.logLevel.DBG, "ConvComma", "カンマをアンダーバーに変更 Start")
		Dim retString As String = Nothing
		Try
			retString = pPrevString.Replace(CST_STR_COMMA, CST_STR_UNDERBAR)
		Catch ex As Exception
			Throw
		End Try
		Return retString
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' 統計定義を取得
	''' </summary>
	''' <param name="pDefinitionCd_Prefix">定義コード（下２桁を除く）</param>
	''' <returns>取得結果</returns>
	''' <remarks>
	''' 2010/10/07 新規作成 CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Function GetStatisticsDefinition(ByVal pDefinitionCd_Prefix As String) As ArrayList
		log(clsSysMst.logLevel.DBG, "GetStatisticsDefinition", "統計定義を取得 Start")
		Dim arData As ArrayList = Nothing
		Try
			arData = New ArrayList(0)
			Using db As clsDB = New clsDB(clsSysMst.ctlConfigData)
				'SELECT文設定
				db.setSQL(sqlLST010F010.sqlSel_Definition_ForLend)
				'パラメータ（デフォルト値）
				db.setParam(sqlLST010F010.prmDEFINITION_CD_DEF, clsDB.Enum_dbType.dbNumeric)
				db.setVal(sqlLST010F010.prmDEFINITION_CD_DEF, _
				   CDbl(pDefinitionCd_Prefix & sqlLST010F010.CST_ENDING_LEND_DEFAULT))
				'パラメータ（保存値）
				db.setParam(sqlLST010F010.prmDEFINITION_CD_SAV, clsDB.Enum_dbType.dbNumeric)
				db.setVal(sqlLST010F010.prmDEFINITION_CD_SAV, _
				   CDbl(pDefinitionCd_Prefix & sqlLST010F010.CST_ENDING_LEND_SAVE))
				'値取得
				db.execQuery(GetType(datLST010F010_STATISTICS_DEFINITION), arData)
			End Using
			Return arData
		Catch ex As Exception
			Throw
		End Try
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' 統計定義の追加・更新
	''' </summary>
	''' <param name="pDat">統計定義データクラス</param>
	''' <returns>更新結果（True:更新成功、False:更新失敗）</returns>
	''' <remarks>
	''' 2010/10/07 新規作成 CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Function UpdStatisticsDefinition(ByVal pDat As datLST010F010_STATISTICS_DEFINITION) As Boolean
		log(clsSysMst.logLevel.DBG, "UpdStatisticsDefinition", "統計定義の追加・更新 Start")
		Dim bResult As Boolean
		Dim iGetCount As Integer = 0
		Dim iRet As Integer
		Dim bUpdError As Boolean = False
		Try
			' テーブルの更新（追加）
			Using db As clsDB = New clsDB(clsSysMst.ctlConfigData)
				With db
					.ctlTran(clsDB.Enum_TranMode.Begin)
					Try
						'更新前参照
						Dim arData As New ArrayList
						'SQL文設定
						.setSQL(sqlLST010F010.sqlSel_Definition_Lock)
						'定義コード
						.setParam(sqlLST010F010.prmDEFINITION_CD, clsDB.Enum_dbType.dbNumeric)
						.setVal(sqlLST010F010.prmDEFINITION_CD, pDat.DEFINITION_CD)
						'値取得
						.execQuery(GetType(datLST010F010_STATISTICS_DEFINITION), arData, False)
						If arData IsNot Nothing Then
							iGetCount = arData.Count
							'取得情報のクリア
							arData.Clear()
						End If
						arData = Nothing
						'SQL文の設定
						If iGetCount > 0 Then
							.setSQL(sqlLST010F010.sqlUpd_Definition_ForLend)
						Else
							.setSQL(sqlLST010F010.sqlIns_Definition_ForLend)
						End If
						' 定義コード
						.setParam(sqlLST010F010.prmDEFINITION_CD, clsDB.Enum_dbType.dbNumeric)
						.setVal(sqlLST010F010.prmDEFINITION_CD, pDat.DEFINITION_CD)
						' 帳票タイトル
						.setParam(sqlLST010F010.prmLEDGERSHEET_TITLE, clsDB.Enum_dbType.dbNVarChar)
						.setVal(sqlLST010F010.prmLEDGERSHEET_TITLE, pDat.LEDGERSHEET_TITLE)
						' ファイル名
						.setParam(sqlLST010F010.prmFILE_NM, clsDB.Enum_dbType.dbNVarChar)
						.setVal(sqlLST010F010.prmFILE_NM, pDat.FILE_NM)
						' シート名
						.setParam(sqlLST010F010.prmSHEET_NM, clsDB.Enum_dbType.dbNVarChar)
						.setVal(sqlLST010F010.prmSHEET_NM, pDat.SHEET_NM)
						' 表示順
						.setParam(sqlLST010F010.prmDSPORDER, clsDB.Enum_dbType.dbInt)
						Dim nullFlg As Boolean = False
						If String.IsNullOrEmpty(pDat.DSPORDER) Then
							nullFlg = True
						End If
						.setVal(sqlLST010F010.prmDSPORDER, pDat.DSPORDER, nullFlg)
						' ゼロ行表示
						.setParam(sqlLST010F010.prmZEROLINE_DSP, clsDB.Enum_dbType.dbNVarChar)
						.setVal(sqlLST010F010.prmZEROLINE_DSP, pDat.ZEROLINE_DSP)
						' 略称表示
						.setParam(sqlLST010F010.prmRNM_DSP, clsDB.Enum_dbType.dbNVarChar)
						.setVal(sqlLST010F010.prmRNM_DSP, pDat.RNM_DSP)
						' 更新者コード
						.setParam(sqlLST010F010.prmLASTUPDUSER_CD, clsDB.Enum_dbType.dbNVarChar)
						.setVal(sqlLST010F010.prmLASTUPDUSER_CD, pDat.LASTUPDUSER_CD)
						' 更新日
						.setParam(sqlLST010F010.prmLASTUPD_DT, clsDB.Enum_dbType.dbDateTime)
						.setVal(sqlLST010F010.prmLASTUPD_DT, pDat.LASTUPD_DT)
						iRet = .execNonQuery(False)
						If iRet <> 1 Then
							bUpdError = True
						End If
						If bUpdError Then
							db.ctlTran(clsDB.Enum_TranMode.RollBack)
							bResult = False
						Else
							db.ctlTran(clsDB.Enum_TranMode.Commit)
							bResult = True
						End If
					Catch ex As Exception
						If db.statTran() Then db.ctlTran(clsDB.Enum_TranMode.RollBack)
						Throw
					End Try
				End With
			End Using
		Catch ex As Exception
			Throw
		End Try
		Return bResult
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' 横軸作成
	''' </summary>
	''' <returns>結果</returns>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Function CreateArrayYoko() As Boolean
		log(clsSysMst.logLevel.DBG, "CreateArrayYoko", "横軸作成 Start")
		Dim bResult As Boolean = False
		Try
			'横軸の列数
			pCntYoko = 0
			'総数列の作成
			If pPrintMode = Enum_PrintMode.Stat_OnBusiness Then
				'業務量統計
				cliYoko.Add(New clsLST010F010.clsYoko(CST_TATEYOKO_KEY_ADD, CST_TATEYOKO_KEY_TOTAL, CST_TATEYOKO_NM_TOTAL, CST_INT_ZERO))
				cliYoko.Add(New clsLST010F010.clsYoko(CST_TATEYOKO_KEY_LEND, CST_TATEYOKO_KEY_TOTAL, CST_TATEYOKO_NM_TOTAL, CST_INT_ZERO))
				cliYoko.Add(New clsLST010F010.clsYoko(CST_TATEYOKO_KEY_RETURN, CST_TATEYOKO_KEY_TOTAL, CST_TATEYOKO_NM_TOTAL, CST_INT_ZERO))
				pCntYoko += 3
			Else
				cliYoko.Add(New clsLST010F010.clsYoko(CST_TATEYOKO_KEY_TOTAL, Nothing, CST_TATEYOKO_NM_TOTAL, CST_INT_ZERO))
				pCntYoko += 1
			End If
			'データ列の作成
			Select Case pPrintMode
				Case Enum_PrintMode.L_DivByPurpose
					'借用者部門・貸出目的
					'貸出目的を取得（データがない場合はエラー）
					Using dt As DataTable = GetLendAim(True)
						If dt IsNot Nothing AndAlso dt.Rows.Count > 0 Then
							'該当なし列を追加
							cliYoko.Add(New clsLST010F010.clsYoko(CST_TATEYOKO_KEY_NONE, Nothing, CST_TATEYOKO_NM_NONE, CST_INT_ZERO))
							pCntYoko += 1
							'貸出目的コード列を追加
							For Each row As DataRow In dt.Rows
								cliYoko.Add(New clsLST010F010.clsYoko(row(sqlLTM_LENDAIM.itmLENDAIM_CD), Nothing, row(sqlLTM_LENDAIM.itmLENDAIM_NM), CST_INT_ZERO))
								pCntYoko += 1
							Next
						Else
							'データがないときはエラー
							bResult = False
							Return bResult
						End If
					End Using
				Case Enum_PrintMode.Stat_OnBusiness
					'業務量統計
					'管理物を取得（データがない場合はエラー）
					Using dt As DataTable = GetMngItem()
						If dt IsNot Nothing AndAlso dt.Rows.Count > 0 Then
							'該当なし列を追加
							cliYoko.Add(New clsLST010F010.clsYoko(CST_TATEYOKO_KEY_ADD, CST_TATEYOKO_KEY_NONE, CST_TATEYOKO_NM_NONE, CST_INT_ZERO))
							cliYoko.Add(New clsLST010F010.clsYoko(CST_TATEYOKO_KEY_LEND, CST_TATEYOKO_KEY_NONE, CST_TATEYOKO_NM_NONE, CST_INT_ZERO))
							cliYoko.Add(New clsLST010F010.clsYoko(CST_TATEYOKO_KEY_RETURN, CST_TATEYOKO_KEY_NONE, CST_TATEYOKO_NM_NONE, CST_INT_ZERO))
							pCntYoko += 3
							'貸出物コード列を追加
							For Each row As DataRow In dt.Rows
								cliYoko.Add(New clsLST010F010.clsYoko(CST_TATEYOKO_KEY_ADD, row(sqlLTM_MNGITEM.itmMNGITEM_CD), row(sqlLST010F010.itmMNGITEM_NM), CST_INT_ZERO))
								cliYoko.Add(New clsLST010F010.clsYoko(CST_TATEYOKO_KEY_LEND, row(sqlLTM_MNGITEM.itmMNGITEM_CD), row(sqlLST010F010.itmMNGITEM_NM), CST_INT_ZERO))
								cliYoko.Add(New clsLST010F010.clsYoko(CST_TATEYOKO_KEY_RETURN, row(sqlLTM_MNGITEM.itmMNGITEM_CD), row(sqlLST010F010.itmMNGITEM_NM), CST_INT_ZERO))
								pCntYoko += 3
							Next
						Else
							'データがないときはエラー
							bResult = False
							Return bResult
						End If
					End Using
				Case Else
					'貸出日の開始～終了までの年月で列を作成する
					Dim endYM As String = dte009LST010F010.DateValue.ToString(CST_FMT_YYYYMM)
					Dim sDate As Date = DateSerial(dte007LST010F010.DateValue.Year, dte007LST010F010.DateValue.Month, 1)
					Dim sYM As String = sDate.ToString(CST_FMT_YYYYMM)
					Do Until sYM > endYM
						cliYoko.Add(New clsLST010F010.clsYoko(sYM, Nothing, sDate.ToString(CST_FMT_YYYYMM_AddSlash), CST_INT_ZERO))
						pCntYoko += 1
						sDate = DateAdd(DateInterval.Month, 1, sDate)
						sYM = sDate.ToString(CST_FMT_YYYYMM)
					Loop
			End Select
			bResult = True
		Catch ex As Exception
			Throw
		End Try
		Return bResult
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' 縦軸作成
	''' </summary>
	''' <returns>結果</returns>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Function CreateArrayTate() As Boolean
		log(clsSysMst.logLevel.DBG, "CreateArrayTate", "縦軸作成 Start")
		Dim bResult As Boolean = False
		Try
			'縦軸の列数
			pCntTate = 0
			'総数列の作成
			cliTate.Add(New clsLST010F010.clsTate(CST_TATEYOKO_KEY_TOTAL, CST_TATEYOKO_NM_TOTAL, cliYoko))
			pCntTate += 1
			'該当なし列の作成
			cliTate.Add(New clsLST010F010.clsTate(CST_TATEYOKO_KEY_NONE, CST_TATEYOKO_NM_NONE, cliYoko))
			pCntTate += 1
			'データ列の作成
			Select Case pPrintMode
				Case Enum_PrintMode.L_DivByPurpose, Enum_PrintMode.U_DivByMonth
					'借用者部門・貸出目的 or 借用者部門・貸出月
					'借用者部門を取得（データがない場合はエラー）
					Using dt As DataTable = GetBorrowerDiv()
						If dt IsNot Nothing AndAlso dt.Rows.Count > 0 Then
							'借用者部門コード列を追加
							For Each row As DataRow In dt.Rows
								cliTate.Add(New clsLST010F010.clsTate(row(sqlLST010F010.itmSTAFFDIV_CD), row(sqlLST010F010.itmSTAFFDIV_NM), cliYoko))
								pCntTate += 1
							Next
						Else
							'データがないときはエラー
							bResult = False
							Return bResult
						End If
					End Using
				Case Enum_PrintMode.L_PurposeByMonth
					'貸出目的・貸出月
					'貸出目的を取得（データがない場合はエラー）
					Using dt As DataTable = GetLendAim(False)
						If dt IsNot Nothing AndAlso dt.Rows.Count > 0 Then
							'貸出目的コード列を追加
							For Each row As DataRow In dt.Rows
								cliTate.Add(New clsLST010F010.clsTate(row(sqlLTM_LENDAIM.itmLENDAIM_CD), row(sqlLTM_LENDAIM.itmLENDAIM_NM), cliYoko))
								pCntTate += 1
							Next
						Else
							'データがないときはエラー
							bResult = False
							Return bResult
						End If
					End Using
				Case Else
					'借用者・貸出月 or 業務量統計
					'職員を取得（データがない場合はエラー）
					Using dt As DataTable = GetStaff()
						If dt IsNot Nothing AndAlso dt.Rows.Count > 0 Then
							'職員コード列を追加
							For Each row As DataRow In dt.Rows
								cliTate.Add(New clsLST010F010.clsTate(row(sqlXTM_STAFF.itmSTAFF_CD), row(sqlXTM_STAFF.itmSTAFF_NM), cliYoko))
								pCntTate += 1
							Next
						Else
							'データがないときはエラー
							bResult = False
							Return bResult
						End If
					End Using
			End Select
			bResult = True
		Catch ex As Exception
			Throw
		End Try
		Return bResult
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' 件数を縦軸に設定
	''' </summary>
	''' <returns>結果</returns>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Function SetCountToTate() As Boolean
		log(clsSysMst.logLevel.DBG, "SetCountToTate", "件数を縦軸に設定 Start")
		Dim bResult As Boolean = False
		Try
			Dim dtCount As DataTable = Nothing
			Dim dtAdd As DataTable = Nothing
			Dim dtLend As DataTable = Nothing
			Dim dtReturn As DataTable = Nothing
			Dim iRecCount As Integer
			Dim sKeyItemNm_Yoko As String
			Dim sKeyItemNm_Tate As String
			'データを取得
			Select Case pPrintMode
				Case Enum_PrintMode.L_DivByPurpose
					dtCount = GetCount(sqlLST010F010.sqlSel_L_DivByPurpose, Me.chk011LST010F010.Checked)
					iRecCount = dtCount.Rows.Count
					sKeyItemNm_Yoko = sqlLST010F010.itmLENDAIM_CD
					sKeyItemNm_Tate = sqlLST010F010.itmSTAFFDIV_CD
				Case Enum_PrintMode.L_PurposeByMonth
					dtCount = GetCount(sqlLST010F010.sqlSel_L_PurposeByMonth, Me.chk011LST010F010.Checked)
					iRecCount = dtCount.Rows.Count
					sKeyItemNm_Yoko = sqlLST010F010.itmISSUE_DT_YM
					sKeyItemNm_Tate = sqlLST010F010.itmLENDAIM_CD
				Case Enum_PrintMode.U_DivByMonth
					dtCount = GetCount(sqlLST010F010.sqlSel_U_DivByMonth, True)
					iRecCount = dtCount.Rows.Count
					sKeyItemNm_Yoko = sqlLST010F010.itmISSUE_DT_YM
					sKeyItemNm_Tate = sqlLST010F010.itmSTAFFDIV_CD
				Case Enum_PrintMode.U_BorrowerByMonth
					dtCount = GetCount(sqlLST010F010.sqlSel_U_BorrowerByMonth, True)
					iRecCount = dtCount.Rows.Count
					sKeyItemNm_Yoko = sqlLST010F010.itmISSUE_DT_YM
					sKeyItemNm_Tate = sqlLST010F010.itmBORROWER_CD
				Case Enum_PrintMode.Stat_OnBusiness
					dtAdd = GetCountStatisticsOnBusiness(sqlLST010F010.sqlSel_Stat_OnBusiness_Add)
					dtLend = GetCountStatisticsOnBusiness(sqlLST010F010.sqlSel_Stat_OnBusiness_Lend)
					dtReturn = GetCountStatisticsOnBusiness(sqlLST010F010.sqlSel_Stat_OnBusiness_Return)
					iRecCount = dtAdd.Rows.Count + dtLend.Rows.Count + dtReturn.Rows.Count
					sKeyItemNm_Yoko = sqlLST010F010.itmMNGITEM_CD
					sKeyItemNm_Tate = sqlLST010F010.itmSTAFF_CD
				Case Else
					iRecCount = 0
					sKeyItemNm_Yoko = Nothing
					sKeyItemNm_Tate = Nothing
			End Select
			Dim bErr As Boolean = False
			If iRecCount > 0 Then
				'縦横キーによる値設定
				If pPrintMode <> Enum_PrintMode.Stat_OnBusiness Then
					'業務量統計以外の場合
					For Each rowData As DataRow In dtCount.Rows
						If Not SetCountToTateYoko(rowData(sKeyItemNm_Tate).ToString, rowData(sKeyItemNm_Yoko).ToString, Nothing, CLng(rowData(sqlLST010F010.itmCOUNT).ToString)) Then
							bErr = True
							Exit For
						End If
					Next
				Else
					'業務量統計の場合
					'新規作成
					For Each rowData As DataRow In dtAdd.Rows
						If Not SetCountToTateYoko(rowData(sKeyItemNm_Tate).ToString, CST_TATEYOKO_KEY_ADD, rowData(sKeyItemNm_Yoko).ToString, CLng(rowData(sqlLST010F010.itmCOUNT).ToString)) Then
							bErr = True
							Exit For
						End If
					Next
					'貸出
					If Not bErr Then
						For Each rowData As DataRow In dtLend.Rows
							If Not SetCountToTateYoko(rowData(sKeyItemNm_Tate).ToString, CST_TATEYOKO_KEY_LEND, rowData(sKeyItemNm_Yoko).ToString, CLng(rowData(sqlLST010F010.itmCOUNT).ToString)) Then
								bErr = True
								Exit For
							End If
						Next
					End If
					'返却
					If Not bErr Then
						For Each rowData As DataRow In dtReturn.Rows
							If Not SetCountToTateYoko(rowData(sKeyItemNm_Tate).ToString, CST_TATEYOKO_KEY_RETURN, rowData(sKeyItemNm_Yoko).ToString, CLng(rowData(sqlLST010F010.itmCOUNT).ToString)) Then
								bErr = True
								Exit For
							End If
						Next
					End If
				End If
				'ゼロ行表示＝しないの場合、ゼロ行を削除
				If Me.cmb053LST010F010.Text = CInt(clsConst.Enum_DspZeroRow.NonDsp).ToString Then
					Dim bAddOk As Boolean
					Dim cPutTate = New List(Of clsTate)
					For i As Integer = 0 To cliTate.Count - 1
						bAddOk = False
						With cliTate(i)
							If pPrintMode = Enum_PrintMode.Stat_OnBusiness Then
								If .LstYokoData(cliLST010F010.GetYokoFindIndex(.LstYokoData, CST_TATEYOKO_KEY_ADD, CST_TATEYOKO_KEY_TOTAL)).YokoValue > 0 OrElse _
								 .LstYokoData(cliLST010F010.GetYokoFindIndex(.LstYokoData, CST_TATEYOKO_KEY_LEND, CST_TATEYOKO_KEY_TOTAL)).YokoValue > 0 OrElse _
								 .LstYokoData(cliLST010F010.GetYokoFindIndex(.LstYokoData, CST_TATEYOKO_KEY_RETURN, CST_TATEYOKO_KEY_TOTAL)).YokoValue > 0 Then
									bAddOk = True
								End If
							Else
								If .LstYokoData(cliLST010F010.GetYokoFindIndex(.LstYokoData, CST_TATEYOKO_KEY_TOTAL, Nothing)).YokoValue > 0 Then
									bAddOk = True
								End If
							End If
						End With
						If bAddOk Then
							cPutTate.Add(cliTate(i))
						End If
					Next
					cliTate = cPutTate
					iRecCount = cliTate.Count
				End If
			End If
			'取得件数がゼロ、またはゼロ行非表示でゼロの場合
			If iRecCount = 0 Then
				showMsg("E0004")
				bErr = True
			End If
			If Not bErr Then
				bResult = True
			Else
				bResult = False
			End If
			If dtCount IsNot Nothing Then dtCount.Dispose()
			If dtAdd IsNot Nothing Then dtAdd.Dispose()
			If dtLend IsNot Nothing Then dtLend.Dispose()
			If dtReturn IsNot Nothing Then dtReturn.Dispose()
			dtCount = Nothing
			dtAdd = Nothing
			dtLend = Nothing
			dtReturn = Nothing
		Catch ex As Exception
			Throw
		End Try
		Return bResult
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' 件数を縦横配列に設定
	''' </summary>
	''' <param name="pTate">縦キー名</param>
	''' <param name="pYoko1">横キー名(1)</param>
	''' <param name="pYoko2">横キー名(2)</param>
	''' <param name="pCnt">件数</param>
	''' <returns>結果</returns>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Function SetCountToTateYoko(ByVal pTate As String, ByVal pYoko1 As String, ByVal pYoko2 As String, ByVal pCnt As Integer) As Boolean
		log(clsSysMst.logLevel.DBG, "SetCountToTateYoko", "件数を縦横配列に設定 Start")
		Dim bResult As Boolean = False
		Try
			Dim sTotal_Tate As String
			sTotal_Tate = CST_TATEYOKO_KEY_TOTAL
			Dim sTotal_Yoko1 As String
			Dim sTotal_Yoko2 As String
			If String.IsNullOrEmpty(pYoko2) Then
				sTotal_Yoko1 = CST_TATEYOKO_KEY_TOTAL
				sTotal_Yoko2 = Nothing
			Else
				sTotal_Yoko1 = pYoko1
				sTotal_Yoko2 = CST_TATEYOKO_KEY_TOTAL
			End If
			'個別
			If Not SetTateYoko(pTate, pYoko1, pYoko2, pCnt) Then
				Return bResult
			End If
			'縦軸総計
			If Not SetTateYoko(pTate, sTotal_Yoko1, sTotal_Yoko2, pCnt) Then
				Return bResult
			End If
			'横軸総計
			If Not SetTateYoko(sTotal_Tate, pYoko1, pYoko2, pCnt) Then
				Return bResult
			End If
			'総計
			If Not SetTateYoko(sTotal_Tate, sTotal_Yoko1, sTotal_Yoko2, pCnt) Then
				Return bResult
			End If
			bResult = True
		Catch ex As Exception
			Throw
		End Try
		Return bResult
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' 縦横配列の設定
	''' </summary>
	''' <param name="pTate">縦キー名</param>
	''' <param name="pYoko1">横キー名(1)</param>
	''' <param name="pYoko2">横キー名(2)</param>
	''' <param name="pCnt">件数</param>
	''' <returns>結果</returns>
	''' <remarks>
	''' 2010/10/07 新規作成　CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Function SetTateYoko(ByVal pTate As String, ByVal pYoko1 As String, ByVal pYoko2 As String, ByVal pCnt As Integer) As Boolean
		log(clsSysMst.logLevel.DBG, "SetTateYoko", "縦横配列の設定 Start")
		Dim bResult As Boolean = False
		Dim sFindKey_Tate As String
		Dim sFindKey_Yoko1 As String
		Dim sFindKey_Yoko2 As String
		Dim iTate As Integer
		Dim iYoko As Integer
		Try
			'縦軸にあるかどうか検索
			sFindKey_Tate = pTate
			iTate = cliLST010F010.GetTateFindIndex(cliTate, sFindKey_Tate)
			If iTate < 0 Then
				'取得できない場合は「該当なし」
				sFindKey_Tate = CST_TATEYOKO_KEY_NONE
				iTate = cliLST010F010.GetTateFindIndex(cliTate, sFindKey_Tate)
			End If
			'横軸にあるかどうか検索
			sFindKey_Yoko1 = pYoko1
			sFindKey_Yoko2 = pYoko2
			iYoko = cliLST010F010.GetYokoFindIndex(cliYoko, sFindKey_Yoko1, sFindKey_Yoko2)
			If iYoko < 0 Then
				'取得できない場合は「該当なし」
				If String.IsNullOrEmpty(pYoko2) Then
					sFindKey_Yoko1 = CST_TATEYOKO_KEY_NONE
					sFindKey_Yoko2 = Nothing
				Else
					sFindKey_Yoko1 = pYoko1
					sFindKey_Yoko2 = CST_TATEYOKO_KEY_NONE
				End If
				iYoko = cliLST010F010.GetYokoFindIndex(cliYoko, sFindKey_Yoko1, sFindKey_Yoko2)
			End If
			'件数を加算
			cliTate(iTate).LstYokoData(iYoko).YokoValue += pCnt
			bResult = True
		Catch ex As Exception
			Throw
		End Try
		Return bResult
	End Function

'(A) STR V4-14047-000 021 2013/11/14 ID)鐘井 貸出管理レベルアップ２次開発　大規模病院への対応　グループ検索
    '''---------------------------------------------
    ''' <summary>
    ''' '管理物グループ検索
    ''' </summary>
    ''' <remarks>
    ''' 2013/11/14 新規作成　ID)鐘井<BR/>
    ''' </remarks>
    '''---------------------------------------------
    Private Sub SearchMNGITEM_GRP()
        log(clsSysMst.logLevel.DBG, "SearchMNGITEM_GRP", "管理物グループ検索 Start")
        Try
            '管理物グループ検索
            frmXSP240F010 = Nothing
'(M) STR V4-15007-000 004 2014/03/03 ID)鐘井 貸出管理レベルアップ４次開発　共通管理物の対応
'			frmXSP240F010 = New XSP240F010()
			frmXSP240F010 = New XSP240F010(False)
'(M) END V4-15007-000 004 2014/03/03 ID)鐘井 貸出管理レベルアップ４次開発　共通管理物の対応
			nextForm(frmXSP240F010)
        Catch ex As Exception
            Throw
        End Try
    End Sub
'(A) END V4-14047-000 021 2013/11/14 ID)鐘井 貸出管理レベルアップ２次開発　大規模病院への対応　グループ検索

#End Region

#Region "オーバーライドメソッド"

	''' ---------------------------------------------
	''' <summary>
	''' ファンクションキーイベント
	''' </summary>
	''' <param name="msg"></param>
	''' <param name="KeyData"></param>
	''' <returns></returns>
	''' <remarks>
	''' 2010/10/07 新規作成 CS)松本<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Protected Overrides Function ProcessCmdKey(ByRef msg As Message, ByVal KeyData As Keys) As Boolean
		log(clsSysMst.logLevel.DBG, "ProcessCmdKey", "ファンクションキーイベント Start")
		Try
			Const WM_KEYDOWN As Integer = &H100
			' KEYDOWN時
			If msg.Msg = WM_KEYDOWN Then
				Dim key As Keys = KeyData And Keys.KeyCode
				' Shift+Enter(Shift+Tab) または Enter(Tab) の場合　
				If KeyData.Equals(Keys.Enter Or Keys.Shift) OrElse KeyData.Equals(Keys.Tab Or Keys.Shift) Then
					' 前のコントロールへフォーカス移動
					' ※グループ内またはグループ間のRadioButtonコントロール移動を制御
					Select Case True
						Case Me.rdo021LST010F010.Focused
							Me.chk011LST010F010.Focus()
							Me.Show()
						Case Me.rdo023LST010F010.Focused
							Me.rdo021LST010F010.Focus()
							Me.Show()
						Case Me.rdo033LST010F010.Focused
							Me.rdo023LST010F010.Focus()
							Me.Show()
						Case Me.rdo035LST010F010.Focused
							Me.rdo033LST010F010.Focus()
							Me.Show()
						Case Me.dte039LST010F010.Focused
							Me.rdo035LST010F010.Focus()
							Me.Show()
						Case Me.rdo042LST010F010.Focused
							Me.dte041LST010F010.Focus()
							Me.Show()
						Case Else
							Return ShiftEnterProc()
					End Select
					Return True
				ElseIf key = Keys.Enter OrElse key = Keys.Tab Then
					' 次のコントロールへフォーカス移動
					' Buttonコントロールはスキップ
					If TypeOf Me.ActiveControl Is Button OrElse TypeOf Me.ActiveControl Is BT_Button Then
						Return False
					Else
						' ※グループ内またはグループ間のRadioButtonコントロール移動を制御
						Select Case True
							Case Me.chk011LST010F010.Focused
								Me.rdo021LST010F010.Focus()
								Me.Show()
							Case Me.rdo021LST010F010.Focused
								Me.rdo023LST010F010.Focus()
								Me.Show()
							Case Me.rdo023LST010F010.Focused
								Me.rdo033LST010F010.Focus()
								Me.Show()
							Case Me.rdo033LST010F010.Focused
								Me.rdo035LST010F010.Focus()
								Me.Show()
							Case Me.rdo035LST010F010.Focused
								Me.dte039LST010F010.Focus()
								Me.Show()
							Case Me.dte041LST010F010.Focused
								Me.rdo042LST010F010.Focus()
								Me.Show()
							Case Else
								Return EnterProc()
						End Select
						Return True
					End If
				End If
			End If
			Return MyBase.ProcessCmdKey(msg, KeyData)
		Catch ex As Exception
			Me.ErrorProc(ex)
		End Try
	End Function

'(A) STR V4-14047-000 030 20130812 ID)平井(貸出管理レベルアップ２次開発　大規模病院への対応　グループ検索)
	''' ---------------------------------------------
	''' <summary>
	''' 子画面処理後の処理
	''' </summary>
	''' <param name="ret"></param>
	''' <param name="de"></param>
	''' <remarks>
	''' 2013/08/12 新規作成　ID)平井<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Overrides Sub rcvData(ret As XCM.frmBase.Enum_FormReturn, de As System.Collections.DictionaryEntry)
		CType(Me.TopLevelControl, frmBase).log(clsSysMst.logLevel.DBG, "rcvData", "子画面処理後の処理")
		Dim cliCom As clsCom
		Try
			cliCom = New clsCom
			Select Case de.Key.ToString
				Case C_XSP240F010_ID
					If ret = frmBase.Enum_FormReturn.OK Then
						cliCom.setComboValue(Me.cmb003LST010F010, de.Value)
'(A) STR V4-14047-000 003 2013/11/14 ID)鐘井(貸出管理レベルアップ２次開発　大規模病院への対応　グループ検索)
                        Me.cmb003LST010F010.Focus()
'(A) END V4-14047-000 003 2013/11/14 ID)鐘井(貸出管理レベルアップ２次開発　大規模病院への対応　グループ検索)
                    End If
			End Select
			MyBase.rcvData(ret, de)
		Catch ex As Exception
			Throw
		Finally
			cliCom = Nothing
		End Try
	End Sub
'(A) END V4-14047-000 030 20130812

'(A) STR V4-14047-000 021 2013/11/14 ID)鐘井 貸出管理レベルアップ２次開発　大規模病院への対応　グループ検索
    '''---------------------------------------------
    ''' <summary>
    ''' F1処理
    ''' </summary>
    ''' <remarks>
    ''' 2013/11/14 新規作成 ID)鐘井<BR/>
    ''' </remarks>
    '''---------------------------------------------
    Public Overrides Function F1KeyProc() As Boolean
        log(clsSysMst.logLevel.NRM, "F1KeyProc", "Ｆ１キー押下処理 Start")
        Try
            MyBase.F1KeyProc()
            '管理物グループ検索
            If Me.ActiveControl.Name = Me.cmb003LST010F010.Name Then Me.SearchMNGITEM_GRP()
        Catch ex As Exception
            Throw
        End Try
        Return True
    End Function
'(A) END V4-14047-000 021 2013/11/14 ID)鐘井 貸出管理レベルアップ２次開発　大規模病院への対応　グループ検索

#End Region

End Class
