﻿Imports XCM

'''---------------------------------------------
''' <summary>
''' 診療情報管理 補助 診療圏変更
''' </summary>
''' <remarks>
''' Copyright 2010 FUJITSU SHIKOKU SYSTEMS LIMITED All rights reserved.<BR/>
''' FUJITSU SHIKOKU SYSTEMS LIMITED CONFIDENTIAL<BR/>
''' </remarks>
'''---------------------------------------------
Public Class MAX070F010

#Region "コンスタント"

	Private Enum Enum_PRCID As Integer
		PRCID_SEL = 1								'検索
		PRCID_UPD = 2								'更新
	End Enum

	Private Enum Enum_SQLID As Integer
		SQLID_SEL = 1								'検索
		SQLID_UPD = 2								'更新
'(A) STR V4-11007-000 003 20110809 FJSK)荒川 XXX号 病歴大将V4PKG問題点No1 一括更新⇔登録機能での排他チェック仕様変更対応
		SQLID_CHK = 3								'排他用検索
'(A) END V4-11007-000 003 20110809
	End Enum

#End Region

#Region "変数"

	Private dtMTI_CH As New DataTable				'データ保持用
	'EXCELヘッダ
	Private excelHeader() As String = {"患者番号", "入退院歴番号", "科歴番号", clsSysMst.ctlEnvData.getEnv(datEnv.Enum_ENV.ENV_00001), _
									   "氏名", "開始日", "終了日", "診療科名", "診療圏コード", "診療圏名", "郵便番号", "住所"}

#End Region

#Region "イベント"

	'''---------------------------------------------
	''' <summary>
	''' 診療圏変更画面＿初期設定
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/10/28 新規作成 ACS)福士
	''' </remarks>
	'''---------------------------------------------
	Private Sub MAX070F010_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
		Me.log(XCM.clsSysMst.logLevel.NRM, "MAX070F010_Load", "診療圏変更画面＿初期設定 Start")
		Dim cliComboCom As XSP.clsComboCom	'コンボボックス設定用
		Dim dat As DataTable = Nothing
		Try
			cliComboCom = New XSP.clsComboCom

			'診療圏コンボ設定
			Using db As New XCM.clsDB(XCM.clsSysMst.ctlConfigData)
				dat = cliComboCom.getCombo(db, XSP.clsComboCom.Enum_ComboType.Enum_M_Area)
			End Using

			Me.cmb005MAX070F010.DataSource = dat.Copy
			Me.cmb005MAX070F010.setDropDownWidth()

			Me.cmb024MAX070F010.DataSource = dat.Copy
			Me.cmb024MAX070F010.setDropDownWidth()

			Me.rdo007MAX070F010.Checked = True
			Me.rdo004MAX070F010.Checked = True
			Me.cmb005MAX070F010.Select()
		Catch ex As Exception
			Me.ErrorProc(ex)
			Me.CancelProc()
		Finally
			If dat IsNot Nothing Then dat.Dispose()
			dat = Nothing
			cliComboCom = Nothing
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' 診療圏変更画面＿閉じる
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/10/28 新規作成 ACS)福士
	''' </remarks>
	'''---------------------------------------------
	Private Sub MAX070F010_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
		Me.log(XCM.clsSysMst.logLevel.NRM, "MAX070F010_FormClosing", "診療圏変更画面＿閉じる Start")
		Try
			Me.FormClosingProc()
		Catch ex As Exception
			Me.ErrorProc(ex)
		Finally
			'メモリ解放
			Me.dtMTI_CH = Nothing
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' クリアボタンクリック
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/10/28 新規作成 ACS)福士
	''' </remarks>
	'''---------------------------------------------
	Protected Overrides Sub btn005MAX000F010_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn005MAX000F010.Click
		Me.log(XCM.clsSysMst.logLevel.NRM, "btn005MAX000F010_Click", "クリアボタンクリック Start")
		Try
			Me.Cursor = Cursors.WaitCursor
			'画面初期化処理
			Me.ClearInput()
		Catch ex As Exception
			Me.ErrorProc(ex)
		Finally
			Me.Cursor = Cursors.Default
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' 検索ボタンクリック
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/10/28 新規作成 ACS)福士
	''' </remarks>
	'''---------------------------------------------
	Private Sub btn016MAX070F010_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn016MAX070F010.Click
		Me.log(XCM.clsSysMst.logLevel.NRM, "btn016MAX070F010_Click", "検索ボタンクリック Start")
		Try
			Me.Cursor = Cursors.WaitCursor
			'検索処理
			Me.SelProc()
		Catch ex As Exception
			Me.ErrorProc(ex)
		Finally
			Me.Cursor = Cursors.Default
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' Excelボタンクリック
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/10/28 新規作成 ACS)福士
	''' </remarks>
	'''---------------------------------------------
	Private Sub btn021MAX070F010_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn021MAX070F010.Click
		Me.log(XCM.clsSysMst.logLevel.NRM, "btn021MAX070F010_Click", "Excelボタンクリック Start")
		Try
			Me.Cursor = Cursors.WaitCursor
			'Excelブック出力処理
			Me.SetExcel()
		Catch ex As Exception
			Me.ErrorProc(ex)
		Finally
			Me.Cursor = Cursors.Default
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' 変更ボタンクリック
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/10/28 新規作成 ACS)福士
	''' </remarks>
	'''---------------------------------------------
	Private Sub btn026MAX070F010_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn026MAX070F010.Click
		Me.log(XCM.clsSysMst.logLevel.NRM, "btn026MAX070F010_Click", "変更ボタンクリック Start")
		Try
			Me.Cursor = Cursors.WaitCursor
			'変更処理
			Me.UpdProc()
		Catch ex As Exception
			Me.ErrorProc(ex)
		Finally
			Me.Cursor = Cursors.Default
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' 診療圏ラジオボタンクリック
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/10/28 新規作成 ACS)福士
	''' </remarks>
	'''---------------------------------------------
	Private Sub rdo004MAX070F010_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdo004MAX070F010.Click
		Me.log(XCM.clsSysMst.logLevel.NRM, "rdo004MAX070F010_Click", "診療圏ラジオボタンクリック Start")
		Try
			'入力項目クリア
			Me.msk008MAX070F010.Text = Nothing
			Me.msk010MAX070F010.Text = Nothing
		Catch ex As Exception
			Me.ErrorProc(ex)
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' 郵便番号ラジオボタンクリック
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/10/28 新規作成 ACS)福士
	''' </remarks>
	'''---------------------------------------------
	Private Sub rdo007MAX070F010_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdo007MAX070F010.Click
		Me.log(XCM.clsSysMst.logLevel.NRM, "rdo007MAX070F010_Click", "郵便番号ラジオボタンクリック Start")
		Try
			'入力項目クリア
			Me.cmb005MAX070F010.Text = Nothing
		Catch ex As Exception
			Me.ErrorProc(ex)
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' 住所マスタラジオボタンクリック
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/10/28 新規作成 ACS)福士
	''' </remarks>
	'''---------------------------------------------
	Private Sub rdo011MAX070F010_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdo011MAX070F010.Click
		Me.log(XCM.clsSysMst.logLevel.NRM, "rdo011MAX070F010_Click", "住所マスタラジオボタンクリック Start")
		Try
			'入力項目クリア
			Me.cmb005MAX070F010.Text = Nothing
			Me.msk008MAX070F010.Text = Nothing
			Me.msk010MAX070F010.Text = Nothing
		Catch ex As Exception
			Me.ErrorProc(ex)
		End Try
	End Sub

#End Region

#Region "メソッド"

	'''---------------------------------------------
	''' <summary>
	''' Excel出力処理
	''' </summary>
	''' <remarks>
	''' 2010/10/29 新規作成 ACS)福士<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Sub SetExcel()
		Me.log(XCM.clsSysMst.logLevel.DBG, "SetExcel", "Excel出力処理 Start")
		Dim posHome As XSP.clsExcel.PosInfo
		Try
			posHome = New XSP.clsExcel.PosInfo(1, 1)	'１ページの基準となるホームポジションの初期値を、シートの左上に設定する。

			'Excel出力処理
			Using xlApp As XSP.clsExcel = New XSP.clsExcel(False)
				' Workbooks コレクション
				Using xlBooks As XSP.clsExcelBooks = New XSP.clsExcelBooks(xlApp, False)
					' 出力用 Workbook
					Using xlOBook As XSP.clsExcelBook = New XSP.clsExcelBook(xlBooks, False)
						Try
							' 出力用 Worksheets
							Using xlOSheets As XSP.clsExcelSheets = New XSP.clsExcelSheets(xlOBook)
								' 出力用 Worksheet
								Using xlOSheet As XSP.clsExcelSheet = New XSP.clsExcelSheet

									'新規Bookのシートをクリアし、雛型に合わせる
									' 先頭をダミー用シートに設定
									If xlOSheets.Count = 0 Then
										' シートがない場合は新しいシートを追加
										xlOSheets.Add()
									Else
										' シートがある場合は１つだけ残し、以外を削除する
										For i As Integer = xlOSheets.Count To 2 Step -1
											xlOSheet.SetSheet(xlOSheets, i)
											xlOSheet.Delete()
										Next i
									End If
									'シートの先頭を選択
									xlOSheet.SetSheet(xlOSheets, 1)

									'シートにデータ設定
									Using xlRange As XSP.clsExcelRange = New XSP.clsExcelRange
										Dim excelItm(,) As Object = Me.cnvDt2Ary(Me.dtMTI_CH)
										'書式設定
										Me.setSheetFormat(xlApp, xlRange, xlOSheet, posHome, Me.dtMTI_CH)
										xlRange.SetAreaValue(xlOSheet.Worksheet, XSP.clsExcelFunc.Enum_PosX.pA, 1, excelItm.GetLength(1), excelItm.GetLength(0), excelItm)
									End Using

									Try
										'表示
										xlApp.setVisible(True, Me)
									Catch iEx As System.Runtime.InteropServices.COMException
										'ファイルの作成に失敗
										XCM.clsSysMst.showMsgEx("E0013", "ファイルの作成", iEx.Message)
										'エラー発生のため、解放フラグを設定
										xlApp.setError()
										xlBooks.setError()
										xlOBook.setError()

										Exit Sub
									Catch ex As Exception
										Throw
									End Try
								End Using
							End Using
						Catch ex As Exception
							'エラー発生のため、解放フラグを設定
							xlApp.setError()
							xlBooks.setError()
							xlOBook.setError()
							Throw
						End Try
					End Using
				End Using
			End Using
		Catch ex As Exception
			Throw
		Finally
			posHome = Nothing
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' データシートの書式設定
	''' </summary>
	''' <param name="xlApp">clsExcelオブジェクト</param>
	''' <param name="xlOSheet">clsExcelSheetオブジェクト</param>
	''' <param name="xlRange">clsExcelRangeオブジェクト</param>
	''' <param name="posHome">開始位置</param> 
	''' <param name="dt">データテーブル</param>
	''' <remarks>
	''' 2010/10/29 新規作成 ACS)福士<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub setSheetFormat(ByRef xlApp As XSP.clsExcel, _
							   ByRef xlRange As XSP.clsExcelRange, _
							   ByRef xlOSheet As XSP.clsExcelSheet, _
							   ByVal posHome As XSP.clsExcel.PosInfo, _
							   ByRef dt As DataTable)
		Me.log(XCM.clsSysMst.logLevel.DBG, "setSheetFormat", "データシートの書式設定 Start")
		Dim cnt As Integer = dt.Columns.Count
		Dim sformat As String = Nothing
		Dim bformat As String = Nothing
		Dim posfrom As Integer = 1
		Try
			For i As Integer = 0 To cnt
				If i = cnt Then
					sformat = String.Empty
				Else
					Select Case dt.Columns(i).DataType.ToString
						Case Type.GetType("System.DateTime").ToString
							sformat = XSP.clsExcel.CST_FORMAT_DATE
						Case Type.GetType("System.String").ToString
							sformat = XSP.clsExcel.CST_FORMAT_STRING
						Case Else
							sformat = XSP.clsExcel.CST_FORMAT_INTEGER
					End Select
				End If
				If bformat <> sformat Then
					If i > 0 Then Me.setFormat(xlApp, xlRange, xlOSheet, posHome, posfrom, i, dt.Rows.Count + 1, bformat)
					posfrom = i + 1
					bformat = sformat
				End If
			Next
		Catch ex As Exception
			Throw
		Finally
			sformat = Nothing
			bformat = Nothing
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' 書式設定
	''' </summary>
	''' <param name="xlApp">clsExcelオブジェクト</param>
	''' <param name="xlOSheet">clsExcelSheetオブジェクト</param>
	''' <param name="xlRange">clsExcelRangeオブジェクト</param>
	''' <param name="posHome">開始位置</param> 
	''' <param name="posFrom">範囲指定での左端のインデックス</param>
	''' <param name="posTo">範囲指定での右端のインデックス</param>
	''' <param name="cnt">範囲指定でのEND行</param>
	''' <param name="format">書式文字列</param>                    
	''' <remarks>
	''' 2010/10/29 新規作成 ACS)福士<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub setFormat(ByRef xlApp As XSP.clsExcel, _
						  ByRef xlRange As XSP.clsExcelRange, _
						  ByRef xlOSheet As XSP.clsExcelSheet, _
						  ByVal posHome As XSP.clsExcel.PosInfo, _
						  ByVal posFrom As XSP.clsExcelFunc.Enum_PosX, _
						  ByVal posTo As XSP.clsExcelFunc.Enum_PosX, _
						  ByVal cnt As Integer, _
						  ByVal format As String)
		Me.log(XCM.clsSysMst.logLevel.DBG, "setFormat", "書式設定 Start")
		Try
			'フォーマット設定
			xlRange.SetMultiFormat(xlOSheet, _
									xlApp.getMultiCellStyle(posHome, _
										New XSP.clsExcel.PosInfo(posFrom, 1), _
										New XSP.clsExcel.PosInfo(posTo, cnt)), _
									format)
		Catch ex As Exception
			Throw
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' データテーブルを２次元配列化
	''' </summary>
	''' <param name="dt">データテーブル</param>
	''' <returns>２次元配列</returns>
	''' <remarks>
	''' 2010/10/29 新規作成 ACS)福士<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Function cnvDt2Ary(ByRef dt As DataTable) As Object(,)
		Me.log(XCM.clsSysMst.logLevel.DBG, "cnvDt2Ary", "データテーブルを２次元配列化 Start")
		Dim aryPut(dt.Rows.Count, dt.Columns.Count) As Object
		Dim dtrow As DataRow = Nothing
		Try
			'ヘッダ
			For i As Integer = 0 To Me.excelHeader.Length - 1
				aryPut(0, i) = Me.excelHeader(i)
			Next
			For row As Integer = 0 To dt.Rows.Count - 1
				dtrow = dt.Rows(row)
				For col As Integer = 0 To dt.Columns.Count - 1
					Select Case True
						Case IsDBNull(dtrow(col))
							aryPut(row + 1, col) = String.Empty
							' 書式設定
							'Case dt.Columns(col).DataType.ToString = Type.GetType("System.DateTime").ToString
							'	aryPut(row + 1, col) = DirectCast(dtrow(col), DateTime).ToString(XCM.clsConst.CST_YYYYMMDD_FORMAT)
							'Case dt.Columns(col).DataType.ToString = Type.GetType("System.Integer").ToString()
						Case Else
							aryPut(row + 1, col) = dtrow(col)
					End Select
				Next col
			Next row
			Return aryPut
		Catch ex As Exception
			Throw
		Finally
			aryPut = Nothing
			dtrow = Nothing
		End Try
	End Function

	'''---------------------------------------------
	''' <summary>
	''' データ検索処理
	''' </summary>
	''' <remarks>
	''' 2010/10/29 新規作成 ACS)福士<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Sub SelData()
		Me.log(XCM.clsSysMst.logLevel.DBG, "SelData", "データ検索処理 Start")
		Try
			Dim sql As String = Nothing

			Using db As New XCM.clsDB(XCM.clsSysMst.ctlConfigData)
				Me.dtMTI_CH = New DataTable

				'データ検索
				Me.GetSQL(Enum_SQLID.SQLID_SEL, sql)
				db.setSQLDa(sql)
				Me.SetSQLPara(db, Enum_SQLID.SQLID_SEL)
				db.execQueryDa(Me.dtMTI_CH)
			End Using
		Catch ex As Exception
			Throw
		End Try
	End Sub

'(A) STR V4-11007-000 035 20110809 FJSK)荒川 XXX号 病歴大将V4PKG問題点No1 一括更新⇔登録機能での排他チェック仕様変更対応
	'''---------------------------------------------
	''' <summary>
	''' 排他用検索
	''' </summary>
	''' <remarks>
	''' 2011/07/01 新規作成 荒川<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Function SelChkData() As ArrayList
		Me.log(XCM.clsSysMst.logLevel.DBG, Reflection.MethodBase.GetCurrentMethod.Name, "排他用検索 Start")
		Dim retData As ArrayList = Nothing
		Try
			Dim sql As String = Nothing

			Using db As New XCM.clsDB(XCM.clsSysMst.ctlConfigData), da As New DataTable
				'データ検索
				Me.GetSQL(Enum_SQLID.SQLID_CHK, sql)
				db.setSQLDa(sql)
				Me.SetSQLPara(db, Enum_SQLID.SQLID_CHK)

				db.execQueryDa(da)

				For Each daRow As DataRow In da.Rows
					If retData Is Nothing Then retData = New ArrayList
					retData.Add(daRow.Item(sqlMAX070F010.itmPATIENT_NO).ToString)
				Next
			End Using
		Catch ex As Exception
			Throw
		End Try
		'戻り値
		Return retData
	End Function
'(A) END V4-11007-000 035 20110809

	'''---------------------------------------------
	''' <summary>
	''' データ更新処理
	''' </summary>
	''' <remarks>
	''' 2010/10/29 新規作成 ACS)福士<BR/>
	''' 2011/08/09 変更　　 FJSK)荒川<BR/>
	''' (M) STR V4-11007-000 000 20110809 FJSK)荒川 XXX号 病歴大将V4PKG問題点No1 一括更新⇔登録機能での排他チェック仕様変更対応
	''' (変更前)　Private Sub UpdData()
	''' (変更後)　Private Function UpdData() As Boolean
	''' </remarks>
	'''---------------------------------------------
	Private Function UpdData() As Boolean
'(M) STR V4-11007-000 004 20110809 FJSK)荒川 XXX号 病歴大将V4PKG問題点No1 一括更新⇔登録機能での排他チェック仕様変更対応
'		Me.log(XCM.clsSysMst.logLevel.DBG, "UpdData", "データ更新処理 Start")
		Me.log(XCM.clsSysMst.logLevel.DBG, Reflection.MethodBase.GetCurrentMethod.Name, "データ更新処理 Start")
'(M) END V4-11007-000 004 20110809
'(A) STR V4-11007-000 008 20110809 FJSK)荒川 XXX号 病歴大将V4PKG問題点No1 一括更新⇔登録機能での排他チェック仕様変更対応
		Dim sql As String = Nothing
		Dim ret As Integer = -1
		Dim updPtn As ArrayList = Nothing
		Dim errPtn As ArrayList = Nothing
		Dim sqlRep As String = String.Empty
'(A) END V4-11007-000 008 20110809
		Try
'(D) STR V4-11007-000 004 20110809 FJSK)荒川 XXX号 病歴大将V4PKG問題点No1 一括更新⇔登録機能での排他チェック仕様変更対応
'			Dim sql As String = Nothing
'			Dim ret As Integer = -1
'(D) END V4-11007-000 004 20110809
'(A) STR V4-11007-000 007 20110809 FJSK)荒川 XXX号 病歴大将V4PKG問題点No1 一括更新⇔登録機能での排他チェック仕様変更対応
			'更新対象一覧取得
			updPtn = Me.SelChkData()

			'排他チェック
			errPtn = Me.chkStartStatus(updPtn.ToArray, Me.cmb024MAX070F010.Name, "処理中")
'(A) END V4-11007-000 007 20110809
			Using db As New XCM.clsDB(XCM.clsSysMst.ctlConfigData)
				Try
					'トランザクション開始
					db.ctlTran(clsDB.Enum_TranMode.Begin)

					'データ更新
					Me.GetSQL(Enum_SQLID.SQLID_UPD, sql)
'(A) STR V4-11007-000 022 20110809 FJSK)荒川 XXX号 病歴大将V4PKG問題点No1 一括更新⇔登録機能での排他チェック仕様変更対応
					If errPtn IsNot Nothing Then
						For errPtnIdx As Integer = 0 To errPtn.Count - 1
							'前処理
							Select Case True
								Case errPtnIdx = 0
									sqlRep &= " AND NOT " & sqlMAX070F010.itmPATIENT_NO & " IN("
								Case errPtnIdx > 0
									sqlRep &= ","
							End Select

							'エラー対象の患者を非更新対象に（IN句を構成する）
							'パラメータクエリだと限界があるので。。（確か1024だったかな。。）
							sqlRep &= "'" & errPtn(errPtnIdx).ToString & "'"

							'後処理
							If errPtnIdx = errPtn.Count - 1 Then sqlRep &= ")"
						Next
					End If
					'{0}を置換する
					sql = String.Format(sql, sqlRep)
'(A) END V4-11007-000 022 20110809
					db.setSQL(sql)
					Me.SetSQLPara(db, Enum_SQLID.SQLID_UPD)
					ret = db.execNonQuery(False)
					If ret = -1 Then
						'更新異常
						'ロールバック処理
						db.ctlTran(clsDB.Enum_TranMode.RollBack)
'(M) STR V4-11007-000 004 20110809 FJSK)荒川 XXX号 病歴大将V4PKG問題点No1 一括更新⇔登録機能での排他チェック仕様変更対応
'						Exit Sub
						Return False
'(M) END V4-11007-000 004 20110809
					End If

					'トランザクションコミット処理
					db.ctlTran(clsDB.Enum_TranMode.Commit)
'(A) STR V4-11007-000 009 20110809 FJSK)荒川 XXX号 病歴大将V4PKG問題点No1 一括更新⇔登録機能での排他チェック仕様変更対応
					If Me.getErrCount > 0 Then
						Me.nextErrForm(CST_RUNPROC_NAME)
						Return False
					End If

					'正常処理
					Return True
'(A) END V4-11007-000 009 20110809
				Catch ex As Exception
					Throw
				Finally
					'ロールバック処理
					If db.statTran() = True Then
						db.ctlTran(clsDB.Enum_TranMode.RollBack)
					End If
				End Try
			End Using
		Catch ex As Exception
			Throw
		End Try
	End Function

	'''---------------------------------------------
	''' <summary>
	''' 入力チェック
	''' </summary>
	''' <param name="prcId">
	''' 処理分岐フラグ（Enum_PRCID値）
	''' </param>
	''' <returns>True:正常、False:入力値異常</returns>
	''' <remarks>
	''' 2010/10/29 新規作成 ACS)福士<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Function ChkData(ByVal prcId As Integer) As Boolean
		Me.log(XCM.clsSysMst.logLevel.DBG, "ChkData", "入力チェック Start")
		Dim ret As Boolean = False
		Try
			If Me.ValidateChildren = True Then
				Select Case prcId
					Case Enum_PRCID.PRCID_SEL
						'検索の場合
						'検索条件によるチェック分岐
						Select Case True
							Case Me.rdo004MAX070F010.Checked
								'診療圏が未入力の場合
								If String.IsNullOrEmpty(Me.cmb005MAX070F010.Text) = True Then
									Me.addErrList("E0016", Me.cmb005MAX070F010.Name, Me.rdo004MAX070F010.Text, Me.rdo004MAX070F010.Text, Nothing)
								End If

							Case Me.rdo007MAX070F010.Checked
								'郵便番号が未入力の場合
								If String.IsNullOrEmpty(Me.msk008MAX070F010.Text.Replace("-", Nothing).Trim) = True Then
									Me.addErrList("E0016", Me.msk008MAX070F010.Name, Me.rdo007MAX070F010.Text, Me.rdo007MAX070F010.Text & "(開始)", Nothing)
								End If
								If String.IsNullOrEmpty(Me.msk010MAX070F010.Text.Replace("-", Nothing).Trim) = True Then
									Me.addErrList("E0016", Me.msk010MAX070F010.Name, Me.rdo007MAX070F010.Text, Me.rdo007MAX070F010.Text & "(終了)", Nothing)
								End If

							Case Me.rdo011MAX070F010.Checked
							Case Else
						End Select

						'科終了日条件指定の場合
						If Me.chk012MAX070F010.Checked = True Then
							'科終了日が未入力の場合
							If String.IsNullOrEmpty(Me.dte013MAX070F010.Text) = True Then
								Me.addErrList("E0016", Me.dte013MAX070F010.Name, Me.chk012MAX070F010.Text, Me.chk012MAX070F010.Text & "(開始)", Nothing)
							End If
							If String.IsNullOrEmpty(Me.dte015MAX070F010.Text) = True Then
								Me.addErrList("E0016", Me.dte015MAX070F010.Name, Me.chk012MAX070F010.Text, Me.chk012MAX070F010.Text & "(終了)", Nothing)
							End If
						End If
					Case Enum_PRCID.PRCID_UPD
						'更新の場合
						'検索条件によるチェック分岐
						Select Case True
							Case Me.rdo004MAX070F010.Checked Or Me.rdo007MAX070F010.Checked
								'変更後診療圏が未入力の場合
								If String.IsNullOrEmpty(Me.cmb024MAX070F010.Text) = True Then
									Me.addErrList("E0016", Me.cmb024MAX070F010.Name, Me.lbl023MAX070F010.Text, Me.lbl023MAX070F010.Text, Nothing)
								End If

							Case Me.rdo011MAX070F010.Checked
							Case Else
						End Select

					Case Else
				End Select

				'エラーがある場合はエラー画面を表示する
				If Me.getErrCount() > 0 Then
					Me.nextErrForm()
				Else
					ret = True
				End If
			Else
				ret = False
			End If
		Catch ex As Exception
			Throw
		End Try
		Return ret
	End Function

	'''---------------------------------------------
	''' <summary>
	''' SQL文作成
	''' </summary>
	''' <param name="prcId">
	''' 1:検索
	''' 2:更新
	''' （Enum_SQLID値）
	''' </param>
	''' <param name="sql">SQL文格納用</param>
	''' <remarks>
	''' 2010/10/29 新規作成 ACS)福士<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Sub GetSQL(ByVal prcId As Integer, ByRef sql As String)
		Me.log(XCM.clsSysMst.logLevel.DBG, "GetSQL", "SQL文作成 Start")
		Try
			Select Case prcId
'(M) STR V4-11007-000 004 20110809 FJSK)荒川 XXX号 病歴大将V4PKG問題点No1 一括更新⇔登録機能での排他チェック仕様変更対応
'				Case Enum_SQLID.SQLID_SEL
				Case Enum_SQLID.SQLID_SEL, Enum_SQLID.SQLID_CHK
'(M) END V4-11007-000 004 20110809
					'検索
'(A) STR V4-11007-000 008 20110809 FJSK)荒川 XXX号 病歴大将V4PKG問題点No1 一括更新⇔登録機能での排他チェック仕様変更対応
					'排他用か検索用か
					If prcId = Enum_SQLID.SQLID_SEL Then
						sql = sqlMAX070F010.sqlSel_MTI_CH
					Else
						sql = sqlMAX070F010.sqlSel_MTI_CH_Check
					End If
'(A) END V4-11007-000 008 20110809
					'検索条件によるチェック分岐
					Select Case True
						Case Me.rdo004MAX070F010.Checked
							'診療圏指定の場合
'(M) STR V4-11007-000 004 20110809 FJSK)荒川 XXX号 病歴大将V4PKG問題点No1 一括更新⇔登録機能での排他チェック仕様変更対応
'							sql = sqlMAX070F010.sqlSel_MTI_CH & sqlMAX070F010.sqlCND_AREA
							sql &= sqlMAX070F010.sqlCND_AREA
'(M) END V4-11007-000 004 20110809
						Case Me.rdo007MAX070F010.Checked
							'郵便番号指定の場合
'(M) STR V4-11007-000 004 20110809 FJSK)荒川 XXX号 病歴大将V4PKG問題点No1 一括更新⇔登録機能での排他チェック仕様変更対応
'							sql = sqlMAX070F010.sqlSel_MTI_CH & sqlMAX070F010.sqlCND_ZIP1
							sql &= sqlMAX070F010.sqlCND_ZIP1
'(M) END V4-11007-000 004 20110809
						Case Me.rdo011MAX070F010.Checked
							'住所マスタ指定の場合
'(M) STR V4-11007-000 004 20110809 FJSK)荒川 XXX号 病歴大将V4PKG問題点No1 一括更新⇔登録機能での排他チェック仕様変更対応
'							sql = sqlMAX070F010.sqlSel_MTI_CH & sqlMAX070F010.sqlCND_ZIP2
							sql &= sqlMAX070F010.sqlCND_ZIP2
'(M) END V4-11007-000 004 20110809
						Case Else
					End Select

					'科終了日条件指定の場合
					If Me.chk012MAX070F010.Checked = True Then
						sql &= sqlMAX070F010.sqlCND_END_DT
					End If
				Case Enum_SQLID.SQLID_UPD
					'更新
					'検索条件によるチェック分岐
					Select Case True
						Case Me.rdo004MAX070F010.Checked
							'診療圏指定の場合
							sql = sqlMAX070F010.sqlUpd_MTI_CH_CND1

						Case Me.rdo007MAX070F010.Checked
							'郵便番号指定の場合
							sql = sqlMAX070F010.sqlUpd_MTI_CH_CND2

						Case Me.rdo011MAX070F010.Checked
							'住所マスタ指定の場合
							sql = sqlMAX070F010.sqlUpd_MTI_CH_CND3

						Case Else
					End Select

					'科終了日条件指定の場合
					If Me.chk012MAX070F010.Checked = True Then
						sql &= sqlMAX070F010.sqlCND_END_DT
					End If

				Case Else
			End Select
		Catch ex As Exception
			Throw
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' SQLパラメータ設定
	''' </summary>
	''' <param name="db">DB取得クラス</param>
	''' <param name="prcId">
	''' 1:検索
	''' 2:更新
	''' （Enum_SQLID値）
	''' </param>
	''' <remarks>
	''' 2010/10/29 新規作成 ACS)福士<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Sub SetSQLPara(ByRef db As XCM.clsDB, ByVal prcId As Integer)
		Me.log(XCM.clsSysMst.logLevel.DBG, "SetSQLPara", "SQLパラメータ設定 Start")
		Dim cliCom As XSP.clsCom
		Try
			cliCom = New XSP.clsCom
			Dim strAry() As String
			Select Case prcId
'(M) STR V4-11007-000 004 20110809 FJSK)荒川 XXX号 病歴大将V4PKG問題点No1 一括更新⇔登録機能での排他チェック仕様変更対応
'				Case Enum_SQLID.SQLID_SEL
				Case Enum_SQLID.SQLID_SEL, Enum_SQLID.SQLID_CHK
'(M) END V4-11007-000 004 20110809
					'検索
					'検索条件によるチェック分岐
					Select Case True
						Case Me.rdo004MAX070F010.Checked
							'診療圏指定の場合
							db.setParamDa(sqlMAX070F010.prmAREA_CD, XCM.clsDB.Enum_dbType.dbNVarChar)
							db.setValDa(sqlMAX070F010.prmAREA_CD, Me.cmb005MAX070F010.Text)

						Case Me.rdo007MAX070F010.Checked
							'郵便番号指定の場合
							strAry = cliCom.getFromToValue(Me.msk008MAX070F010.Text.Replace("-", Nothing), Me.msk010MAX070F010.Text.Replace("-", Nothing))
							db.setParamDa(sqlMAX070F010.prmZIP_CD_Frm, XCM.clsDB.Enum_dbType.dbNVarChar)
							db.setParamDa(sqlMAX070F010.prmZIP_CD_To, XCM.clsDB.Enum_dbType.dbNVarChar)
							db.setValDa(sqlMAX070F010.prmZIP_CD_Frm, strAry(0))
							db.setValDa(sqlMAX070F010.prmZIP_CD_To, strAry(1))

						Case Me.rdo011MAX070F010.Checked
						Case Else
					End Select

					'科終了日条件指定の場合
					If Me.chk012MAX070F010.Checked = True Then
						strAry = cliCom.getFromToValue(Me.dte013MAX070F010.Text, Me.dte015MAX070F010.Text)
						db.setParamDa(sqlMAX070F010.prmEND_DT_Frm, XCM.clsDB.Enum_dbType.dbDateTime)
						db.setParamDa(sqlMAX070F010.prmEND_DT_To, XCM.clsDB.Enum_dbType.dbDateTime)
						db.setValDa(sqlMAX070F010.prmEND_DT_Frm, strAry(0))
						db.setValDa(sqlMAX070F010.prmEND_DT_To, strAry(1))
					End If
				Case Enum_SQLID.SQLID_UPD
					'更新
					'検索条件によるチェック分岐
					Select Case True
						Case Me.rdo004MAX070F010.Checked
							'診療圏指定の場合
							db.setParam(sqlMAX070F010.prmAREA_CD_Bfr, XCM.clsDB.Enum_dbType.dbNVarChar)
							db.setParam(sqlMAX070F010.prmAREA_CD_Aft, XCM.clsDB.Enum_dbType.dbNVarChar)
							db.setVal(sqlMAX070F010.prmAREA_CD_Bfr, Me.cmb005MAX070F010.Text)
							db.setVal(sqlMAX070F010.prmAREA_CD_Aft, Me.cmb024MAX070F010.Text)

						Case Me.rdo007MAX070F010.Checked
							'郵便番号指定の場合
							strAry = cliCom.getFromToValue(Me.msk008MAX070F010.Text.Replace("-", Nothing), Me.msk010MAX070F010.Text.Replace("-", Nothing))
							db.setParam(sqlMAX070F010.prmAREA_CD_Aft, XCM.clsDB.Enum_dbType.dbNVarChar)
							db.setParam(sqlMAX070F010.prmZIP_CD_Frm, XCM.clsDB.Enum_dbType.dbNVarChar)
							db.setParam(sqlMAX070F010.prmZIP_CD_To, XCM.clsDB.Enum_dbType.dbNVarChar)
							db.setVal(sqlMAX070F010.prmAREA_CD_Aft, Me.cmb024MAX070F010.Text)
							db.setVal(sqlMAX070F010.prmZIP_CD_Frm, strAry(0))
							db.setVal(sqlMAX070F010.prmZIP_CD_To, strAry(1))

						Case Me.rdo011MAX070F010.Checked
							'住所マスタ指定の場合
						Case Else
					End Select

					'科終了日条件指定の場合
					If Me.chk012MAX070F010.Checked = True Then
						strAry = cliCom.getFromToValue(Me.dte013MAX070F010.Text, Me.dte015MAX070F010.Text)
						db.setParam(sqlMAX070F010.prmEND_DT_Frm, XCM.clsDB.Enum_dbType.dbDateTime)
						db.setParam(sqlMAX070F010.prmEND_DT_To, XCM.clsDB.Enum_dbType.dbDateTime)
						db.setVal(sqlMAX070F010.prmEND_DT_Frm, strAry(0))
						db.setVal(sqlMAX070F010.prmEND_DT_To, strAry(1))
					End If

					'共通部
					db.setParam(sqlMAX070F010.prmLASTUPDUSER_CD, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setParam(sqlMAX070F010.prmLASTUPD_DT, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setVal(sqlMAX070F010.prmLASTUPDUSER_CD, XCM.clsSysMst.getLoginId)
					db.setVal(sqlMAX070F010.prmLASTUPD_DT, DateTime.Now())
				Case Else
			End Select
		Catch ex As Exception
			Throw
		Finally
			cliCom = Nothing
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' 画面モード切替
	''' </summary>
	''' <param name="prcId">
	''' 処理分岐フラグ（Enum_PRCID値）
	''' </param>
	''' <remarks>
	''' 2010/10/29 新規作成 ACS)福士<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Sub SetDspMode(ByVal prcId As Integer)
		Me.log(XCM.clsSysMst.logLevel.DBG, "SetDspMode", "画面モード切替 Start")
		Try
			Select Case prcId
				Case Enum_PRCID.PRCID_SEL
					'検索モード
					Me.pnl001MAX070F010.Enabled = True
					Me.pnl017MAX070F010.Enabled = False
					Me.pnl022MAX070F010.Enabled = False

					'フォーカス制御
					Select Case True
						Case Me.rdo004MAX070F010.Checked
							Me.cmb005MAX070F010.Select()
						Case Me.rdo007MAX070F010.Checked
							Me.msk008MAX070F010.Select()
						Case (Me.rdo011MAX070F010.Checked)
						Case Else
					End Select
				Case Enum_PRCID.PRCID_UPD
					'更新モード
					'検索結果が0レコードの場合、更新モードへは移行しない
					If String.IsNullOrEmpty(Me.lbl019MAX070F010.Text) = False AndAlso _
					   CLng(Me.lbl019MAX070F010.Text) > 0 Then
						Me.pnl001MAX070F010.Enabled = False
						Me.pnl017MAX070F010.Enabled = True
						Me.pnl022MAX070F010.Enabled = True
						Me.cmb024MAX070F010.Enabled = Not Me.rdo011MAX070F010.Checked

						Me.btn021MAX070F010.Select()
						''フォーカス制御
						'If Me.cmb024MAX070F010.Enabled = True Then
						'	Me.cmb024MAX070F010.Select()
						'End If
					Else
						'検索結果が0ならば検索モードで再帰呼び出し
						Me.SetDspMode(Enum_PRCID.PRCID_SEL)
					End If
				Case Else
			End Select
		Catch ex As Exception
			Throw
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' 初期画面表示
	''' </summary>
	''' <remarks>
	''' 2010/10/28 新規作成 ACS)福士<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Sub ClearInput()
		Me.log(XCM.clsSysMst.logLevel.DBG, "ClearInput", "入力項目クリア Start")
		Try
			'入力項目のクリア、操作可能コントロールの調整
			Me.grp003MAX070F010.Enabled = True
			Me.btn016MAX070F010.Enabled = True
			Me.cmb005MAX070F010.Text = Nothing
			Me.msk008MAX070F010.Text = Nothing
			Me.msk010MAX070F010.Text = Nothing
			Me.dte013MAX070F010.DateValue = Nothing
			Me.dte015MAX070F010.DateValue = Nothing
			Me.cmb024MAX070F010.Text = Nothing
			Me.rdo007MAX070F010.Checked = True
			Me.rdo004MAX070F010.Checked = True
			Me.chk012MAX070F010.Checked = False
			Me.lbl019MAX070F010.Text = Nothing

			'操作可能コントロールの調整
			Me.SetDspMode(Enum_PRCID.PRCID_SEL)
		Catch ex As Exception
			Throw
		End Try
	End Sub

#End Region

#Region "オーバーライドメソッド"
'(A) STR V4-11007-000 025 20110809 FJSK)荒川 XXX号 病歴大将V4PKG問題点No1 一括更新⇔登録機能での排他チェック仕様変更対応
	'''---------------------------------------------
	''' <summary>
	''' 戻り処理
	''' </summary>
	''' <param name="ret"></param>
	''' <param name="de"></param>
	''' <remarks>
	''' 2011/06/29 新規作成 荒川<BR/>
	''' </remarks>
	'''---------------------------------------------
	Public Overrides Sub rcvData(ret As XCM.frmBase.Enum_FormReturn, de As System.Collections.DictionaryEntry)
		Me.log(XCM.clsSysMst.logLevel.DBG, Reflection.MethodBase.GetCurrentMethod.Name, "戻り処理 Start")
		Try
			Select Case de.Key
				Case CST_XCM020F010_CD
					'エラー画面から戻った場合はﾒｯｾｰｼﾞを表示する
					If de.Value IsNot Nothing AndAlso de.Value.ToString = CST_RUNPROC_NAME Then
						Me.showMsg("I0006", "更新", Nothing)			'終了メッセージ出力
					End If
				Case Else
			End Select
		Catch ex As Exception
			Throw
		End Try
	End Sub
'(A) END V4-11007-000 025 20110809

	'''---------------------------------------------
	''' <summary>
	''' 検索処理
	''' </summary>
	''' <remarks>
	''' 2010/10/29 新規作成 ACS)福士<BR/>
	''' </remarks>
	'''---------------------------------------------
	Protected Overrides Sub SelProc()
		Me.log(XCM.clsSysMst.logLevel.DBG, "SelProc", "検索処理 Start")
		Try
			'入力チェック
			If Me.ChkData(Enum_PRCID.PRCID_SEL) = True Then
				Dim cnt As Integer = 0

				'データ取得処理
				Me.SelData()

				'ラベルに取得件数をセット
				If Me.dtMTI_CH Is Nothing = False Then
					cnt = Me.dtMTI_CH.Rows.Count
				End If
				Me.lbl019MAX070F010.Text = cnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)

				'メッセージの表示
				If cnt = 0 Then
					Me.showMsg("I0001", "検索", Nothing)

					'検索モード保持
					Me.SetDspMode(Enum_PRCID.PRCID_SEL)
				Else
					'更新モードへ移行
					Me.SetDspMode(Enum_PRCID.PRCID_UPD)
				End If
			End If
		Catch ex As Exception
			Throw
		Finally
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' 更新処理
	''' </summary>
	''' <remarks>
	''' 2010/10/29 新規作成 ACS)福士<BR/>
	''' </remarks>
	'''---------------------------------------------
	Protected Overrides Sub UpdProc()
		Me.log(XCM.clsSysMst.logLevel.DBG, "UpdProc", "更新処理 Start")
		Try
			'入力チェック
			If Me.ChkData(Enum_PRCID.PRCID_UPD) = False Then
'(D) STR V4-11007-000 004 20110809 FJSK)荒川 XXX号 病歴大将V4PKG問題点No1 一括更新⇔登録機能での排他チェック仕様変更対応
'			ElseIf Me.chkStartStatusRegSys() = True Then		'登録系の起動を確認
'																'「更新しますか?」のメッセージを表示
'(D) END V4-11007-000 004 20110809
'(M) STR V4-12053-000 004 2012/12/14 ID 病歴大将V4PKG 管理No.49 確認メッセージ「OK/キャンセル」→「はい/いいえ」に修正
			'ElseIf Me.confMsg("Q0005", "更新", Nothing) <> MsgBoxResult.Ok Then
			ElseIf Me.confMsg("Q0005", "更新", Nothing) <> MsgBoxResult.Yes Then
'(M) END V4-12053-000 004 2012/12/14 ID
'(D) STR V4-11007-000 003 20110809 FJSK)荒川 XXX号 病歴大将V4PKG問題点No1 一括更新⇔登録機能での排他チェック仕様変更対応
'			ElseIf Me.chkStartStatusRegSys() = True Then		'登録系の起動を再確認
'(D) END V4-11007-000 003 20110809
			Else
'(M) STR V4-11007-000 004 20110809 FJSK)荒川 XXX号 病歴大将V4PKG問題点No1 一括更新⇔登録機能での排他チェック仕様変更対応
'				Me.UpdData()									'データ更新処理
				If Me.UpdData() = True Then						'データ更新処理
'(M) END V4-11007-000 004 20110809
					Me.showMsg("I0006", "更新", Nothing)		'メッセージの表示
'(A) STR V4-11007-000 003 20110809 FJSK)荒川 XXX号 病歴大将V4PKG問題点No1 一括更新⇔登録機能での排他チェック仕様変更対応
				End If
'(A) END V4-11007-000 003 20110809
			End If
		Catch ex As Exception
			Throw
		Finally
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' Ｆ７キー押下
	''' </summary>
	''' <remarks>
	''' 2010/10/29 新規作成 ACS)福士<BR/>
	''' </remarks>
	'''---------------------------------------------
	Public Overrides Function F7KeyProc() As Boolean
		log(XCM.clsSysMst.logLevel.NRM, "F7KeyProc", "Ｆ７キー押下 Start")
		Try
			Me.Cursor = Cursors.WaitCursor

			If Me.btn026MAX070F010.Enabled = False Then
				Return True
			End If

			'変更処理
			Me.UpdProc()
			Return True
		Catch ex As Exception
			Throw
		Finally
			Me.Cursor = Cursors.Default
		End Try
	End Function

	'''---------------------------------------------
	''' <summary>
	''' Ｆ１１キー押下
	''' </summary>
	''' <remarks>
	''' 2010/10/29 新規作成 ACS)福士<BR/>
	''' </remarks>
	'''---------------------------------------------
	Public Overrides Function F11KeyProc() As Boolean
		log(XCM.clsSysMst.logLevel.NRM, "F11KeyProc", "Ｆ１１キー押下 Start")
		Try
			Me.Cursor = Cursors.WaitCursor

			If Me.btn016MAX070F010.Enabled = False Then
				Return True
			End If

			'検索処理
			Me.SelProc()
			Return True
		Catch ex As Exception
			Throw
		Finally
			Me.Cursor = Cursors.Default
		End Try
	End Function
#End Region

End Class