﻿Imports XCM

'''---------------------------------------------
''' <summary>
''' 診療情報管理 補助 論理チェック（論理チェック入退院対象一覧）
''' </summary>
''' <remarks>
''' Copyright 2010 FUJITSU SHIKOKU SYSTEMS LIMITED All rights reserved.<BR/>
''' FUJITSU SHIKOKU SYSTEMS LIMITED CONFIDENTIAL<BR/>
''' </remarks>
'''---------------------------------------------
Friend Class sqlMAX030R010

#Region "パラメータ"

	Public Const prmFIXED_CD As String = "@FIXED_CD"								'固定コード
	Public Const prmFIXED_CD_A As String = "@FIXED_CD_A"							'固定コード
	Public Const prmFIXED_CD_B As String = "@FIXED_CD_B"							'固定コード
	Public Const prmPATIENT_NO As String = "@PATIENT_NO"							'患者番号
	Public Const prmHSP_HISTORY_NO As String = "@HSP_HISTORY_NO"					'入退院歴番号
	Public Const prmOUT_HSP_DT As String = "@OUT_HSP_DT"							'退院日
	Public Const prmHSP_CHANCE_DISEASE_FLG As String = "@HSP_CHANCE_DISEASE_FLG"	'入院契機病名フラグ
	Public Const prmDISEASE_MED_RES_FLG1 As String = "@DISEASE_MED_RES_FLG1"		'医療資源投入病名フラグ１
	Public Const prmDISEASE_MED_RES_FLG2 As String = "@DISEASE_MED_RES_FLG2"		'医療資源投入病名フラグ２

	Public Const prmHOST_NM As String = "@HOST_NM"									'ホスト名
	Public Const prmBYOREKI_NO As String = "@BYOREKI_NO"							'病歴番号
	Public Const prmPATIENT_NM As String = "@PATIENT_NM"							'患者氏名
	Public Const prmDEPT_CD As String = "@DEPT_CD"									'診療科コード
	Public Const prmDOCTOR_CD As String = "@DOCTOR_CD"								'医師コード
	Public Const prmCODE As String = "@CODE"										'コード
	Public Const prmRECORD_MNGSTATUS_CD As String = "@RECORD_MNGSTATUS_CD "			'カルテ管理状況コード
	Public Const prmREG_PERSON_CD As String = "@REG_PERSON_CD"						'登録者コード
	Public Const prmLASTUPDUSER_CD As String = "@LASTUPDUSER_CD"					'更新者コード
	Public Const prmLASTUPD_DT As String = "@LASTUPD_DT"							'更新日

#End Region

#Region "取得項目"

	Public Const itmCOUNTER As String = "COUNTER"									'件数
	Public Const itmPATIENT_NO As String = "PATIENT_NO"								'患者番号
	Public Const itmHSP_HISTORY_NO As String = "HSP_HISTORY_NO"						'入退院歴番号
	Public Const itmHSP_DT As String = "HSP_DT"										'入院日
	Public Const itmOUT_HSP_DT As String = "OUT_HSP_DT"								'退院日
	Public Const itmSTART_DT As String = "START_DT"									'開始日
	Public Const itmEND_DT As String = "END_DT"										'終了日

	Public Const itmBYOREKI_NO As String = "BYOREKI_NO"								'病歴番号
	Public Const itmPATIENT_NM As String = "PATIENT_NM"								'患者氏名
	Public Const itmDEPT_CD As String = "DEPT_CD"									'診療科コード
	Public Const itmDOCTOR_CD As String = "DOCTOR_CD"								'医師コード

#End Region

#Region "入退院関連チェック用取得元情報"

	''' <summary>
	''' 入退院情報比較元データ取得用
	''' </summary>
	Public Const sqlSel_MTI_HSP_BASE As String = _
		" SELECT " _
		& "		MTI_HSP.PATIENT_NO, " _
		& "		XTI_BASICINFO.PATIENT_NM, " _
		& "		MTI_HSP.HSP_HISTORY_NO, " _
		& "		MTI_HSP.HSP_DT, " _
		& "		MTI_HSP.OUT_HSP_DT, " _
		& "		MTI_HSP.BYOREKI_NO, " _
		& "		MTI_HSP.DEPT_CD, " _
		& "		MTI_HSP.DOCTOR_CD " _
		& "	FROM " _
		& "		MTI_HSP " _
		& "			LEFT JOIN " _
		& "				XTI_BASICINFO " _
		& "			ON " _
		& "				MTI_HSP.PATIENT_NO = XTI_BASICINFO.PATIENT_NO " _
		& " {0}"

	''' <summary>
	''' 入院日が前の退院日より過去のデータ件数チェック用
	''' </summary>
	Public Const sqlSel_MTI_HSP_CHK1 As String = _
		" SELECT " _
		& "		MTI_HSP.PATIENT_NO, " _
		& "		MTI_HSP.HSP_HISTORY_NO, " _
		& "		MTI_HSP.HSP_DT, " _
		& "		MTI_HSP.OUT_HSP_DT " _
		& "	FROM " _
		& "		MTI_HSP " _
		& "	WHERE " _
		& "		MTI_HSP.PATIENT_NO = " & prmPATIENT_NO _
		& "     AND " _
		& "		MTI_HSP.HSP_HISTORY_NO < " & prmHSP_HISTORY_NO

	''' <summary>
	''' 退院日が次の入院日より未来のデータ件数チェック用
	''' </summary>
	Public Const sqlSel_MTI_HSP_CHK2 As String = _
		" SELECT " _
		& "		MTI_HSP.PATIENT_NO, " _
		& "		MTI_HSP.HSP_HISTORY_NO, " _
		& "		MTI_HSP.HSP_DT, " _
		& "		MTI_HSP.OUT_HSP_DT " _
		& "	FROM " _
		& "		MTI_HSP " _
		& "	WHERE " _
		& "		MTI_HSP.PATIENT_NO = " & prmPATIENT_NO _
		& "     AND " _
		& "		MTI_HSP.HSP_HISTORY_NO > " & prmHSP_HISTORY_NO

	''' <summary>
	''' 退院転帰が「死亡」のものが複数存在するデータ件数チェック用（帳票出力用）
	''' </summary>
	Public Const sqlIns_MTI_HSP_CHK3_PRT As String = _
		" INSERT INTO " _
		& "		MTW_CHK_HSP_OBJECT " _
		& "	SELECT " _
		& prmHOST_NM & ", " _
		& "		MTI_HSP.PATIENT_NO, " _
		& "		MTI_HSP.HSP_HISTORY_NO, " _
		& "		MTI_HSP.BYOREKI_NO, " _
		& "		XTI_BASICINFO.PATIENT_NM, " _
		& "		MTI_HSP.DEPT_CD, " _
		& "		MTI_HSP.DOCTOR_CD, " _
		& "		MTI_HSP.OUT_HSP_DT, " _
		& "		NULL, NULL, NULL, " _
		& prmLASTUPDUSER_CD & ", " _
		& prmLASTUPD_DT _
		& "	 FROM " _
		& "		MTI_HSP " _
		& "			INNER JOIN " _
		& "				XTI_BASICINFO " _
		& "			ON " _
		& "				MTI_HSP.PATIENT_NO = XTI_BASICINFO.PATIENT_NO " _
		& "			INNER JOIN " _
		& "				MTI_CH " _
		& "			ON " _
		& "				MTI_HSP.PATIENT_NO = MTI_CH.PATIENT_NO " _
		& "				AND " _
		& "				MTI_HSP.HSP_HISTORY_NO = MTI_CH.HSP_HISTORY_NO " _
		& "			INNER JOIN " _
		& "				MTM_OUT_HSP_OUTCOME " _
		& "			ON " _
		& "				MTI_CH.END_OUTCOME_CD = MTM_OUT_HSP_OUTCOME.OUT_HSP_OUTCOME_CD " _
		& "				AND " _
		& "				MTM_OUT_HSP_OUTCOME.FIXED_CD = " & prmFIXED_CD_A _
		& "			INNER JOIN " _
		& "				MTM_HSP_CNL " _
		& "			ON " _
		& "				MTI_CH.START_CNL_CD = MTM_HSP_CNL.HSP_CNL_CD " _
		& "				AND " _
		& "				ISNULL(MTM_HSP_CNL.FIXED_CD, '') <> " & prmFIXED_CD_B _
		& " {0}"

	''' <summary>
	''' 入院契機が１入退院内に複数存在するデータ件数チェック用（帳票出力用）
	''' </summary>
	Public Const sqlIns_MTI_HSP_CHK4_PRT As String = _
		" INSERT INTO " _
		& "		MTW_CHK_HSP_OBJECT " _
		& "	SELECT " _
		& prmHOST_NM & ", " _
		& "		MTI_HSP.PATIENT_NO, " _
		& "		MTI_HSP.HSP_HISTORY_NO, " _
		& "		MTI_HSP.BYOREKI_NO, " _
		& "		XTI_BASICINFO.PATIENT_NM, " _
		& "		MTI_HSP.DEPT_CD, " _
		& "		MTI_HSP.DOCTOR_CD, " _
		& "		MTI_HSP.OUT_HSP_DT, " _
		& "		NULL, NULL, NULL, " _
		& prmLASTUPDUSER_CD & ", " _
		& prmLASTUPD_DT _
		& "	FROM " _
		& "		MTI_HSP " _
		& "			INNER JOIN " _
		& "				XTI_BASICINFO " _
		& "			ON " _
		& "				MTI_HSP.PATIENT_NO = XTI_BASICINFO.PATIENT_NO " _
		& "			INNER JOIN " _
		& "				(MTI_CH " _
		& "					INNER JOIN " _
		& "						MTI_DISEASE " _
		& "					ON " _
		& "						MTI_CH.PATIENT_NO = MTI_DISEASE.PATIENT_NO " _
		& "						AND " _
		& "						MTI_CH.HSP_HISTORY_NO = MTI_DISEASE.HSP_HISTORY_NO " _
		& "						AND " _
		& "						MTI_CH.CH_NO = MTI_DISEASE.CH_NO " _
		& "						AND " _
		& "						MTI_DISEASE.HSP_CHANCE_DISEASE_FLG = " & prmHSP_CHANCE_DISEASE_FLG & ") " _
		& "			ON " _
		& "				MTI_HSP.PATIENT_NO = MTI_CH.PATIENT_NO " _
		& "				AND " _
		& "				MTI_HSP.HSP_HISTORY_NO = MTI_CH.HSP_HISTORY_NO " _
		& " {0}"

	''' <summary>
	''' 医療投入資源１位が１入退院内に２つ以上存在するデータ件数チェック用（帳票出力用）
	''' </summary>
	Public Const sqlIns_MTI_HSP_CHK5_PRT As String = _
		" INSERT INTO " _
		& "		MTW_CHK_HSP_OBJECT " _
		& "	SELECT " _
		& prmHOST_NM & ", " _
		& "		MTI_HSP.PATIENT_NO, " _
		& "		MTI_HSP.HSP_HISTORY_NO, " _
		& "		MTI_HSP.BYOREKI_NO, " _
		& "		XTI_BASICINFO.PATIENT_NM, " _
		& "		MTI_HSP.DEPT_CD, " _
		& "		MTI_HSP.DOCTOR_CD, " _
		& "		MTI_HSP.OUT_HSP_DT, " _
		& "		NULL, NULL, NULL, " _
		& prmLASTUPDUSER_CD & ", " _
		& prmLASTUPD_DT _
		& "	FROM " _
		& "		MTI_HSP " _
		& "			INNER JOIN " _
		& "				XTI_BASICINFO " _
		& "			ON " _
		& "				MTI_HSP.PATIENT_NO = XTI_BASICINFO.PATIENT_NO " _
		& "			INNER JOIN " _
		& "				(MTI_CH " _
		& "					INNER JOIN " _
		& "						MTI_DISEASE " _
		& "					ON " _
		& "						MTI_CH.PATIENT_NO = MTI_DISEASE.PATIENT_NO " _
		& "						AND " _
		& "						MTI_CH.HSP_HISTORY_NO = MTI_DISEASE.HSP_HISTORY_NO " _
		& "						AND " _
		& "						MTI_CH.CH_NO = MTI_DISEASE.CH_NO " _
		& "						AND " _
		& "						MTI_DISEASE.DISEASE_MED_RES_FLG1 = " & prmDISEASE_MED_RES_FLG1 & ") " _
		& "			ON " _
		& "				MTI_HSP.PATIENT_NO = MTI_CH.PATIENT_NO " _
		& "				AND " _
		& "				MTI_HSP.HSP_HISTORY_NO = MTI_CH.HSP_HISTORY_NO " _
		& " {0}"

	''' <summary>
	''' 医療投入資源２位が１入退院内に２つ以上存在するデータ件数チェック用（帳票出力用）
	''' </summary>
	Public Const sqlIns_MTI_HSP_CHK6_PRT As String = _
		" INSERT INTO " _
		& "		MTW_CHK_HSP_OBJECT " _
		& "	SELECT " _
		& prmHOST_NM & ", " _
		& "		MTI_HSP.PATIENT_NO, " _
		& "		MTI_HSP.HSP_HISTORY_NO, " _
		& "		MTI_HSP.BYOREKI_NO, " _
		& "		XTI_BASICINFO.PATIENT_NM, " _
		& "		MTI_HSP.DEPT_CD, " _
		& "		MTI_HSP.DOCTOR_CD, " _
		& "		MTI_HSP.OUT_HSP_DT, " _
		& "		NULL, NULL, NULL, " _
		& prmLASTUPDUSER_CD & ", " _
		& prmLASTUPD_DT _
		& "	FROM " _
		& "		MTI_HSP " _
		& "			INNER JOIN " _
		& "				XTI_BASICINFO " _
		& "			ON " _
		& "				MTI_HSP.PATIENT_NO = XTI_BASICINFO.PATIENT_NO " _
		& "			INNER JOIN " _
		& "				(MTI_CH " _
		& "					INNER JOIN " _
		& "						MTI_DISEASE " _
		& "					ON " _
		& "						MTI_CH.PATIENT_NO = MTI_DISEASE.PATIENT_NO " _
		& "						AND " _
		& "						MTI_CH.HSP_HISTORY_NO = MTI_DISEASE.HSP_HISTORY_NO " _
		& "						AND " _
		& "						MTI_CH.CH_NO = MTI_DISEASE.CH_NO " _
		& "						AND " _
		& "						MTI_DISEASE.DISEASE_MED_RES_FLG2 = " & prmDISEASE_MED_RES_FLG2 & ") " _
		& "			ON " _
		& "				MTI_HSP.PATIENT_NO = MTI_CH.PATIENT_NO " _
		& "				AND " _
		& "				MTI_HSP.HSP_HISTORY_NO = MTI_CH.HSP_HISTORY_NO " _
		& " {0}"

	''' <summary>
	''' 入退院歴内の科歴の前後関係チェック比較元データ取得用
	''' </summary>
	Public Const sqlSel_MTI_HSP_CHK7_SUB1 As String = _
		" SELECT " _
		& "		MTI_HSP.PATIENT_NO, " _
		& "		MTI_HSP.HSP_HISTORY_NO, " _
		& "		MTI_HSP.BYOREKI_NO, " _
		& "		XTI_BASICINFO.PATIENT_NM, " _
		& "		MTI_HSP.DEPT_CD, " _
		& "		MTI_HSP.DOCTOR_CD, " _
		& "		MTI_HSP.OUT_HSP_DT " _
		& "	FROM " _
		& "		MTI_HSP " _
		& "			LEFT JOIN " _
		& "				XTI_BASICINFO " _
		& "			ON " _
		& "				MTI_HSP.PATIENT_NO = XTI_BASICINFO.PATIENT_NO " _
		& "	{0}"

	''' <summary>
	''' 入退院歴内の科歴の前後関係チェック比較先データ取得用
	''' </summary>
	Public Const sqlSel_MTI_HSP_CHK7_SUB2 As String = _
		"SELECT" _
		& " START_DT" _
		& ",END_DT" _
		& "	 FROM MTI_CH" _
		& "	WHERE PATIENT_NO = " & prmPATIENT_NO _
		& "	  AND HSP_HISTORY_NO = " & prmHSP_HISTORY_NO _
		& "   AND START_CNL_CD NOT IN ( SELECT HSP_CNL_CD FROM MTM_HSP_CNL WHERE FIXED_CD = " & prmFIXED_CD & ")" _
		& "	ORDER BY CH_NO"

	''' <summary>
	''' ORDER BY句 タイプ１（入退院情報用）
	''' </summary>
	Public Const sqlSel_MTI_HSP_BASE_ORD1 As String = _
		" ORDER BY " _
		& "		MTI_HSP.PATIENT_NO, " _
		& "		MTI_HSP.HSP_HISTORY_NO "

	''' <summary>
	''' ORDER BY句 タイプ２（入退院情報用）
	''' </summary>
	Public Const sqlSel_MTI_HSP_BASE_ORD2 As String = _
		" ORDER BY " _
		& "		MTI_HSP.PATIENT_NO, " _
		& "		MTI_HSP.HSP_HISTORY_NO DESC "

	''' <summary>
	''' 帳票出力用集計条件
	''' </summary>
	Public Const sqlIns_MTI_HSP_GRP_PRT As String = _
		"	GROUP BY " _
		& "		MTI_HSP.PATIENT_NO, " _
		& "		MTI_HSP.HSP_HISTORY_NO, " _
		& "		MTI_HSP.BYOREKI_NO, " _
		& "		XTI_BASICINFO.PATIENT_NM, " _
		& "		MTI_HSP.DEPT_CD, " _
		& "		MTI_HSP.DOCTOR_CD, " _
		& "		MTI_HSP.OUT_HSP_DT " _
		& "	HAVING " _
		& "		COUNT(*) > 1 "

#End Region

#Region "死亡情報取得用"

	''' <summary>
	''' 死亡日と最新入退院歴の退院日が一致しないデータ件数取得用（帳票出力用）
	''' </summary>]
	Public Const sqlIns_MTI_DEATH_CHK1_PRT As String = _
		" INSERT INTO " _
		& "		MTW_CHK_HSP_OBJECT " _
		& "	SELECT " _
		& "		DISTINCT " _
		& prmHOST_NM & ", " _
		& "		MTI_HSP.PATIENT_NO, " _
		& "		MTI_HSP.HSP_HISTORY_NO, " _
		& "		MTI_HSP.BYOREKI_NO, " _
		& "		XTI_BASICINFO.PATIENT_NM, " _
		& "		MTI_HSP.DEPT_CD, " _
		& "		MTI_HSP.DOCTOR_CD, " _
		& "		MTI_HSP.OUT_HSP_DT, " _
		& "		NULL, NULL, NULL, " _
		& prmLASTUPDUSER_CD & ", " _
		& prmLASTUPD_DT _
		& "	FROM " _
		& "		MTI_HSP " _
		& "			INNER JOIN " _
		& "				XTI_BASICINFO " _
		& "			ON " _
		& "				MTI_HSP.PATIENT_NO = XTI_BASICINFO.PATIENT_NO " _
		& "			INNER JOIN " _
		& "				MTI_CH " _
		& "			ON " _
		& "				MTI_HSP.PATIENT_NO = MTI_CH.PATIENT_NO " _
		& "				AND " _
		& "				MTI_HSP.HSP_HISTORY_NO = MTI_CH.HSP_HISTORY_NO " _
		& "			INNER JOIN " _
		& "				MTM_OUT_HSP_OUTCOME " _
		& "			ON " _
		& "				MTI_HSP.OUT_HSP_OUTCOME_CD = MTM_OUT_HSP_OUTCOME.OUT_HSP_OUTCOME_CD " _
		& "				AND " _
		& "				MTM_OUT_HSP_OUTCOME.FIXED_CD = " & prmFIXED_CD & " " _
		& "			INNER JOIN " _
		& "				MTI_DEATH " _
		& "			ON " _
		& "				MTI_HSP.PATIENT_NO = MTI_DEATH.PATIENT_NO " _
		& "				AND " _
		& "				MTI_HSP.OUT_HSP_DT <> MTI_DEATH.DEATH_DT " _
		& "	{0}"

#End Region

#Region "帳票出力用ワークテーブル操作用"

	''' <summary>
	''' TW_チェック入退院対象一覧テーブルデータ削除用
	''' </summary>
	Public Const sqlDel_MTW_CHK_HSP_OBJECT As String = _
		" DELETE " _
		& "	FROM " _
		& "		MTW_CHK_HSP_OBJECT " _
		& " WHERE " _
		& "		HOST_NM = " & prmHOST_NM

	''' <summary>
	''' TW_チェック入退院対象一覧テーブルデータ件数確認用
	''' </summary>
	Public Const sqlSel_MTW_CHK_HSP_OBJECT As String = _
		" SELECT " _
		& "		COUNT(*) AS COUNTER " _
		& "	FROM " _
		& "		MTW_CHK_HSP_OBJECT " _
		& " WHERE " _
		& "		HOST_NM = " & prmHOST_NM

	''' <summary>
	''' TW_チェック入退院対象一覧テーブルデータ挿入用
	''' </summary>
	Public Const sqlIns_MTW_CHK_HSP_OBJECT As String = _
		" INSERT " _
		& "	INTO " _
		& "		MTW_CHK_HSP_OBJECT " _
		& "	VALUES ( " _
		& prmHOST_NM & ", " _
		& prmPATIENT_NO & ", " _
		& prmHSP_HISTORY_NO & ", " _
		& prmBYOREKI_NO & ", " _
		& prmPATIENT_NM & ", " _
		& prmDEPT_CD & ", " _
		& prmDOCTOR_CD & ", " _
		& prmOUT_HSP_DT & ", " _
		& prmCODE & ", " _
		& prmRECORD_MNGSTATUS_CD & ", " _
		& prmREG_PERSON_CD & ", " _
		& prmLASTUPDUSER_CD & ", " _
		& prmLASTUPD_DT _
		& ") "

#End Region

End Class