﻿Imports XCM

'''---------------------------------------------
''' <summary>
''' 診療情報管理 補助 未入力チェック
''' </summary>
''' <remarks>
''' Copyright 2010 FUJITSU SHIKOKU SYSTEMS LIMITED All rights reserved.<BR/>
''' FUJITSU SHIKOKU SYSTEMS LIMITED CONFIDENTIAL<BR/>
''' </remarks>
'''---------------------------------------------
Public Class MAX020F010

#Region "コンスタント"

	'対応SQL取得用
	Private Enum Enum_SQLID As Integer
		'* 入退院情報関連 *
		SQLID_MTI_HSP_ALL = 1						'入退院情報総件数取得用
		SQLID_MTI_HSP_CHK1 = 2						'病歴番号件数取得用
		SQLID_MTI_HSP_CHK2 = 3						'入院科歴件数取得用
		SQLID_MTI_HSP_CHK3 = 4						'主科科歴件数取得用
		SQLID_MTI_HSP_CHK4 = 5						'退院科歴件数取得用
		SQLID_MTI_HSP_CHK5 = 6						'診療科件数取得用
		SQLID_MTI_HSP_CHK6 = 7						'病棟件数取得用
		SQLID_MTI_HSP_CHK7 = 8						'在院日数件数取得用
		SQLID_MTI_HSP_CHK8 = 9						'医師件数取得用
		SQLID_MTI_HSP_CHK9 = 10						'入院日件数取得用
		SQLID_MTI_HSP_CHK10 = 11					'予定緊急件数取得用
		SQLID_MTI_HSP_CHK11 = 12					'入院目的件数取得用
		SQLID_MTI_HSP_CHK12 = 13					'入院形態件数取得用
		SQLID_MTI_HSP_CHK13 = 14					'救急車有無件数取得用
		SQLID_MTI_HSP_CHK14 = 15					'退院日件数取得用
		SQLID_MTI_HSP_CHK15 = 16					'退院転帰件数取得用
		SQLID_MTI_HSP_CHK16 = 17					'主病名件数取得用
		SQLID_MTI_HSP_CHK17 = 18					'入院契機件数取得用
		SQLID_MTI_HSP_CHK18 = 19					'医療資源投入１位件数取得用
		SQLID_MTI_HSP_CHK19 = 20					'医療資源投入２位件数取得用
		SQLID_MTI_HSP_CHK20 = 21					'入院科歴印刷ボタン押下可判定用
		SQLID_MTI_HSP_CHK21 = 22					'主科科歴印刷ボタン押下可判定用
		SQLID_MTI_HSP_CHK22 = 23					'退院科歴印刷ボタン押下可判定用
		SQLID_MTI_HSP_CHK23 = 24					'主病名印刷ボタン押下可判定用
		SQLID_MTI_HSP_CHK24 = 25					'入院契機印刷ボタン押下可判定用
		SQLID_MTI_HSP_CHK25 = 26					'医療資源１位印刷ボタン押下可判定用
		SQLID_MTI_HSP_CHK26 = 27					'医療資源２位印刷ボタン押下可判定用

		'* 科歴情報関連 *
		SQLID_MTI_CH_ALL = 31						'科歴情報総件数取得用
		SQLID_MTI_CH_CHK1 = 32						'病歴番号件数取得用
		SQLID_MTI_CH_CHK2 = 33						'郵便番号件数取得用
		SQLID_MTI_CH_CHK3 = 34						'診療圏件数取得用
		SQLID_MTI_CH_CHK4 = 35						'診療科件数取得用
		SQLID_MTI_CH_CHK5 = 36						'主病棟件数取得用
		SQLID_MTI_CH_CHK6 = 37						'在院日数件数取得用
		SQLID_MTI_CH_CHK7 = 38						'代表医師件数取得用
		SQLID_MTI_CH_CHK8 = 39						'開始日件数取得用
		SQLID_MTI_CH_CHK9 = 40						'開始時年齢件数取得用
		SQLID_MTI_CH_CHK10 = 41						'開始経路件数取得用
		SQLID_MTI_CH_CHK11 = 42						'開始経路(紹介)件数取得用
		SQLID_MTI_CH_CHK12 = 43						'開始経路(転科)件数取得用
		SQLID_MTI_CH_CHK13 = 44						'開始経路(兼科)件数取得用
		SQLID_MTI_CH_CHK14 = 45						'終了日件数取得用
		SQLID_MTI_CH_CHK15 = 46						'終了時年齢件数取得用
		SQLID_MTI_CH_CHK16 = 47						'終了経路件数取得用
		SQLID_MTI_CH_CHK17 = 48						'終了経路(紹介)件数取得用
		SQLID_MTI_CH_CHK18 = 49						'終了経路(転科)件数取得用
		SQLID_MTI_CH_CHK19 = 50						'終了転帰件数取得用
		SQLID_MTI_CH_CHK20 = 51						'終了転帰(死亡)件数取得用
		SQLID_MTI_CH_CHK21 = 52						'主病名件数取得用
		SQLID_MTI_CH_CHK22 = 53						'主病名印刷ボタン押下可判定用

		'* 病名タブ関連 *
		SQLID_MTI_DISEASE_ALL = 61					'病名総件数取得用
		SQLID_MTI_DISEASE_CHK1 = 62					'ICD10件数取得用
		SQLID_MTI_DISEASE_CHK2 = 63					'ICD9件数取得用
		SQLID_MTI_DISEASE_CHK3 = 64					'ICD10orICD9件数取得用
		SQLID_MTI_DISEASE_CHK4 = 65					'大分類件数取得用
		SQLID_MTI_DISEASE_CHK5 = 66					'中分類件数取得用
		SQLID_MTI_DISEASE_CHK6 = 67					'小分類件数取得用
		SQLID_MTI_DISEASE_CHK7 = 68					'３００分類件数取得用
		SQLID_MTI_DISEASE_CHK8 = 69					'a分類件数取得用
		SQLID_MTI_DISEASE_CHK9 = 70					'b分類件数取得用
		SQLID_MTI_DISEASE_CHK10 = 71				'c分類件数取得用
		SQLID_MTI_DISEASE_CHK11 = 72				'病名区分件数取得用
		SQLID_MTI_DISEASE_CHK12 = 73				'病名転帰件数取得用
		SQLID_MTI_DISEASE_CHK13 = 74				'発症日件数取得用
		SQLID_MTI_DISEASE_CHK14 = 75				'診断日件数取得用
		SQLID_MTI_DISEASE_CHK15 = 76				'終了日件数取得用
		SQLID_MTI_DISEASE_CHK16 = 77				'死因分類(クラス設計書№235)件数取得用
		SQLID_MTI_DISEASE_CHK17 = 78				'原死因が病名件数取得用
		SQLID_MTI_DISEASE_CHK18 = 79				'死因分類(クラス設計書№240)件数取得用
		SQLID_MTI_DISEASE_CHK19 = 80				'原死因が病名件数取得用

		'* 手術タブ関連 *
		SQLID_MTI_OPE_ALL = 91						'手術総件数取得用
		SQLID_MTI_OPE_CHK1 = 92						'ICD9CM件数取得用
		SQLID_MTI_OPE_CHK2 = 93						'大分類件数取得用
		SQLID_MTI_OPE_CHK3 = 94						'中分類件数取得用
		SQLID_MTI_OPE_CHK4 = 95						'３桁分類件数取得用
		SQLID_MTI_OPE_CHK5 = 96						'開始日件数取得用
		SQLID_MTI_OPE_CHK6 = 97						'開始時刻件数取得用
		SQLID_MTI_OPE_CHK7 = 98						'終了日件数取得用
		SQLID_MTI_OPE_CHK8 = 99						'終了時刻件数取得用
		SQLID_MTI_OPE_CHK9 = 100					'対応病名件数取得用
		SQLID_MTI_OPE_CHK10 = 101					'所要時間件数取得用
		SQLID_MTI_OPE_CHK11 = 102					'医師件数取得用
		SQLID_MTI_OPE_CHK12 = 103					'術前日数件数取得用
		SQLID_MTI_OPE_CHK13 = 104					'手術区分件数取得用
		SQLID_MTI_OPE_CHK14 = 105					'麻酔１件数取得用
		SQLID_MTI_OPE_CHK15 = 106					'補助区分１件数取得用
		SQLID_MTI_OPE_CHK16 = 107					'補助区分２件数取得用
		SQLID_MTI_OPE_CHK17 = 108					'術後日数件数取得用
		SQLID_MTI_OPE_CHK18 = 109					'点数表ｺｰﾄﾞ件数取得用
		SQLID_MTI_OPE_CHK19 = 110					'備考１件数取得用
		SQLID_MTI_OPE_CHK20 = 111					'備考２件数取得用

		'* 治療処置タブ関連 *
		SQLID_MTI_CARE_ALL = 121					'治療処置総件数取得用
		SQLID_MTI_CARE_CHK1 = 122					'ICD9CM件数取得用
		SQLID_MTI_CARE_CHK2 = 123					'大分類件数取得用
		SQLID_MTI_CARE_CHK3 = 124					'中分類件数取得用
		SQLID_MTI_CARE_CHK4 = 125					'３桁分類件数取得用
		SQLID_MTI_CARE_CHK5 = 126					'実施日数件数取得用
		SQLID_MTI_CARE_CHK6 = 127					'補助区分件数取得用
		SQLID_MTI_CARE_CHK7 = 128					'治療処置区分件数取得用

		'* 検査タブ関連 *
		SQLID_MTI_TEST_ALL = 141					'検査総件数取得用
		SQLID_MTI_TEST_CHK1 = 142					'ICD9CM件数取得用
		SQLID_MTI_TEST_CHK2 = 143					'大分類件数取得用
		SQLID_MTI_TEST_CHK3 = 144					'中分類件数取得用
		SQLID_MTI_TEST_CHK4 = 145					'３桁分類件数取得用
		SQLID_MTI_TEST_CHK5 = 146					'実施日件数取得用
		SQLID_MTI_TEST_CHK6 = 147					'補助区分件数取得用
		SQLID_MTI_TEST_CHK7 = 148					'検査区分件数取得用

		'* 死亡タブ関連 *
		SQLID_MTI_DEATH_ALL = 161					'終了転帰が死亡件数取得用
		SQLID_MTI_DEATH_CHK1 = 162					'重複患者を除いた死亡件数取得用
		SQLID_MTI_DEATH_CHK2 = 163					'主病名件数取得用
		SQLID_MTI_DEATH_CHK3 = 164					'院内死亡件数取得用
		SQLID_MTI_DEATH_CHK4 = 165					'死亡日件数取得用
		SQLID_MTI_DEATH_CHK5 = 166					'死亡時刻件数取得用
		SQLID_MTI_DEATH_CHK6 = 167					'死亡区分件数取得用
		SQLID_MTI_DEATH_CHK7 = 168					'剖検有無件数取得用
		SQLID_MTI_DEATH_CHK8 = 169					'原死因件数取得用
		SQLID_MTI_DEATH_CHK9 = 170					'原死因（病名死因）件数取得用
		SQLID_MTI_DEATH_CHK10 = 171					'原死因（外因死因）件数取得用
		SQLID_MTI_DEATH_CHK11 = 172					'剖検区分が有件数取得用
		SQLID_MTI_DEATH_CHK12 = 173					'剖検番号件数取得用

		'* 紹介タブ関連 *
		SQLID_MTI_HSP_CNL_ALL = 181					'開始経路紹介総件数取得用
		SQLID_MTI_HSP_CNL_CHK1 = 182				'医療機関コード件数取得用
		SQLID_MTI_HSP_CNL_CHK2 = 183				'医療機関名件数取得用
		SQLID_MTI_HSP_CNL_CHK3 = 184				'医師名件数取得用
		SQLID_MTI_HSP_CNL_CHK4 = 185				'終了経路紹介件数取得用
		SQLID_MTI_HSP_CNL_CHK5 = 186				'医療機関コード件数取得用
		SQLID_MTI_HSP_CNL_CHK6 = 187				'医療機関名件数取得用
		SQLID_MTI_HSP_CNL_CHK7 = 188				'医師名件数取得用

	End Enum

	'フィールド識別名
	Private Const CST_HSP_DEPT_CD As String = clsMAXCOMMON.CST_TABLECD_MTI_HSP & ".DEPT_CD"					'診療科コード（入退院側条件）
	Private Const CST_CH_DEPT_CD As String = clsMAXCOMMON.CST_TABLECD_MTI_CH & ".DEPT_CD"					'診療科コード（科歴側条件）
	Private Const CST_HSP_WARD_CD As String = clsMAXCOMMON.CST_TABLECD_MTI_HSP & ".WARD_CD"					'病棟コード（入退院側条件）
	Private Const CST_CH_WARD_CD As String = clsMAXCOMMON.CST_TABLECD_MTI_CH & ".WARD_CD"					'病棟コード（科歴側条件）
	Private Const CST_DISEASE_DIV As String = clsMAXCOMMON.CST_TABLECD_MTI_DISEASE & ".DISEASE_DIV"			'病名区分コード
	Private Const CST_OPE_DIV As String = clsMAXCOMMON.CST_TABLECD_MTI_OPE & ".OPE_DIV"						'手術区分コード
	Private Const CST_CARE_DIV As String = clsMAXCOMMON.CST_TABLECD_MTI_CARE & ".CARE_DIV"					'治療処置区分コード
	Private Const CST_TEST_DIV As String = clsMAXCOMMON.CST_TABLECD_MTI_TEST & ".TEST_DIV"					'検査区分コード

#End Region

#Region "変数"
	Private strENV0059 As String								'動作環境（終了転帰｢死亡」の重複）

	Private _initRadioBtn() As String = New String() {}			'ラジオボタン初期値

	Private lblObjs_NOCLR() As System.Windows.Forms.Label		'画面初期化時にクリアしないラベル群
	Private lblObjs_HSP() As System.Windows.Forms.Label			'入退院歴系ラベル群
	Private lblObjs_CH() As System.Windows.Forms.Label			'科歴系ラベル群
	Private lblObjs_DISEASE() As System.Windows.Forms.Label		'病名系ラベル群
	Private lblObjs_OPE() As System.Windows.Forms.Label			'手術系ラベル群
	Private lblObjs_CARE() As System.Windows.Forms.Label		'治療処置系ラベル群
	Private lblObjs_TEST() As System.Windows.Forms.Label		'検査系ラベル群
	Private lblObjs_DEATH() As System.Windows.Forms.Label		'死亡系ラベル群
	Private lblObjs_STINTRO() As System.Windows.Forms.Label		'開始経路が「紹介」系ラベル群
	Private lblObjs_ENINTRO() As System.Windows.Forms.Label		'終了経路が「紹介」系ラベル群

	Private btnObjs_HSP() As System.Windows.Forms.Button		'入退院歴系印刷ボタン群
	Private btnObjs_CH() As System.Windows.Forms.Button			'科歴系印刷ボタン群
	Private btnObjs_DISEASE() As System.Windows.Forms.Button	'病名系印刷ボタン群
	Private btnObjs_OPE() As System.Windows.Forms.Button		'手術系印刷ボタン群
	Private btnObjs_CARE() As System.Windows.Forms.Button		'治療処置系印刷ボタン群
	Private btnObjs_TEST() As System.Windows.Forms.Button		'検査系印刷ボタン群
	Private btnObjs_DEATH() As System.Windows.Forms.Button		'死亡系印刷ボタン群
	Private btnObjs_STINTRO() As System.Windows.Forms.Button	'開始経路が「紹介」系印刷ボタン群
	Private btnObjs_ENINTRO() As System.Windows.Forms.Button	'終了経路が「紹介」系印刷ボタン群
	Private btnObjs_EXEC_TAB() As System.Windows.Forms.Button	'タブ内の実行(F8)ボタン群

	Private chkObjs_SEARCH() As XCM.BT_CheckBox					'本画面で追加された検索条件用チェックボックス群

	Private eUNIT_CD As XCM.clsConst.Enum_LendUnit = Nothing	'TM_貸出物マスタ.単位

	'継承先用共通条件
	'診療科コード（入退院側）
	'病棟コード（入退院側）
	'診療科コード（科歴側）
	'病棟コード（科歴側）
	'病名区分コード
	'手術区分コード
	'治療処置区分コード
	'検査区分コード
	Private ReadOnly clsScInpSucAhead As XSP.datSearchInput() = _
	{
		  New XSP.datSearchInput("chk001MAX020F010", clsMAXCOMMON.CST_TABLECD_MTI_HSP, CST_HSP_DEPT_CD, XSP.clsSearch.ENUM_SQL_CTYPE.cNORMAL, _
			New XSP.datSearchInput.clsLinkControls() { _
				New XSP.datSearchInput.clsLinkControls("cmb002MAX020F010", XSP.clsSearch.ENUM_SQL_CTYPE.cNORMAL, XCM.clsDB.Enum_dbType.dbNVarChar) _
			}) _
		, New XSP.datSearchInput("chk004MAX020F010", clsMAXCOMMON.CST_TABLECD_MTI_HSP, CST_HSP_WARD_CD, XSP.clsSearch.ENUM_SQL_CTYPE.cNORMAL, _
			New XSP.datSearchInput.clsLinkControls() { _
				New XSP.datSearchInput.clsLinkControls("cmb005MAX020F010", XSP.clsSearch.ENUM_SQL_CTYPE.cNORMAL, XCM.clsDB.Enum_dbType.dbNVarChar) _
			}) _
		, New XSP.datSearchInput("chk001MAX020F010", clsMAXCOMMON.CST_TABLECD_MTI_CH, CST_CH_DEPT_CD, XSP.clsSearch.ENUM_SQL_CTYPE.cNORMAL, _
			New XSP.datSearchInput.clsLinkControls() { _
				New XSP.datSearchInput.clsLinkControls("cmb002MAX020F010", XSP.clsSearch.ENUM_SQL_CTYPE.cNORMAL, XCM.clsDB.Enum_dbType.dbNVarChar) _
			}) _
		, New XSP.datSearchInput("chk004MAX020F010", clsMAXCOMMON.CST_TABLECD_MTI_CH, CST_CH_WARD_CD, XSP.clsSearch.ENUM_SQL_CTYPE.cNORMAL,
			New XSP.datSearchInput.clsLinkControls() { _
				New XSP.datSearchInput.clsLinkControls("cmb005MAX020F010", XSP.clsSearch.ENUM_SQL_CTYPE.cNORMAL, XCM.clsDB.Enum_dbType.dbNVarChar) _
			}) _
		, New XSP.datSearchInput("rdo140MAX020F010", clsMAXCOMMON.CST_TABLECD_MTI_DISEASE, CST_DISEASE_DIV, XSP.clsSearch.ENUM_SQL_CTYPE.cNORMAL, _
			New XSP.datSearchInput.clsLinkControls() { _
				New XSP.datSearchInput.clsLinkControls("cmb141MAX020F010", XSP.clsSearch.ENUM_SQL_CTYPE.cNORMAL, XCM.clsDB.Enum_dbType.dbNVarChar) _
			}) _
		, New XSP.datSearchInput("rdo201MAX020F010", clsMAXCOMMON.CST_TABLECD_MTI_OPE, CST_OPE_DIV, XSP.clsSearch.ENUM_SQL_CTYPE.cNORMAL, _
			New XSP.datSearchInput.clsLinkControls() { _
				New XSP.datSearchInput.clsLinkControls("cmb202MAX020F010", XSP.clsSearch.ENUM_SQL_CTYPE.cNORMAL, XCM.clsDB.Enum_dbType.dbNVarChar) _
			}) _
		, New XSP.datSearchInput("rdo270MAX020F010", clsMAXCOMMON.CST_TABLECD_MTI_CARE, CST_CARE_DIV, XSP.clsSearch.ENUM_SQL_CTYPE.cNORMAL, _
			New XSP.datSearchInput.clsLinkControls() { _
				New XSP.datSearchInput.clsLinkControls("cmb271MAX020F010", XSP.clsSearch.ENUM_SQL_CTYPE.cNORMAL, XCM.clsDB.Enum_dbType.dbNVarChar) _
			}) _
		, New XSP.datSearchInput("rdo300MAX020F010", clsMAXCOMMON.CST_TABLECD_MTI_TEST, CST_TEST_DIV, XSP.clsSearch.ENUM_SQL_CTYPE.cNORMAL, _
			New XSP.datSearchInput.clsLinkControls() { _
				New XSP.datSearchInput.clsLinkControls("cmb301MAX020F010", XSP.clsSearch.ENUM_SQL_CTYPE.cNORMAL, XCM.clsDB.Enum_dbType.dbNVarChar) _
		}) _
	}

#End Region

#Region "イベント"

	'''---------------------------------------------
	''' <summary>
	''' 未入力チェック画面＿初期設定
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/11/29 新規作成 ACS)福士
	''' </remarks>
	'''---------------------------------------------
	Private Sub MAX020F010_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
		If Me.IsDisposed = True Then Return
		Me.log(XCM.clsSysMst.logLevel.NRM, "MAX020F010_Load", "未入力チェック画面＿初期設定 Start")
		Dim cliComboCom As XSP.clsComboCom	'コンボボックス設定用
		Dim adat As DataTable = Nothing
		Try

			'（終了転帰「死亡」の重複）
			Me.strENV0059 = XCM.clsSysMst.ctlEnvData.getEnv(XCM.datEnv.Enum_ENV.ENV_00059)

			cliComboCom = New XSP.clsComboCom

			'ラジオボタン初期値設定用設定
			Me._initRadioBtn = {Me.rdo139MAX020F010.Name, Me.rdo200MAX020F010.Name, Me.rdo269MAX020F010.Name, Me.rdo299MAX020F010.Name}

			'本画面で追加された検索条件チェックボックス群
			Me.chkObjs_SEARCH = New XCM.BT_CheckBox() { _
													Me.chk001MAX020F010, Me.chk004MAX020F010 _
													}

			'入退院歴チェックボックス連動チェックボックス群
			Me.chkObjs_HSP = New XCM.BT_CheckBox() { _
													Me.chk010MAX020F010, Me.chk013MAX020F010, Me.chk016MAX020F010, Me.chk019MAX020F010, _
													Me.chk022MAX020F010, Me.chk025MAX020F010, Me.chk028MAX020F010, Me.chk031MAX020F010, _
													Me.chk034MAX020F010, Me.chk037MAX020F010, Me.chk040MAX020F010, Me.chk043MAX020F010, _
													Me.chk046MAX020F010, Me.chk049MAX020F010, Me.chk052MAX020F010, Me.chk056MAX020F010, _
													Me.chk059MAX020F010, Me.chk062MAX020F010
													}

			'科歴チェックボックス連動チェックボックス群
			Me.chkObjs_CH = New XCM.BT_CheckBox() { _
													Me.chk073MAX020F010, Me.chk076MAX020F010, Me.chk079MAX020F010, Me.chk082MAX020F010, _
													Me.chk085MAX020F010, Me.chk088MAX020F010, Me.chk091MAX020F010, Me.chk094MAX020F010, _
													Me.chk097MAX020F010, Me.chk100MAX020F010, Me.chk110MAX020F010, Me.chk113MAX020F010, _
													Me.chk116MAX020F010, Me.chk124MAX020F010, Me.chk130MAX020F010 _
													}

			'病名チェックボックス連動チェックボックス群
			Me.chkObjs_DISEASE = New XCM.BT_CheckBox() { _
													Me.chk152MAX020F010, Me.chk155MAX020F010, Me.chk158MAX020F010, Me.chk161MAX020F010, _
													Me.chk164MAX020F010, Me.chk167MAX020F010, Me.chk170MAX020F010, Me.chk143MAX020F010, _
													Me.chk173MAX020F010, Me.chk176MAX020F010, Me.chk179MAX020F010, Me.chk182MAX020F010, _
													Me.chk187MAX020F010, Me.chk192MAX020F010 _
													}

			'手術チェックボックス連動チェックボックス群
			Me.chkObjs_OPE = New XCM.BT_CheckBox() { _
													Me.chk204MAX020F010, Me.chk207MAX020F010, Me.chk210MAX020F010, Me.chk213MAX020F010, _
													Me.chk216MAX020F010, Me.chk219MAX020F010, Me.chk222MAX020F010, Me.chk225MAX020F010, _
													Me.chk228MAX020F010, Me.chk231MAX020F010, Me.chk234MAX020F010, Me.chk237MAX020F010, _
													Me.chk240MAX020F010, Me.chk243MAX020F010, Me.chk246MAX020F010, Me.chk249MAX020F010, _
													Me.chk252MAX020F010, Me.chk255MAX020F010, Me.chk258MAX020F010, Me.chk261MAX020F010
													}

			'治療処置チェックボックス連動チェックボックス群
			Me.chkObjs_CARE = New XCM.BT_CheckBox() { _
													Me.chk273MAX020F010, Me.chk276MAX020F010, Me.chk279MAX020F010, Me.chk282MAX020F010, _
													Me.chk285MAX020F010, Me.chk288MAX020F010, Me.chk291MAX020F010
													}

			'検査チェックボックス連動チェックボックス群
			Me.chkObjs_TEST = New XCM.BT_CheckBox() { _
													Me.chk303MAX020F010, Me.chk306MAX020F010, Me.chk309MAX020F010, Me.chk312MAX020F010, _
													Me.chk315MAX020F010, Me.chk318MAX020F010, Me.chk321MAX020F010
													}

			'死亡チェックボックス連動チェックボックス群
			Me.chkObjs_DEATH = New XCM.BT_CheckBox() { _
													Me.chk330MAX020F010, Me.chk333MAX020F010, Me.chk336MAX020F010, Me.chk339MAX020F010, _
													Me.chk342MAX020F010, Me.chk345MAX020F010, Me.chk348MAX020F010, Me.chk358MAX020F010 _
													}

			'開始経路が紹介チェックボックス連動チェックボックス群
			Me.chkObjs_STINTRO = New XCM.BT_CheckBox() { _
													Me.chk365MAX020F010, Me.chk368MAX020F010, Me.chk371MAX020F010 _
													}

			'終了経路が紹介チェックボックス連動チェックボックス群
			Me.chkObjs_ENINTRO = New XCM.BT_CheckBox() { _
													Me.chk376MAX020F010, Me.chk379MAX020F010, Me.chk382MAX020F010 _
													}

			'カウンタラベル群（印刷ボタンと連動するもの）
			'入退院歴ラベル群
			Me.lblObjs_HSP = New System.Windows.Forms.Label() { _
													Me.lbl011MAX020F010, Me.lbl014MAX020F010, Me.lbl017MAX020F010, Me.lbl020MAX020F010, _
													Me.lbl023MAX020F010, Me.lbl026MAX020F010, Me.lbl029MAX020F010, Me.lbl032MAX020F010, _
													Me.lbl035MAX020F010, Me.lbl038MAX020F010, Me.lbl041MAX020F010, Me.lbl044MAX020F010, _
													Me.lbl047MAX020F010, Me.lbl050MAX020F010, Me.lbl053MAX020F010, Me.lbl057MAX020F010, _
													Me.lbl060MAX020F010, Me.lbl064MAX020F010, Me.lbl067MAX020F010 _
													}

			'科歴ラベル群
			Me.lblObjs_CH = New System.Windows.Forms.Label() { _
													Me.lbl074MAX020F010, Me.lbl077MAX020F010, Me.lbl080MAX020F010, Me.lbl083MAX020F010, _
													Me.lbl086MAX020F010, Me.lbl089MAX020F010, Me.lbl092MAX020F010, Me.lbl095MAX020F010, _
													Me.lbl098MAX020F010, Me.lbl101MAX020F010, Me.lbl111MAX020F010, Me.lbl114MAX020F010, _
													Me.lbl117MAX020F010, Me.lbl125MAX020F010, Me.lbl131MAX020F010 _
													}

			'病名ラベル群
			Me.lblObjs_DISEASE = New System.Windows.Forms.Label() { _
													Me.lbl136MAX020F010, Me.lbl144MAX020F010, Me.lbl153MAX020F010, Me.lbl156MAX020F010, _
													Me.lbl159MAX020F010, Me.lbl162MAX020F010, Me.lbl165MAX020F010, Me.lbl168MAX020F010, _
													Me.lbl171MAX020F010, Me.lbl174MAX020F010, Me.lbl177MAX020F010, Me.lbl180MAX020F010, _
													Me.lbl183MAX020F010, Me.lbl188MAX020F010, Me.lbl193MAX020F010 _
													}

			'手術ラベル群
			Me.lblObjs_OPE = New System.Windows.Forms.Label() { _
													Me.lbl205MAX020F010, Me.lbl208MAX020F010, Me.lbl211MAX020F010, Me.lbl214MAX020F010, _
													Me.lbl217MAX020F010, Me.lbl220MAX020F010, Me.lbl223MAX020F010, Me.lbl226MAX020F010, _
													Me.lbl229MAX020F010, Me.lbl232MAX020F010, Me.lbl235MAX020F010, Me.lbl238MAX020F010, _
													Me.lbl241MAX020F010, Me.lbl244MAX020F010, Me.lbl247MAX020F010, Me.lbl250MAX020F010, _
													Me.lbl253MAX020F010, Me.lbl256MAX020F010, Me.lbl259MAX020F010, Me.lbl262MAX020F010
													}

			'治療処置ラベル群
			Me.lblObjs_CARE = New System.Windows.Forms.Label() { _
													Me.lbl274MAX020F010, Me.lbl277MAX020F010, Me.lbl280MAX020F010, Me.lbl283MAX020F010, _
													Me.lbl286MAX020F010, Me.lbl289MAX020F010, Me.lbl292MAX020F010
													}

			'検査ラベル群
			Me.lblObjs_TEST = New System.Windows.Forms.Label() { _
													Me.lbl304MAX020F010, Me.lbl307MAX020F010, Me.lbl310MAX020F010, Me.lbl313MAX020F010, _
													Me.lbl316MAX020F010, Me.lbl319MAX020F010, Me.lbl322MAX020F010
													}

			'死亡ラベル群
			Me.lblObjs_DEATH = New System.Windows.Forms.Label() { _
													Me.lbl331MAX020F010, Me.lbl334MAX020F010, Me.lbl337MAX020F010, Me.lbl340MAX020F010, _
													Me.lbl343MAX020F010, Me.lbl346MAX020F010, Me.lbl349MAX020F010, Me.lbl359MAX020F010 _
													}

			'紹介（開始）ラベル群
			Me.lblObjs_STINTRO = New System.Windows.Forms.Label() { _
													Me.lbl366MAX020F010, Me.lbl369MAX020F010, Me.lbl372MAX020F010 _
													}


			'紹介（終了）ラベル群
			Me.lblObjs_ENINTRO = New System.Windows.Forms.Label() { _
													Me.lbl377MAX020F010, Me.lbl380MAX020F010, Me.lbl383MAX020F010 _
													}

			'全件数表示（印刷ボタン連動）ラベル群
			Me.lblObjs_Cnt = New System.Windows.Forms.Label() { _
													Me.lbl011MAX020F010, Me.lbl014MAX020F010, Me.lbl017MAX020F010, Me.lbl020MAX020F010, _
													Me.lbl023MAX020F010, Me.lbl026MAX020F010, Me.lbl029MAX020F010, Me.lbl032MAX020F010, _
													Me.lbl035MAX020F010, Me.lbl038MAX020F010, Me.lbl041MAX020F010, Me.lbl044MAX020F010, _
													Me.lbl047MAX020F010, Me.lbl050MAX020F010, Me.lbl053MAX020F010, Me.lbl057MAX020F010, _
													Me.lbl060MAX020F010, Me.lbl064MAX020F010, Me.lbl067MAX020F010, Me.lbl074MAX020F010, _
													Me.lbl077MAX020F010, Me.lbl080MAX020F010, Me.lbl083MAX020F010, Me.lbl086MAX020F010, _
													Me.lbl089MAX020F010, Me.lbl092MAX020F010, Me.lbl095MAX020F010, Me.lbl098MAX020F010, _
													Me.lbl101MAX020F010, Me.lbl111MAX020F010, Me.lbl114MAX020F010, Me.lbl117MAX020F010, _
													Me.lbl125MAX020F010, Me.lbl131MAX020F010, Me.lbl136MAX020F010, Me.lbl144MAX020F010, _
													Me.lbl153MAX020F010, Me.lbl156MAX020F010, Me.lbl159MAX020F010, Me.lbl162MAX020F010, _
													Me.lbl165MAX020F010, Me.lbl168MAX020F010, Me.lbl171MAX020F010, Me.lbl174MAX020F010, _
													Me.lbl177MAX020F010, Me.lbl180MAX020F010, Me.lbl183MAX020F010, Me.lbl188MAX020F010, _
													Me.lbl193MAX020F010, Me.lbl205MAX020F010, Me.lbl208MAX020F010, Me.lbl211MAX020F010, _
													Me.lbl214MAX020F010, Me.lbl217MAX020F010, Me.lbl220MAX020F010, Me.lbl223MAX020F010, _
													Me.lbl226MAX020F010, Me.lbl229MAX020F010, Me.lbl232MAX020F010, Me.lbl235MAX020F010, _
													Me.lbl238MAX020F010, Me.lbl241MAX020F010, Me.lbl244MAX020F010, Me.lbl247MAX020F010, _
													Me.lbl250MAX020F010, Me.lbl253MAX020F010, Me.lbl256MAX020F010, Me.lbl259MAX020F010, _
													Me.lbl262MAX020F010, Me.lbl274MAX020F010, Me.lbl277MAX020F010, Me.lbl280MAX020F010, _
													Me.lbl283MAX020F010, Me.lbl286MAX020F010, Me.lbl289MAX020F010, Me.lbl292MAX020F010, _
													Me.lbl304MAX020F010, Me.lbl307MAX020F010, Me.lbl310MAX020F010, Me.lbl313MAX020F010, _
													Me.lbl316MAX020F010, Me.lbl319MAX020F010, Me.lbl322MAX020F010, Me.lbl331MAX020F010, _
													Me.lbl334MAX020F010, Me.lbl337MAX020F010, Me.lbl340MAX020F010, Me.lbl343MAX020F010, _
													Me.lbl346MAX020F010, Me.lbl349MAX020F010, Me.lbl359MAX020F010, Me.lbl366MAX020F010, _
													Me.lbl369MAX020F010, Me.lbl372MAX020F010, Me.lbl377MAX020F010, Me.lbl380MAX020F010, _
													Me.lbl383MAX020F010
													}

			'印刷ボタン群
			'入退院歴ボタン群
			Me.btnObjs_HSP = New System.Windows.Forms.Button() { _
													Me.btn012MAX020F010, Me.btn015MAX020F010, Me.btn018MAX020F010, Me.btn021MAX020F010, _
													Me.btn024MAX020F010, Me.btn027MAX020F010, Me.btn030MAX020F010, Me.btn033MAX020F010, _
													Me.btn036MAX020F010, Me.btn039MAX020F010, Me.btn042MAX020F010, Me.btn045MAX020F010, _
													Me.btn048MAX020F010, Me.btn051MAX020F010, Me.btn054MAX020F010, Me.btn058MAX020F010, _
													Me.btn061MAX020F010, Me.btn065MAX020F010, Me.btn068MAX020F010 _
													}

			'科歴ボタン群
			Me.btnObjs_CH = New System.Windows.Forms.Button() { _
													Me.btn075MAX020F010, Me.btn078MAX020F010, Me.btn081MAX020F010, Me.btn084MAX020F010, _
													Me.btn087MAX020F010, Me.btn090MAX020F010, Me.btn093MAX020F010, Me.btn096MAX020F010, _
													Me.btn099MAX020F010, Me.btn102MAX020F010, Me.btn112MAX020F010, Me.btn115MAX020F010, _
													Me.btn118MAX020F010, Me.btn126MAX020F010, Me.btn132MAX020F010 _
													}

			'病名ボタン群
			Me.btnObjs_DISEASE = New System.Windows.Forms.Button() { _
													Me.btn137MAX020F010, Me.btn145MAX020F010, Me.btn154MAX020F010, Me.btn157MAX020F010, _
													Me.btn160MAX020F010, Me.btn163MAX020F010, Me.btn166MAX020F010, Me.btn169MAX020F010, _
													Me.btn172MAX020F010, Me.btn175MAX020F010, Me.btn178MAX020F010, Me.btn181MAX020F010, _
													Me.btn184MAX020F010, Me.btn189MAX020F010, Me.btn194MAX020F010 _
													}

			'手術ボタン群
			Me.btnObjs_OPE = New System.Windows.Forms.Button() { _
													Me.btn206MAX020F010, Me.btn209MAX020F010, Me.btn212MAX020F010, Me.btn215MAX020F010, _
													Me.btn218MAX020F010, Me.btn221MAX020F010, Me.btn224MAX020F010, Me.btn227MAX020F010, _
													Me.btn230MAX020F010, Me.btn233MAX020F010, Me.btn236MAX020F010, Me.btn239MAX020F010, _
													Me.btn242MAX020F010, Me.btn245MAX020F010, Me.btn248MAX020F010, Me.btn251MAX020F010, _
													Me.btn254MAX020F010, Me.btn257MAX020F010, Me.btn260MAX020F010, Me.btn263MAX020F010 _
													}

			'治療処置ボタン群
			Me.btnObjs_CARE = New System.Windows.Forms.Button() { _
													Me.btn275MAX020F010, Me.btn278MAX020F010, Me.btn281MAX020F010, Me.btn284MAX020F010, _
													Me.btn287MAX020F010, Me.btn290MAX020F010, Me.btn293MAX020F010 _
													}

			'検査ボタン群
			Me.btnObjs_TEST = New System.Windows.Forms.Button() { _
													Me.btn305MAX020F010, Me.btn308MAX020F010, Me.btn311MAX020F010, Me.btn314MAX020F010, _
													Me.btn317MAX020F010, Me.btn320MAX020F010, Me.btn323MAX020F010 _
													}

			'死亡ボタン群
			Me.btnObjs_DEATH = New System.Windows.Forms.Button() { _
													Me.btn332MAX020F010, Me.btn335MAX020F010, Me.btn338MAX020F010, Me.btn341MAX020F010, _
													Me.btn344MAX020F010, Me.btn347MAX020F010, Me.btn350MAX020F010, Me.btn360MAX020F010 _
													}

			'紹介（開始）ボタン群
			Me.btnObjs_STINTRO = New System.Windows.Forms.Button() { _
													Me.btn367MAX020F010, Me.btn370MAX020F010, Me.btn373MAX020F010 _
													}

			'紹介（終了）ボタン群
			Me.btnObjs_ENINTRO = New System.Windows.Forms.Button() { _
													Me.btn378MAX020F010, Me.btn381MAX020F010, Me.btn384MAX020F010 _
													}

			'印刷ボタン群
			Me.btnObjs_Prt = New System.Windows.Forms.Button() { _
													Me.btn012MAX020F010, Me.btn015MAX020F010, Me.btn018MAX020F010, Me.btn021MAX020F010, _
													Me.btn024MAX020F010, Me.btn027MAX020F010, Me.btn030MAX020F010, Me.btn033MAX020F010, _
													Me.btn036MAX020F010, Me.btn039MAX020F010, Me.btn042MAX020F010, Me.btn045MAX020F010, _
													Me.btn048MAX020F010, Me.btn051MAX020F010, Me.btn054MAX020F010, Me.btn058MAX020F010, _
													Me.btn061MAX020F010, Me.btn065MAX020F010, Me.btn068MAX020F010, Me.btn075MAX020F010, _
													Me.btn078MAX020F010, Me.btn081MAX020F010, Me.btn084MAX020F010, Me.btn087MAX020F010, _
													Me.btn090MAX020F010, Me.btn093MAX020F010, Me.btn096MAX020F010, Me.btn099MAX020F010, _
													Me.btn102MAX020F010, Me.btn112MAX020F010, Me.btn115MAX020F010, Me.btn118MAX020F010, _
													Me.btn126MAX020F010, Me.btn132MAX020F010, Me.btn137MAX020F010, Me.btn145MAX020F010, _
													Me.btn154MAX020F010, Me.btn157MAX020F010, Me.btn160MAX020F010, Me.btn163MAX020F010, _
													Me.btn166MAX020F010, Me.btn169MAX020F010, Me.btn172MAX020F010, Me.btn175MAX020F010, _
													Me.btn178MAX020F010, Me.btn181MAX020F010, Me.btn184MAX020F010, Me.btn189MAX020F010, _
													Me.btn194MAX020F010, Me.btn206MAX020F010, Me.btn209MAX020F010, Me.btn212MAX020F010, _
													Me.btn215MAX020F010, Me.btn218MAX020F010, Me.btn221MAX020F010, Me.btn224MAX020F010, _
													Me.btn227MAX020F010, Me.btn230MAX020F010, Me.btn233MAX020F010, Me.btn236MAX020F010, _
													Me.btn239MAX020F010, Me.btn242MAX020F010, Me.btn245MAX020F010, Me.btn248MAX020F010, _
													Me.btn251MAX020F010, Me.btn254MAX020F010, Me.btn257MAX020F010, Me.btn260MAX020F010, _
													Me.btn263MAX020F010, Me.btn275MAX020F010, Me.btn278MAX020F010, Me.btn281MAX020F010, _
													Me.btn284MAX020F010, Me.btn287MAX020F010, Me.btn290MAX020F010, Me.btn293MAX020F010, _
													Me.btn305MAX020F010, Me.btn308MAX020F010, Me.btn311MAX020F010, Me.btn314MAX020F010, _
													Me.btn317MAX020F010, Me.btn320MAX020F010, Me.btn323MAX020F010, Me.btn332MAX020F010, _
													Me.btn335MAX020F010, Me.btn338MAX020F010, Me.btn341MAX020F010, Me.btn344MAX020F010, _
													Me.btn347MAX020F010, Me.btn350MAX020F010, Me.btn360MAX020F010, Me.btn367MAX020F010, _
													Me.btn370MAX020F010, Me.btn373MAX020F010, Me.btn378MAX020F010, Me.btn381MAX020F010, _
													Me.btn384MAX020F010
													}

			'タブ内の実行(F8)ボタン群
			Me.btnObjs_EXEC_TAB = New System.Windows.Forms.Button() { _
													Me.btn195MAX020F010, Me.btn264MAX020F010, Me.btn294MAX020F010, Me.btn324MAX020F010, _
													Me.btn361MAX020F010, Me.btn385MAX020F010
													}

			'画面初期化時にクリアしないラベル群
			Me.lblObjs_NOCLR = New System.Windows.Forms.Label() { _
													Me.lbl003MAX020F010, Me.lbl006MAX020F010, Me.lbl055MAX020F010, Me.lbl063MAX020F010, _
													Me.lbl066MAX020F010, Me.lbl069MAX020F010, Me.lbl103MAX020F010, Me.lbl105MAX020F010, _
													Me.lbl107MAX020F010, Me.lbl109MAX020F010, Me.lbl119MAX020F010, Me.lbl121MAX020F010, _
													Me.lbl123MAX020F010, Me.lbl127MAX020F010, Me.lbl129MAX020F010, Me.lbl146MAX020F010, _
													Me.lbl148MAX020F010, Me.lbl150MAX020F010, Me.lbl185MAX020F010, Me.lbl190MAX020F010, _
													Me.lbl328MAX020F010, Me.lbl351MAX020F010, Me.lbl353MAX020F010, Me.lbl355MAX020F010, _
													Me.lbl356MAX020F010
													}

			'前回値保存対象コントロール
			Me.strLastValues = New String() { _
													Me.chk008MAX020F010.Name, Me.chk010MAX020F010.Name, Me.chk013MAX020F010.Name, Me.chk016MAX020F010.Name, _
													Me.chk019MAX020F010.Name, Me.chk022MAX020F010.Name, Me.chk025MAX020F010.Name, Me.chk028MAX020F010.Name, _
													Me.chk031MAX020F010.Name, Me.chk034MAX020F010.Name, Me.chk037MAX020F010.Name, Me.chk040MAX020F010.Name, _
													Me.chk043MAX020F010.Name, Me.chk046MAX020F010.Name, Me.chk049MAX020F010.Name, Me.chk052MAX020F010.Name, _
													Me.chk056MAX020F010.Name, Me.chk059MAX020F010.Name, Me.chk062MAX020F010.Name, Me.chk071MAX020F010.Name, _
													Me.chk073MAX020F010.Name, Me.chk076MAX020F010.Name, Me.chk079MAX020F010.Name, Me.chk082MAX020F010.Name, _
													Me.chk085MAX020F010.Name, Me.chk088MAX020F010.Name, Me.chk091MAX020F010.Name, Me.chk094MAX020F010.Name, _
													Me.chk097MAX020F010.Name, Me.chk100MAX020F010.Name, Me.chk110MAX020F010.Name, Me.chk113MAX020F010.Name, _
													Me.chk116MAX020F010.Name, Me.chk124MAX020F010.Name, Me.chk130MAX020F010.Name, Me.chk135MAX020F010.Name, _
													Me.chk143MAX020F010.Name, Me.chk152MAX020F010.Name, Me.chk155MAX020F010.Name, Me.chk158MAX020F010.Name, _
													Me.chk161MAX020F010.Name, Me.chk164MAX020F010.Name, Me.chk167MAX020F010.Name, Me.chk170MAX020F010.Name, _
													Me.chk173MAX020F010.Name, Me.chk176MAX020F010.Name, Me.chk179MAX020F010.Name, Me.chk182MAX020F010.Name, _
													Me.chk187MAX020F010.Name, Me.chk192MAX020F010.Name, Me.chk197MAX020F010.Name, Me.chk204MAX020F010.Name, _
													Me.chk207MAX020F010.Name, Me.chk210MAX020F010.Name, Me.chk213MAX020F010.Name, Me.chk216MAX020F010.Name, _
													Me.chk219MAX020F010.Name, Me.chk222MAX020F010.Name, Me.chk225MAX020F010.Name, Me.chk228MAX020F010.Name, _
													Me.chk231MAX020F010.Name, Me.chk234MAX020F010.Name, Me.chk237MAX020F010.Name, Me.chk240MAX020F010.Name, _
													Me.chk243MAX020F010.Name, Me.chk246MAX020F010.Name, Me.chk249MAX020F010.Name, Me.chk252MAX020F010.Name, _
													Me.chk255MAX020F010.Name, Me.chk258MAX020F010.Name, Me.chk261MAX020F010.Name, Me.chk266MAX020F010.Name, _
													Me.chk273MAX020F010.Name, Me.chk276MAX020F010.Name, Me.chk279MAX020F010.Name, Me.chk282MAX020F010.Name, _
													Me.chk285MAX020F010.Name, Me.chk288MAX020F010.Name, Me.chk291MAX020F010.Name, Me.chk296MAX020F010.Name, _
													Me.chk303MAX020F010.Name, Me.chk306MAX020F010.Name, Me.chk309MAX020F010.Name, Me.chk312MAX020F010.Name, _
													Me.chk315MAX020F010.Name, Me.chk318MAX020F010.Name, Me.chk321MAX020F010.Name, Me.chk326MAX020F010.Name, _
													Me.chk330MAX020F010.Name, Me.chk333MAX020F010.Name, Me.chk336MAX020F010.Name, Me.chk339MAX020F010.Name, _
													Me.chk342MAX020F010.Name, Me.chk345MAX020F010.Name, Me.chk348MAX020F010.Name, Me.chk358MAX020F010.Name, _
													Me.chk363MAX020F010.Name, Me.chk365MAX020F010.Name, Me.chk368MAX020F010.Name, Me.chk371MAX020F010.Name, _
													Me.chk374MAX020F010.Name, Me.chk376MAX020F010.Name, Me.chk379MAX020F010.Name, Me.chk382MAX020F010.Name
													}

			'コンボの設定
			Using db As New XCM.clsDB(XCM.clsSysMst.ctlConfigData)
				'診療科コンボ設定
				adat = cliComboCom.getCombo(db, XSP.clsComboCom.Enum_ComboType.Enum_M_Dept_Dsp)
				Me.cmb002MAX020F010.DataSource = adat.Copy

				'病棟コンボ設定
				adat.Dispose()
				adat = Nothing
				adat = cliComboCom.getCombo(db, XSP.clsComboCom.Enum_ComboType.Enum_M_Ward)
				Me.cmb005MAX020F010.DataSource = adat.Copy

				'病名コンボ設定
				adat.Dispose()
				adat = Nothing
				adat = cliComboCom.getCombo(db, XSP.clsComboCom.Enum_ComboType.Enum_M_DiseaseDiv)
				Me.cmb141MAX020F010.DataSource = adat.Copy

				'手術コンボ設定
				adat.Dispose()
				adat = Nothing
				adat = cliComboCom.getCombo(db, XSP.clsComboCom.Enum_ComboType.Enum_M_OpeDiv)
				Me.cmb202MAX020F010.DataSource = adat.Copy

				'治療処置コンボ設定
				adat.Dispose()
				adat = Nothing
				adat = cliComboCom.getCombo(db, XSP.clsComboCom.Enum_ComboType.Enum_M_CareDiv)
				Me.cmb271MAX020F010.DataSource = adat.Copy

				'検査コンボ設定
				adat.Dispose()
				adat = Nothing
				adat = cliComboCom.getCombo(db, XSP.clsComboCom.Enum_ComboType.Enum_M_TestDiv)
				Me.cmb301MAX020F010.DataSource = adat.Copy
			End Using

			'ラベル表示の初期条件
			'病歴番号のタイトル
			Dim strENV0001 As String = XCM.clsSysMst.ctlEnvData.getEnv(XCM.datEnv.Enum_ENV.ENV_00001)
			If String.IsNullOrEmpty(strENV0001) = False Then
				Me.chk010MAX020F010.Text = strENV0001
				Me.chk073MAX020F010.Text = strENV0001
			End If

			'終了転帰「死亡」の重複の設定により、ラベル表示を制御する
			Select Case Me.strENV0059
				Case clsConst.Enum_EndOutComeDupDeath.ImPossible
					'重複なしの場合
					Me.lbl328MAX020F010.Visible = False
					Me.lbl329MAX020F010.Visible = False
				Case clsConst.Enum_EndOutComeDupDeath.Possible
					'重複ありの場合
					Me.lbl328MAX020F010.Visible = True
					Me.lbl329MAX020F010.Visible = True
				Case Else

			End Select

			'貸出物マスタから、カルテの貸出物単位を取得する
			adat = Nothing
			Using cliLENDITM As New XSP.clsMTM_LENDITEM
				Dim tmpclr As Drawing.Color = Nothing
				adat = cliLENDITM.getLendItemOneRecDa(XCM.clsConst.Enum_Lenditem.MedicalRecord)
				For Each tmprow As DataRow In adat.Rows
					'単位を取得
					eUNIT_CD = tmprow.Item(sqlMAX020F010.itmUNIT_CD)

					'単位によってラベルの色分けを行う
					tmpclr = cliLENDITM.getUNITColor(eUNIT_CD)
					'色が取得できた場合にラベル文字色を変更する
					If tmpclr <> Drawing.Color.Empty Then
						Me.chk008MAX020F010.ForeColor = tmpclr
						Me.chk071MAX020F010.ForeColor = tmpclr
					End If
					Exit For
				Next tmprow
			End Using

			'検索条件クラスにセット
			Me.cliSearch.addContorl(clsScInpSucAhead)

			'画面初期化
			Me.ClearDsp(ENUM_SET_CONTROL.ENUM_LOAD)

		Catch ex As Exception
			Me.ErrorProc(ex)
			Me.CancelProc()
		Finally
			If adat Is Nothing = False Then
				adat.Dispose()
			End If
			adat = Nothing
			cliComboCom = Nothing
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' 未入力チェック画面＿表示
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/11/28 新規作成 ACS)福士
	''' </remarks>
	'''---------------------------------------------
	Private Sub MAX020F010_Shown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shown
		Me.log(XCM.clsSysMst.logLevel.NRM, "MAX020F010_Shown", "未入力チェック画面＿表示 Start")
		Try
			'前回値の反映
			Me.LoadLastValue(Me.strLastValues)
		Catch ex As Exception
			Me.ErrorProc(ex)
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' 未入力チェック画面＿破棄
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/11/29 新規作成 ACS)福士
	''' </remarks>
	'''---------------------------------------------
	Private Sub MAX020F010_FormClosing(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.FormClosing
		Me.log(XCM.clsSysMst.logLevel.NRM, "MAX020F010_Disposed", "未入力チェック画面＿破棄 Start")
		Try
			If Me.cancelFlg = False Then
				'前回値の保存
				Me.SaveLastValue(Me.strLastValues)
			End If
		Catch ex As Exception
			Me.ErrorProc(ex)
		Finally
			Me.strLastValues = Nothing
			Me.chkObjs_HSP = Nothing
			Me.chkObjs_CH = Nothing
			Me.chkObjs_DISEASE = Nothing
			Me.chkObjs_OPE = Nothing
			Me.chkObjs_CARE = Nothing
			Me.chkObjs_TEST = Nothing
			Me.chkObjs_DEATH = Nothing
			Me.chkObjs_STINTRO = Nothing
			Me.chkObjs_ENINTRO = Nothing
			Me.lblObjs_Cnt = Nothing
			Me.btnObjs_Prt = Nothing
			Me.lblObjs_NOCLR = Nothing
			Me.lblObjs_HSP = Nothing
			Me.lblObjs_CH = Nothing
			Me.lblObjs_DISEASE = Nothing
			Me.lblObjs_OPE = Nothing
			Me.lblObjs_CARE = Nothing
			Me.lblObjs_TEST = Nothing
			Me.lblObjs_DEATH = Nothing
			Me.lblObjs_STINTRO = Nothing
			Me.lblObjs_ENINTRO = Nothing
			Me.btnObjs_HSP = Nothing
			Me.btnObjs_CH = Nothing
			Me.btnObjs_DISEASE = Nothing
			Me.btnObjs_OPE = Nothing
			Me.btnObjs_CARE = Nothing
			Me.btnObjs_TEST = Nothing
			Me.btnObjs_DEATH = Nothing
			Me.btnObjs_STINTRO = Nothing
			Me.btnObjs_ENINTRO = Nothing
			Me.btnObjs_EXEC_TAB = Nothing
			Me.chkObjs_SEARCH = Nothing
			Me.eUNIT_CD = Nothing
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' 実行ボタン押下時処理
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/11/29 新規作成 ACS)福士<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub btnExec_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _
				btn195MAX020F010.Click, btn264MAX020F010.Click, btn294MAX020F010.Click,
				btn324MAX020F010.Click, btn361MAX020F010.Click, btn385MAX020F010.Click
		log(clsSysMst.logLevel.NRM, "btnExec_Click", "実行ボタン押下時処理 START")
		Try
			Me.Cursor = Cursors.WaitCursor
			If Me.cliSearch.getSearch(Me) = False Then Exit Sub
			Select Case sender.name
				Case Me.btn195MAX020F010.Name : Me.GetDiseaseCnt()			'病名タブ実行処理
				Case Me.btn264MAX020F010.Name : Me.GetOpeCnt()				'手術タブ実行処理
				Case Me.btn294MAX020F010.Name : Me.GetCareCnt()				'治療処置タブ実行処理
				Case Me.btn324MAX020F010.Name : Me.GetTestCnt()				'検査タブ実行処理
				Case Me.btn361MAX020F010.Name : Me.GetDeathCnt()			'死亡タブ実行処理
				Case Me.btn385MAX020F010.Name : Me.GetHspCnlCnt()			'紹介タブ実行処理
				Case Else
			End Select
		Catch ex As Exception
			Me.ErrorProc(ex)
		Finally
			Me.Cursor = Cursors.Default
		End Try
	End Sub
#End Region

#Region "メソッド"

	'''---------------------------------------------
	''' <summary>
	''' 帳票名取得処理
	''' </summary>
	''' <returns>帳票名</returns>
	''' <remarks>
	''' 2010/11/29 新規作成 ACS)福士<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Function GetPrintTitle(ByVal obtn As System.Windows.Forms.Button) As String
		Me.log(XCM.clsSysMst.logLevel.DBG, "GetPrintTitle", "帳票名取得処理 Start")
		Dim stitle As String = Nothing

		Try
			Const stitleEnd As String = "チェック処理"
			Const stitleDeath As String = "死亡"
			Const stitleIntroOrigin As String = "紹介元"
			Const stitleIntroAhead As String = "紹介先"

			'文字列取得元コントロール設定（チェックボックス）
			Select Case True
				'* 入退院歴系 *
				Case obtn Is Me.btn012MAX020F010		'病歴番号
					stitle = Me.chk010MAX020F010.Text
				Case obtn Is Me.btn015MAX020F010		'入院科歴数
					stitle = Me.chk013MAX020F010.Text
				Case obtn Is Me.btn018MAX020F010		'主科科歴数
					stitle = Me.chk016MAX020F010.Text
				Case obtn Is Me.btn021MAX020F010		'退院科歴数
					stitle = Me.chk019MAX020F010.Text
				Case obtn Is Me.btn024MAX020F010		'診療科
					stitle = Me.chk022MAX020F010.Text
				Case obtn Is Me.btn027MAX020F010		'病棟
					stitle = Me.chk025MAX020F010.Text
				Case obtn Is Me.btn030MAX020F010		'在院日数
					stitle = Me.chk028MAX020F010.Text
				Case obtn Is Me.btn033MAX020F010		'医師
					stitle = Me.chk031MAX020F010.Text
				Case obtn Is Me.btn036MAX020F010		'入院日
					stitle = Me.chk034MAX020F010.Text
				Case obtn Is Me.btn039MAX020F010		'予定・緊急
					stitle = Me.chk037MAX020F010.Text
				Case obtn Is Me.btn042MAX020F010		'入院目的
					stitle = Me.chk040MAX020F010.Text
				Case obtn Is Me.btn045MAX020F010		'入院形態
					stitle = Me.chk043MAX020F010.Text
				Case obtn Is Me.btn048MAX020F010		'救急車有無
					stitle = Me.chk046MAX020F010.Text
				Case obtn Is Me.btn051MAX020F010		'退院日
					stitle = Me.chk049MAX020F010.Text
				Case obtn Is Me.btn054MAX020F010		'退院転帰
					stitle = Me.chk052MAX020F010.Text
				Case obtn Is Me.btn061MAX020F010		'入院契機
					stitle = Me.chk059MAX020F010.Text
				Case obtn Is Me.btn065MAX020F010		'医療資源１位
					stitle = Me.chk062MAX020F010.Text.Substring(0, 4) & lbl063MAX020F010.Text.Substring(1, 2)
				Case obtn Is Me.btn068MAX020F010		'医療資源２位
					stitle = Me.chk062MAX020F010.Text.Substring(0, 4) & lbl066MAX020F010.Text
				'* 科歴系 *
				Case obtn Is Me.btn075MAX020F010		'病歴番号
					stitle = Me.chk073MAX020F010.Text
				Case obtn Is Me.btn078MAX020F010		'郵便番号
					stitle = Me.chk076MAX020F010.Text
				Case obtn Is Me.btn081MAX020F010		'診療圏
					stitle = Me.chk079MAX020F010.Text
				Case obtn Is Me.btn084MAX020F010		'診療科
					stitle = Me.chk082MAX020F010.Text
				Case obtn Is Me.btn087MAX020F010		'主病棟
					stitle = Me.chk085MAX020F010.Text
				Case obtn Is Me.btn090MAX020F010		'在院日数
					stitle = Me.chk088MAX020F010.Text
				Case obtn Is Me.btn093MAX020F010		'代表医師
					stitle = Me.chk091MAX020F010.Text
				Case obtn Is Me.btn096MAX020F010		'開始日
					stitle = Me.chk094MAX020F010.Text
				Case obtn Is Me.btn099MAX020F010		'開始時年齢
					stitle = Me.chk097MAX020F010.Text
				Case obtn Is Me.btn102MAX020F010		'開始経路
					stitle = Me.chk100MAX020F010.Text
				Case obtn Is Me.btn112MAX020F010		'終了日
					stitle = Me.chk110MAX020F010.Text
				Case obtn Is Me.btn115MAX020F010		'終了時年齢
					stitle = Me.chk113MAX020F010.Text
				Case obtn Is Me.btn118MAX020F010		'終了経路
					stitle = Me.chk116MAX020F010.Text
				Case obtn Is Me.btn126MAX020F010		'終了転帰
					stitle = Me.chk124MAX020F010.Text
				'* 病名タブ *
				Case obtn Is Me.btn137MAX020F010		'病名
					stitle = Me.chk135MAX020F010.Text
				Case obtn Is Me.btn145MAX020F010		'病名区分
					stitle = Me.chk143MAX020F010.Text
				Case obtn Is Me.btn154MAX020F010		'大分類
					stitle = Me.chk135MAX020F010.Text & Me.chk152MAX020F010.Text
				Case obtn Is Me.btn157MAX020F010		'中分類
					stitle = Me.chk135MAX020F010.Text & Me.chk155MAX020F010.Text
				Case obtn Is Me.btn160MAX020F010		'小分類
					stitle = Me.chk135MAX020F010.Text & Me.chk158MAX020F010.Text
				Case obtn Is Me.btn163MAX020F010		'３００分類
					stitle = Me.chk135MAX020F010.Text & Me.chk161MAX020F010.Text
				Case obtn Is Me.btn166MAX020F010		'a分類
					stitle = Me.chk135MAX020F010.Text & Me.chk164MAX020F010.Text
				Case obtn Is Me.btn169MAX020F010		'b分類
					stitle = Me.chk135MAX020F010.Text & Me.chk167MAX020F010.Text
				Case obtn Is Me.btn172MAX020F010		'c分類
					stitle = Me.chk135MAX020F010.Text & Me.chk170MAX020F010.Text
				Case obtn Is Me.btn175MAX020F010		'病名転帰
					stitle = Me.chk173MAX020F010.Text
				Case obtn Is Me.btn178MAX020F010		'発症日
					stitle = Me.chk135MAX020F010.Text & Me.chk176MAX020F010.Text
				Case obtn Is Me.btn181MAX020F010		'診断日
					stitle = Me.chk135MAX020F010.Text & Me.chk179MAX020F010.Text
				Case obtn Is Me.btn184MAX020F010		'終了日
					stitle = Me.chk135MAX020F010.Text & Me.chk182MAX020F010.Text
				Case obtn Is Me.btn189MAX020F010		'死因分類(クラス設計書№234)
					stitle = Me.chk135MAX020F010.Text & Me.chk187MAX020F010.Text
				Case obtn Is Me.btn194MAX020F010		'死因分類(クラス設計書№239)
					stitle = Me.chk135MAX020F010.Text & lbl190MAX020F010.Text.Substring(4, 2) & Me.chk192MAX020F010.Text
				'* 手術タブ *
				Case obtn Is Me.btn206MAX020F010		'手術区分
					stitle = Me.chk204MAX020F010.Text
				Case obtn Is Me.btn209MAX020F010		'ICD9CM
					stitle = Me.chk197MAX020F010.Text & Me.chk207MAX020F010.Text
				Case obtn Is Me.btn212MAX020F010		'大分類
					stitle = Me.chk197MAX020F010.Text & Me.chk210MAX020F010.Text
				Case obtn Is Me.btn215MAX020F010		'中分類
					stitle = Me.chk197MAX020F010.Text & Me.chk213MAX020F010.Text
				Case obtn Is Me.btn218MAX020F010		'３桁分類
					stitle = Me.chk197MAX020F010.Text & Me.chk216MAX020F010.Text
				Case obtn Is Me.btn221MAX020F010		'開始日
					stitle = Me.chk197MAX020F010.Text & Me.chk219MAX020F010.Text
				Case obtn Is Me.btn224MAX020F010		'開始時刻
					stitle = Me.chk197MAX020F010.Text & Me.chk222MAX020F010.Text
				Case obtn Is Me.btn227MAX020F010		'終了日
					stitle = Me.chk197MAX020F010.Text & Me.chk225MAX020F010.Text
				Case obtn Is Me.btn230MAX020F010		'終了時刻
					stitle = Me.chk197MAX020F010.Text & Me.chk228MAX020F010.Text
				Case obtn Is Me.btn233MAX020F010		'対応病名
					stitle = Me.chk197MAX020F010.Text & Me.chk231MAX020F010.Text
				Case obtn Is Me.btn236MAX020F010		'所要時間
					stitle = Me.chk197MAX020F010.Text & Me.chk234MAX020F010.Text
				Case obtn Is Me.btn239MAX020F010		'医師
					stitle = Me.chk197MAX020F010.Text & Me.chk237MAX020F010.Text
				Case obtn Is Me.btn242MAX020F010		'術前日数
					stitle = Me.chk197MAX020F010.Text & Me.chk240MAX020F010.Text
				Case obtn Is Me.btn245MAX020F010		'麻酔１
					stitle = Me.chk197MAX020F010.Text & Me.chk243MAX020F010.Text.Substring(0, 2)
				Case obtn Is Me.btn248MAX020F010		'補助区分１
					stitle = Me.chk197MAX020F010.Text & Me.chk246MAX020F010.Text
				Case obtn Is Me.btn251MAX020F010		'補助区分２
					stitle = Me.chk197MAX020F010.Text & Me.chk249MAX020F010.Text
				Case obtn Is Me.btn254MAX020F010		'術後日数
					stitle = Me.chk197MAX020F010.Text & Me.chk252MAX020F010.Text
				Case obtn Is Me.btn257MAX020F010		'点数表ｺｰﾄﾞ
					stitle = Me.chk197MAX020F010.Text & Me.chk255MAX020F010.Text
				Case obtn Is Me.btn260MAX020F010		'備考１
					stitle = Me.chk197MAX020F010.Text & Me.chk258MAX020F010.Text
				Case obtn Is Me.btn263MAX020F010		'備考２
					stitle = Me.chk197MAX020F010.Text & Me.chk261MAX020F010.Text
				'* 治療処置タブ *
				Case obtn Is Me.btn275MAX020F010		'治療処置区分
					stitle = Me.chk273MAX020F010.Text
				Case obtn Is Me.btn278MAX020F010		'ICD9CM
					stitle = Me.chk266MAX020F010.Text & Me.chk276MAX020F010.Text
				Case obtn Is Me.btn281MAX020F010		'大分類
					stitle = Me.chk266MAX020F010.Text & Me.chk279MAX020F010.Text
				Case obtn Is Me.btn284MAX020F010		'中分類
					stitle = Me.chk266MAX020F010.Text & Me.chk282MAX020F010.Text
				Case obtn Is Me.btn287MAX020F010		'３桁分類
					stitle = Me.chk266MAX020F010.Text & Me.chk285MAX020F010.Text
				Case obtn Is Me.btn290MAX020F010		'実施日
					stitle = Me.chk266MAX020F010.Text & Me.chk288MAX020F010.Text
				Case obtn Is Me.btn293MAX020F010		'補助区分
					stitle = Me.chk266MAX020F010.Text & Me.chk291MAX020F010.Text
				'* 検査タブ *
				Case obtn Is Me.btn305MAX020F010		'検査区分
					stitle = Me.chk303MAX020F010.Text
				Case obtn Is Me.btn308MAX020F010		'ICD9CM
					stitle = Me.chk296MAX020F010.Text & Me.chk306MAX020F010.Text
				Case obtn Is Me.btn311MAX020F010		'大分類
					stitle = Me.chk296MAX020F010.Text & Me.chk309MAX020F010.Text
				Case obtn Is Me.btn314MAX020F010		'中分類
					stitle = Me.chk296MAX020F010.Text & Me.chk312MAX020F010.Text
				Case obtn Is Me.btn317MAX020F010		'３桁分類
					stitle = Me.chk296MAX020F010.Text & Me.chk315MAX020F010.Text
				Case obtn Is Me.btn320MAX020F010		'実施日
					stitle = Me.chk296MAX020F010.Text & Me.chk318MAX020F010.Text
				Case obtn Is Me.btn323MAX020F010		'補助区分
					stitle = Me.chk296MAX020F010.Text & Me.chk321MAX020F010.Text
				'* 紹介タブ *
				Case obtn Is Me.btn367MAX020F010		'医療機関コード(開始経路が紹介)
					stitle = stitleIntroOrigin & Me.chk365MAX020F010.Text
				Case obtn Is Me.btn370MAX020F010		'医療機関名(開始経路が紹介)
					stitle = stitleIntroOrigin & Me.chk368MAX020F010.Text
				Case obtn Is Me.btn373MAX020F010		'医師名(開始経路が紹介)
					stitle = stitleIntroOrigin & Me.chk371MAX020F010.Text
				Case obtn Is Me.btn378MAX020F010		'医療機関コード(終了経路が紹介)
					stitle = stitleIntroAhead & Me.chk376MAX020F010.Text
				Case obtn Is Me.btn381MAX020F010		'医療機関名(終了経路が紹介)
					stitle = stitleIntroAhead & Me.chk379MAX020F010.Text
				Case obtn Is Me.btn384MAX020F010		'医師名(終了経路が紹介)
					stitle = stitleIntroAhead & Me.chk382MAX020F010.Text
				'* 主病名入退院 *
				Case obtn Is Me.btn058MAX020F010		'主病名（入退院歴）
					stitle = Me.chk056MAX020F010.Text
				'* 主病名科歴 *
				Case obtn Is Me.btn132MAX020F010		'主病名（科歴）
					stitle = Me.chk130MAX020F010.Text
'				'* 死亡タブ *
				Case obtn Is Me.btn332MAX020F010		'主病名
					stitle = stitleDeath & Me.chk330MAX020F010.Text
				Case obtn Is Me.btn335MAX020F010		'院内死亡
					stitle = Me.chk333MAX020F010.Text
				Case obtn Is Me.btn338MAX020F010		'死亡日
					stitle = Me.chk336MAX020F010.Text
				Case obtn Is Me.btn341MAX020F010		'死亡時刻
					stitle = Me.chk339MAX020F010.Text
				Case obtn Is Me.btn344MAX020F010		'死亡区分
					stitle = Me.chk342MAX020F010.Text
				Case obtn Is Me.btn347MAX020F010		'剖検有無
					stitle = stitleDeath & Me.chk345MAX020F010.Text.Substring(0, 2)
				Case obtn Is Me.btn350MAX020F010		'原死因
					stitle = stitleDeath & Me.chk348MAX020F010.Text.Substring(1, 2)
				Case obtn Is Me.btn360MAX020F010		'剖検番号
					stitle = stitleDeath & Me.chk358MAX020F010.Text
				Case Else

			End Select

			'文字列の結合
			stitle &= stitleEnd

			Return stitle
		Catch ex As Exception
			Throw
		End Try
	End Function

	'''---------------------------------------------
	''' <summary>
	''' 件数の取得（１回のSQL発行で件数が取得できるもの用）
	''' </summary>
	''' <returns>レコード取得件数（-1の場合は取得失敗）</returns>
	''' <remarks>
	''' 2010/11/29 新規作成 ACS)福士<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Function GetAllCnt(ByVal db As clsDB, ByVal tbltyp As Enum_SQLID) As Integer
		Me.log(XCM.clsSysMst.logLevel.DBG, "GetAllCnt", "件数の取得（１回のSQL発行で件数が取得できるもの用） Start")
		Try
			Using dat As New DataTable
				'SQL文生成、パラメータ設定
				Me.setSQL(db, Nothing, tbltyp)
				db.execQueryDa(dat)
				'件数取得
				If dat.Rows.Count > 0 Then
					Return dat.Rows(0).Item(sqlMAX020F010.itmCOUNTER)
				Else
					Return 0
				End If
			End Using
		Catch ex As Exception
			Throw
		End Try
	End Function

	'''---------------------------------------------
	''' <summary>
	''' SQL文作成
	''' </summary>
	''' <param name="db">DB操作クラス</param>
	''' <param name="sql">SQL文格納用</param>
	''' <param name="prcId">
	''' 取得SQLID
	''' （Enum_SQLID値）
	''' </param>
	''' <remarks>
	''' 2010/11/05 新規作成 ACS)福士<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Sub setSQL(ByRef db As XCM.clsDB, ByRef sql As String, Optional ByVal prcId As Integer = Nothing)
		Me.log(XCM.clsSysMst.logLevel.DBG, "setSQL", "SQL文作成 Start")
		Try
			'対象のSQL分を設定する
			Select Case prcId
				'入退院情報関連
				'入退院情報総件数
				Case Enum_SQLID.SQLID_MTI_HSP_ALL
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_HSP_ALL)

				'病歴番号件数取得用
				Case Enum_SQLID.SQLID_MTI_HSP_CHK1
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_HSP_CHK1)

				'入院科歴件数取得用
				Case Enum_SQLID.SQLID_MTI_HSP_CHK2
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_HSP_CHK2)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmHSP_FLG, XCM.clsDB.Enum_dbType.dbInt)
					db.setValDa(sqlMAX020F010.prmHSP_FLG, XCM.clsConst.Enum_CheckBox_Flg.CheckOn)

				'主科科歴件数取得用
				Case Enum_SQLID.SQLID_MTI_HSP_CHK3
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_HSP_CHK3)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmMAIN_DPM_FLG, XCM.clsDB.Enum_dbType.dbInt)
					db.setValDa(sqlMAX020F010.prmMAIN_DPM_FLG, XCM.clsConst.Enum_CheckBox_Flg.CheckOn)

				'退院科歴件数取得用
				Case Enum_SQLID.SQLID_MTI_HSP_CHK4
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_HSP_CHK4)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmOUT_HSP_FLG, XCM.clsDB.Enum_dbType.dbInt)
					db.setValDa(sqlMAX020F010.prmOUT_HSP_FLG, XCM.clsConst.Enum_CheckBox_Flg.CheckOn)

				'診療科件数取得用
				Case Enum_SQLID.SQLID_MTI_HSP_CHK5
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_HSP_CHK5)

				'病棟件数取得用
				Case Enum_SQLID.SQLID_MTI_HSP_CHK6
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_HSP_CHK6)

				'在院日数件数取得用
				Case Enum_SQLID.SQLID_MTI_HSP_CHK7
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_HSP_CHK7)

				'医師件数取得用
				Case Enum_SQLID.SQLID_MTI_HSP_CHK8
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_HSP_CHK8)

				'入院日件数取得用
				Case Enum_SQLID.SQLID_MTI_HSP_CHK9
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_HSP_CHK9)

				'予定緊急件数取得用
				Case Enum_SQLID.SQLID_MTI_HSP_CHK10
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_HSP_CHK10)

				'入院目的件数取得用
				Case Enum_SQLID.SQLID_MTI_HSP_CHK11
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_HSP_CHK11)

				'入院形態件数取得用
				Case Enum_SQLID.SQLID_MTI_HSP_CHK12
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_HSP_CHK12)

				'救急車有無件数取得用
				Case Enum_SQLID.SQLID_MTI_HSP_CHK13
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_HSP_CHK13)

				'退院日件数取得用
				Case Enum_SQLID.SQLID_MTI_HSP_CHK14
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_HSP_CHK14)

				'退院転帰件数取得用
				Case Enum_SQLID.SQLID_MTI_HSP_CHK15
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_HSP_CHK15)

				'主病名件数取得用
				Case Enum_SQLID.SQLID_MTI_HSP_CHK16
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_HSP_CHK16)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmMAIN_DPM_FLG, XCM.clsDB.Enum_dbType.dbInt)
					db.setParamDa(sqlMAX020F010.prmFIXED_CD, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setValDa(sqlMAX020F010.prmMAIN_DPM_FLG, XCM.clsConst.Enum_CheckBox_Flg.CheckOn)
					db.setValDa(sqlMAX020F010.prmFIXED_CD, XCM.clsConst.Enum_Disease_Div_Fix1.MainDisease)

				'入院契機件数取得用
				Case Enum_SQLID.SQLID_MTI_HSP_CHK17
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_HSP_CHK17)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmHSP_CHANCE_DISEASE_FLG, XCM.clsDB.Enum_dbType.dbInt)
					db.setValDa(sqlMAX020F010.prmHSP_CHANCE_DISEASE_FLG, XCM.clsConst.Enum_CheckBox_Flg.CheckOn)

				'医療資源投入１位件数取得用
				Case Enum_SQLID.SQLID_MTI_HSP_CHK18
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_HSP_CHK18)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmDISEASE_MED_RES_FLG1, XCM.clsDB.Enum_dbType.dbInt)
					db.setValDa(sqlMAX020F010.prmDISEASE_MED_RES_FLG1, XCM.clsConst.Enum_CheckBox_Flg.CheckOn)

				'医療資源投入２位件数取得用
				Case Enum_SQLID.SQLID_MTI_HSP_CHK19
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_HSP_CHK19)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmDISEASE_MED_RES_FLG2, XCM.clsDB.Enum_dbType.dbInt)
					db.setValDa(sqlMAX020F010.prmDISEASE_MED_RES_FLG2, XCM.clsConst.Enum_CheckBox_Flg.CheckOn)

				'入院科歴数印刷ボタン押下可判定用
				Case Enum_SQLID.SQLID_MTI_HSP_CHK20
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_HSP_CHK20)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmHSP_FLG, XCM.clsDB.Enum_dbType.dbInt)
					db.setValDa(sqlMAX020F010.prmHSP_FLG, XCM.clsConst.Enum_CheckBox_Flg.CheckOn)

				'主科科歴数印刷ボタン押下可判定用
				Case Enum_SQLID.SQLID_MTI_HSP_CHK21
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_HSP_CHK21)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmMAIN_DPM_FLG, XCM.clsDB.Enum_dbType.dbInt)
					db.setValDa(sqlMAX020F010.prmMAIN_DPM_FLG, XCM.clsConst.Enum_CheckBox_Flg.CheckOn)

				'退院科歴数印刷ボタン押下可判定用
				Case Enum_SQLID.SQLID_MTI_HSP_CHK22
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_HSP_CHK22)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmOUT_HSP_FLG, XCM.clsDB.Enum_dbType.dbInt)
					db.setValDa(sqlMAX020F010.prmOUT_HSP_FLG, XCM.clsConst.Enum_CheckBox_Flg.CheckOn)

				'主病名数印刷ボタン押下可判定用
				Case Enum_SQLID.SQLID_MTI_HSP_CHK23
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_HSP_CHK23)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmFIXED_CD, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setParamDa(sqlMAX020F010.prmMAIN_DPM_FLG, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setValDa(sqlMAX020F010.prmFIXED_CD, XCM.clsConst.Enum_Disease_Div_Fix1.MainDisease)
					db.setValDa(sqlMAX020F010.prmMAIN_DPM_FLG, XCM.clsConst.Enum_CheckBox_Flg.CheckOn)

				'入院契機数印刷ボタン押下可判定用
				Case Enum_SQLID.SQLID_MTI_HSP_CHK24
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_HSP_CHK24)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmHSP_CHANCE_DISEASE_FLG, XCM.clsDB.Enum_dbType.dbInt)
					db.setValDa(sqlMAX020F010.prmHSP_CHANCE_DISEASE_FLG, XCM.clsConst.Enum_CheckBox_Flg.CheckOn)

				'医療資源投入１位数印刷ボタン押下可判定用
				Case Enum_SQLID.SQLID_MTI_HSP_CHK25
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_HSP_CHK25)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmDISEASE_MED_RES_FLG1, XCM.clsDB.Enum_dbType.dbInt)
					db.setValDa(sqlMAX020F010.prmDISEASE_MED_RES_FLG1, XCM.clsConst.Enum_CheckBox_Flg.CheckOn)

				'医療資源投入２位数印刷ボタン押下可判定用
				Case Enum_SQLID.SQLID_MTI_HSP_CHK26
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_HSP_CHK26)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmDISEASE_MED_RES_FLG2, XCM.clsDB.Enum_dbType.dbInt)
					db.setValDa(sqlMAX020F010.prmDISEASE_MED_RES_FLG2, XCM.clsConst.Enum_CheckBox_Flg.CheckOn)

				'科歴情報関連
				'科歴情報総件数
				Case Enum_SQLID.SQLID_MTI_CH_ALL
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_CH_ALL)

				'病歴番号件数取得用
				Case Enum_SQLID.SQLID_MTI_CH_CHK1
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_CH_CHK1)

				'郵便番号件数取得用
				Case Enum_SQLID.SQLID_MTI_CH_CHK2
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_CH_CHK2)

				'診療圏件数取得用
				Case Enum_SQLID.SQLID_MTI_CH_CHK3
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_CH_CHK3)

				'診療科件数取得用
				Case Enum_SQLID.SQLID_MTI_CH_CHK4
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_CH_CHK4)

				'主病棟件数取得用
				Case Enum_SQLID.SQLID_MTI_CH_CHK5
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_CH_CHK5)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmMAIN_WARD_FLG, XCM.clsDB.Enum_dbType.dbInt)
					db.setValDa(sqlMAX020F010.prmMAIN_WARD_FLG, XCM.clsConst.Enum_CheckBox_Flg.CheckOn)

				'在院日数件数取得用
				Case Enum_SQLID.SQLID_MTI_CH_CHK6
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_CH_CHK6)

				'代表医師件数取得用
				Case Enum_SQLID.SQLID_MTI_CH_CHK7
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_CH_CHK7)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmMAIN_DOCTOR_FLG, XCM.clsDB.Enum_dbType.dbInt)
					db.setValDa(sqlMAX020F010.prmMAIN_DOCTOR_FLG, XCM.clsConst.Enum_CheckBox_Flg.CheckOn)

				'開始日件数取得用
				Case Enum_SQLID.SQLID_MTI_CH_CHK8
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_CH_CHK8)

				'開始時年齢件数取得用
				Case Enum_SQLID.SQLID_MTI_CH_CHK9
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_CH_CHK9)

				'開始経路件数取得用
				Case Enum_SQLID.SQLID_MTI_CH_CHK10
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_CH_CHK10)

				'開始経路(紹介)件数取得用
				Case Enum_SQLID.SQLID_MTI_CH_CHK11
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_CH_CHK11)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmFIXED_CD3, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setValDa(sqlMAX020F010.prmFIXED_CD3, XCM.clsConst.Enum_HspChannel_Fix3.Introduction)

				'開始経路(転科)件数取得用
				Case Enum_SQLID.SQLID_MTI_CH_CHK12
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_CH_CHK12)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmFIXED_CD, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setValDa(sqlMAX020F010.prmFIXED_CD, XCM.clsConst.Enum_HspChannel_Fix1.ChangeDept)

				'開始経路(兼科)件数取得用
				Case Enum_SQLID.SQLID_MTI_CH_CHK13
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_CH_CHK13)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmFIXED_CD, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setValDa(sqlMAX020F010.prmFIXED_CD, XCM.clsConst.Enum_HspChannel_Fix1.HoldDept)

				'終了日件数取得用
				Case Enum_SQLID.SQLID_MTI_CH_CHK14
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_CH_CHK14)

				'終了時年齢件数取得用
				Case Enum_SQLID.SQLID_MTI_CH_CHK15
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_CH_CHK15)

				'終了経路件数取得用
				Case Enum_SQLID.SQLID_MTI_CH_CHK16
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_CH_CHK16)

				'終了経路(紹介)件数取得用
				Case Enum_SQLID.SQLID_MTI_CH_CHK17
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_CH_CHK17)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmFIXED_CD3, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setValDa(sqlMAX020F010.prmFIXED_CD3, XCM.clsConst.Enum_DiscchargeCannel_fix2.Introduction)

				'終了経路(転科)件数取得用
				Case Enum_SQLID.SQLID_MTI_CH_CHK18
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_CH_CHK18)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmFIXED_CD, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setValDa(sqlMAX020F010.prmFIXED_CD, XCM.clsConst.Enum_DiscchargeCannel_Fix1.ChangeDept)

				'開始経路件数取得用
				Case Enum_SQLID.SQLID_MTI_CH_CHK19
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_CH_CHK19)

				'終了転帰(死亡)件数取得用
				Case Enum_SQLID.SQLID_MTI_CH_CHK20
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_CH_CHK20)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmFIXED_CD, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setValDa(sqlMAX020F010.prmFIXED_CD, XCM.clsConst.Enum_DiscchargeCannel_Fix1.Decease)

				'主病名件数取得用
				Case Enum_SQLID.SQLID_MTI_CH_CHK21
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_CH_CHK21)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmFIXED_CD, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setValDa(sqlMAX020F010.prmFIXED_CD, XCM.clsConst.Enum_Disease_Div_Fix1.MainDisease)

				'主病名数印刷ボタン押下可判定用
				Case Enum_SQLID.SQLID_MTI_CH_CHK22
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_CH_CHK22)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmFIXED_CD, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setValDa(sqlMAX020F010.prmFIXED_CD, XCM.clsConst.Enum_Disease_Div_Fix1.MainDisease)


				'病名タブ関連
				'病名総件数取得用
				Case Enum_SQLID.SQLID_MTI_DISEASE_ALL
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_DISEASE_ALL, clsMAXCOMMON.CST_TABLECD_MTI_DISEASE)

				'ICD10件数取得用
				Case Enum_SQLID.SQLID_MTI_DISEASE_CHK1
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_DISEASE_CHK1, clsMAXCOMMON.CST_TABLECD_MTI_DISEASE)

				'ICD9件数取得用
				Case Enum_SQLID.SQLID_MTI_DISEASE_CHK2
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_DISEASE_CHK2, clsMAXCOMMON.CST_TABLECD_MTI_DISEASE)

				'ICD10orICD9件数取得用
				Case Enum_SQLID.SQLID_MTI_DISEASE_CHK3
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_DISEASE_CHK3, clsMAXCOMMON.CST_TABLECD_MTI_DISEASE)

				'大分類件数取得用
				Case Enum_SQLID.SQLID_MTI_DISEASE_CHK4
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_DISEASE_CHK4, clsMAXCOMMON.CST_TABLECD_MTI_DISEASE)

				'中分類件数取得用
				Case Enum_SQLID.SQLID_MTI_DISEASE_CHK5
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_DISEASE_CHK5, clsMAXCOMMON.CST_TABLECD_MTI_DISEASE)

				'小分類件数取得用
				Case Enum_SQLID.SQLID_MTI_DISEASE_CHK6
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_DISEASE_CHK6, clsMAXCOMMON.CST_TABLECD_MTI_DISEASE)

				'３００分類件数取得用
				Case Enum_SQLID.SQLID_MTI_DISEASE_CHK7
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_DISEASE_CHK7, clsMAXCOMMON.CST_TABLECD_MTI_DISEASE)

				'a分類件数取得用
				Case Enum_SQLID.SQLID_MTI_DISEASE_CHK8
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_DISEASE_CHK8, clsMAXCOMMON.CST_TABLECD_MTI_DISEASE)

				'b分類件数取得用
				Case Enum_SQLID.SQLID_MTI_DISEASE_CHK9
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_DISEASE_CHK9, clsMAXCOMMON.CST_TABLECD_MTI_DISEASE)

				'c分類件数取得用
				Case Enum_SQLID.SQLID_MTI_DISEASE_CHK10
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_DISEASE_CHK10, clsMAXCOMMON.CST_TABLECD_MTI_DISEASE)

				'病名区分件数取得用
				Case Enum_SQLID.SQLID_MTI_DISEASE_CHK11
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_DISEASE_CHK11, clsMAXCOMMON.CST_TABLECD_MTI_DISEASE)

				'病名転帰件数取得用
				Case Enum_SQLID.SQLID_MTI_DISEASE_CHK12
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_DISEASE_CHK12, clsMAXCOMMON.CST_TABLECD_MTI_DISEASE)

				'発症日件数取得用
				Case Enum_SQLID.SQLID_MTI_DISEASE_CHK13
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_DISEASE_CHK13, clsMAXCOMMON.CST_TABLECD_MTI_DISEASE)

				'診断日件数取得用
				Case Enum_SQLID.SQLID_MTI_DISEASE_CHK14
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_DISEASE_CHK14, clsMAXCOMMON.CST_TABLECD_MTI_DISEASE)

				'終了日件数取得用
				Case Enum_SQLID.SQLID_MTI_DISEASE_CHK15
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_DISEASE_CHK15, clsMAXCOMMON.CST_TABLECD_MTI_DISEASE)

				'死因分類件数取得用
				Case Enum_SQLID.SQLID_MTI_DISEASE_CHK16
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_DISEASE_CHK16, clsMAXCOMMON.CST_TABLECD_MTI_DISEASE)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmDEATH_DISEASE_FLG, XCM.clsDB.Enum_dbType.dbInt)
					db.setValDa(sqlMAX020F010.prmDEATH_DISEASE_FLG, XCM.clsConst.Enum_CheckBox_Flg.CheckOn)

				'原死因が病名件数取得用
				Case Enum_SQLID.SQLID_MTI_DISEASE_CHK17
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_DISEASE_CHK17, clsMAXCOMMON.CST_TABLECD_MTI_DISEASE)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmDEATH_DISEASE_FLG, XCM.clsDB.Enum_dbType.dbInt)
					db.setValDa(sqlMAX020F010.prmDEATH_DISEASE_FLG, XCM.clsConst.Enum_CheckBox_Flg.CheckOn)

				'死因分類が病名件数取得用
				Case Enum_SQLID.SQLID_MTI_DISEASE_CHK18
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_DISEASE_CHK18, clsMAXCOMMON.CST_TABLECD_MTI_DISEASE)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmDEATH_CAUSE_FLG, XCM.clsDB.Enum_dbType.dbInt)
					db.setValDa(sqlMAX020F010.prmDEATH_CAUSE_FLG, XCM.clsConst.Enum_CheckBox_Flg.CheckOn)

				'原死因が外因が病名件数取得用
				Case Enum_SQLID.SQLID_MTI_DISEASE_CHK19
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_DISEASE_CHK19, clsMAXCOMMON.CST_TABLECD_MTI_DISEASE)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmDEATH_CAUSE_FLG, XCM.clsDB.Enum_dbType.dbInt)
					db.setValDa(sqlMAX020F010.prmDEATH_CAUSE_FLG, XCM.clsConst.Enum_CheckBox_Flg.CheckOn)


				'手術タブ関連
				'手術総件数取得用
				Case Enum_SQLID.SQLID_MTI_OPE_ALL
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_OPE_ALL, clsMAXCOMMON.CST_TABLECD_MTI_OPE)

				'ICD9CM件数取得用
				Case Enum_SQLID.SQLID_MTI_OPE_CHK1
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_OPE_CHK1, clsMAXCOMMON.CST_TABLECD_MTI_OPE)

				'大分類件数取得用
				Case Enum_SQLID.SQLID_MTI_OPE_CHK2
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_OPE_CHK2, clsMAXCOMMON.CST_TABLECD_MTI_OPE)

				'中分類件数取得用
				Case Enum_SQLID.SQLID_MTI_OPE_CHK3
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_OPE_CHK3, clsMAXCOMMON.CST_TABLECD_MTI_OPE)

				'３桁分類件数取得用
				Case Enum_SQLID.SQLID_MTI_OPE_CHK4
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_OPE_CHK4, clsMAXCOMMON.CST_TABLECD_MTI_OPE)

				'開始日件数取得用
				Case Enum_SQLID.SQLID_MTI_OPE_CHK5
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_OPE_CHK5, clsMAXCOMMON.CST_TABLECD_MTI_OPE)

				'開始時刻件数取得用
				Case Enum_SQLID.SQLID_MTI_OPE_CHK6
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_OPE_CHK6, clsMAXCOMMON.CST_TABLECD_MTI_OPE)

				'終了日件数取得用
				Case Enum_SQLID.SQLID_MTI_OPE_CHK7
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_OPE_CHK7, clsMAXCOMMON.CST_TABLECD_MTI_OPE)

				'終了時刻件数取得用
				Case Enum_SQLID.SQLID_MTI_OPE_CHK8
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_OPE_CHK8, clsMAXCOMMON.CST_TABLECD_MTI_OPE)

				'対応病名件数取得用
				Case Enum_SQLID.SQLID_MTI_OPE_CHK9
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_OPE_CHK9, clsMAXCOMMON.CST_TABLECD_MTI_OPE)

				'所要時間件数取得用
				Case Enum_SQLID.SQLID_MTI_OPE_CHK10
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_OPE_CHK10, clsMAXCOMMON.CST_TABLECD_MTI_OPE)

				'医師件数取得用
				Case Enum_SQLID.SQLID_MTI_OPE_CHK11
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_OPE_CHK11, clsMAXCOMMON.CST_TABLECD_MTI_OPE)

				'術前日数件数取得用
				Case Enum_SQLID.SQLID_MTI_OPE_CHK12
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_OPE_CHK12, clsMAXCOMMON.CST_TABLECD_MTI_OPE)

				'手術区分件数取得用
				Case Enum_SQLID.SQLID_MTI_OPE_CHK13
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_OPE_CHK13, clsMAXCOMMON.CST_TABLECD_MTI_OPE)

				'麻酔１件数取得用
				Case Enum_SQLID.SQLID_MTI_OPE_CHK14
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_OPE_CHK14, clsMAXCOMMON.CST_TABLECD_MTI_OPE)

				'補助区分１件数取得用
				Case Enum_SQLID.SQLID_MTI_OPE_CHK15
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_OPE_CHK15, clsMAXCOMMON.CST_TABLECD_MTI_OPE)

				'補助区分２件数取得用
				Case Enum_SQLID.SQLID_MTI_OPE_CHK16
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_OPE_CHK16, clsMAXCOMMON.CST_TABLECD_MTI_OPE)

				'術後日数件数取得用
				Case Enum_SQLID.SQLID_MTI_OPE_CHK17
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_OPE_CHK17, clsMAXCOMMON.CST_TABLECD_MTI_OPE)

				'点数表ｺｰﾄﾞ件数取得用
				Case Enum_SQLID.SQLID_MTI_OPE_CHK18
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_OPE_CHK18, clsMAXCOMMON.CST_TABLECD_MTI_OPE)

				'備考１件数取得用
				Case Enum_SQLID.SQLID_MTI_OPE_CHK19
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_OPE_CHK19, clsMAXCOMMON.CST_TABLECD_MTI_OPE)

				'備考２件数取得用
				Case Enum_SQLID.SQLID_MTI_OPE_CHK20
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_OPE_CHK20, clsMAXCOMMON.CST_TABLECD_MTI_OPE)

				'治療処理タブ関連
				'治療処置総件数取得用
				Case Enum_SQLID.SQLID_MTI_CARE_ALL
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_CARE_ALL, clsMAXCOMMON.CST_TABLECD_MTI_CARE)

				'ICD9CM件数取得用
				Case Enum_SQLID.SQLID_MTI_CARE_CHK1
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_CARE_CHK1, clsMAXCOMMON.CST_TABLECD_MTI_CARE)

				'大分類件数取得用
				Case Enum_SQLID.SQLID_MTI_CARE_CHK2
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_CARE_CHK2, clsMAXCOMMON.CST_TABLECD_MTI_CARE)

				'中分類件数取得用
				Case Enum_SQLID.SQLID_MTI_CARE_CHK3
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_CARE_CHK3, clsMAXCOMMON.CST_TABLECD_MTI_CARE)

				'３桁分類件数取得用
				Case Enum_SQLID.SQLID_MTI_CARE_CHK4
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_CARE_CHK4, clsMAXCOMMON.CST_TABLECD_MTI_CARE)

				'実施日数件数取得用
				Case Enum_SQLID.SQLID_MTI_CARE_CHK5
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_CARE_CHK5, clsMAXCOMMON.CST_TABLECD_MTI_CARE)

				'補助区分件数取得用
				Case Enum_SQLID.SQLID_MTI_CARE_CHK6
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_CARE_CHK6, clsMAXCOMMON.CST_TABLECD_MTI_CARE)

				'治療処置区分件数取得用
				Case Enum_SQLID.SQLID_MTI_CARE_CHK7
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_CARE_CHK7, clsMAXCOMMON.CST_TABLECD_MTI_CARE)


				'検査タブ関連
				'検査総件数取得用
				Case Enum_SQLID.SQLID_MTI_TEST_ALL
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_TEST_ALL, clsMAXCOMMON.CST_TABLECD_MTI_TEST)

				'ICD9CM件数取得用
				Case Enum_SQLID.SQLID_MTI_TEST_CHK1
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_TEST_CHK1, clsMAXCOMMON.CST_TABLECD_MTI_TEST)

				'大分類件数取得用
				Case Enum_SQLID.SQLID_MTI_TEST_CHK2
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_TEST_CHK2, clsMAXCOMMON.CST_TABLECD_MTI_TEST)

				'中分類件数取得用
				Case Enum_SQLID.SQLID_MTI_TEST_CHK3
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_TEST_CHK3, clsMAXCOMMON.CST_TABLECD_MTI_TEST)

				'３桁分類件数取得用
				Case Enum_SQLID.SQLID_MTI_TEST_CHK4
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_TEST_CHK4, clsMAXCOMMON.CST_TABLECD_MTI_TEST)

				'実施日件数取得用
				Case Enum_SQLID.SQLID_MTI_TEST_CHK5
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_TEST_CHK5, clsMAXCOMMON.CST_TABLECD_MTI_TEST)

				'補助区分件数取得用
				Case Enum_SQLID.SQLID_MTI_TEST_CHK6
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_TEST_CHK6, clsMAXCOMMON.CST_TABLECD_MTI_TEST)

				'検査区分件数取得用
				Case Enum_SQLID.SQLID_MTI_TEST_CHK7
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_TEST_CHK7, clsMAXCOMMON.CST_TABLECD_MTI_TEST)


				'死亡タブ関連
				'終了転帰が死亡件数取得用
				Case Enum_SQLID.SQLID_MTI_DEATH_ALL
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_DEATH_ALL)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmFIXED_CD, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setValDa(sqlMAX020F010.prmFIXED_CD, XCM.clsConst.Enum_DiscchargeOutcome_Fix1.Decease)

				'重複患者を除いた死亡件数取得用
				Case Enum_SQLID.SQLID_MTI_DEATH_CHK1
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_DEATH_CHK1)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmFIXED_CD, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setValDa(sqlMAX020F010.prmFIXED_CD, XCM.clsConst.Enum_DiscchargeOutcome_Fix1.Decease)

				'主病名件数取得用
				Case Enum_SQLID.SQLID_MTI_DEATH_CHK2
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_DEATH_CHK2)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmFIXED_CD, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setParamDa(sqlMAX020F010.prmFIXED_CD_EX, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setValDa(sqlMAX020F010.prmFIXED_CD, XCM.clsConst.Enum_DiscchargeOutcome_Fix1.Decease)
					db.setValDa(sqlMAX020F010.prmFIXED_CD_EX, XCM.clsConst.Enum_Disease_Div_Fix1.MainDisease)

				'院内死亡件数取得用
				Case Enum_SQLID.SQLID_MTI_DEATH_CHK3
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_DEATH_CHK3)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmFIXED_CD, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setParamDa(sqlMAX020F010.prmFIXED_CD_EX, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setValDa(sqlMAX020F010.prmFIXED_CD, XCM.clsConst.Enum_DiscchargeOutcome_Fix1.Decease)
					db.setValDa(sqlMAX020F010.prmFIXED_CD_EX, XCM.clsConst.Enum_Decease_Lct_Fix1.Hsp)

				'死亡日件数取得用
				Case Enum_SQLID.SQLID_MTI_DEATH_CHK4
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_DEATH_CHK4)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmFIXED_CD, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setParamDa(sqlMAX020F010.prmFIXED_CD_EX, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setValDa(sqlMAX020F010.prmFIXED_CD, XCM.clsConst.Enum_DiscchargeOutcome_Fix1.Decease)
					db.setValDa(sqlMAX020F010.prmFIXED_CD_EX, XCM.clsConst.Enum_Decease_Lct_Fix1.Hsp)

				'死亡時刻件数取得用
				Case Enum_SQLID.SQLID_MTI_DEATH_CHK5
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_DEATH_CHK5)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmFIXED_CD, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setParamDa(sqlMAX020F010.prmFIXED_CD_EX, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setValDa(sqlMAX020F010.prmFIXED_CD, XCM.clsConst.Enum_DiscchargeOutcome_Fix1.Decease)
					db.setValDa(sqlMAX020F010.prmFIXED_CD_EX, XCM.clsConst.Enum_Decease_Lct_Fix1.Hsp)

				'死亡区分件数取得用
				Case Enum_SQLID.SQLID_MTI_DEATH_CHK6
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_DEATH_CHK6)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmFIXED_CD, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setParamDa(sqlMAX020F010.prmFIXED_CD_EX, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setValDa(sqlMAX020F010.prmFIXED_CD, XCM.clsConst.Enum_DiscchargeOutcome_Fix1.Decease)
					db.setValDa(sqlMAX020F010.prmFIXED_CD_EX, XCM.clsConst.Enum_Decease_Lct_Fix1.Hsp)

				'剖検有無件数取得用
				Case Enum_SQLID.SQLID_MTI_DEATH_CHK7
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_DEATH_CHK7)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmFIXED_CD, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setParamDa(sqlMAX020F010.prmFIXED_CD_EX, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setValDa(sqlMAX020F010.prmFIXED_CD, XCM.clsConst.Enum_DiscchargeOutcome_Fix1.Decease)
					db.setValDa(sqlMAX020F010.prmFIXED_CD_EX, XCM.clsConst.Enum_Decease_Lct_Fix1.Hsp)

				'原死因件数取得用
				Case Enum_SQLID.SQLID_MTI_DEATH_CHK8
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_DEATH_CHK8)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmFIXED_CD, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setParamDa(sqlMAX020F010.prmDEATH_DISEASE_FLG, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setParamDa(sqlMAX020F010.prmDEATH_CAUSE_FLG, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setValDa(sqlMAX020F010.prmFIXED_CD, XCM.clsConst.Enum_DiscchargeOutcome_Fix1.Decease)
					db.setValDa(sqlMAX020F010.prmDEATH_DISEASE_FLG, XCM.clsConst.Enum_CheckBox_Flg.CheckOn)
					db.setValDa(sqlMAX020F010.prmDEATH_CAUSE_FLG, XCM.clsConst.Enum_CheckBox_Flg.CheckOn)

				'原死因（病名死因）件数取得用
				Case Enum_SQLID.SQLID_MTI_DEATH_CHK9
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_DEATH_CHK9)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmFIXED_CD, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setParamDa(sqlMAX020F010.prmDEATH_DISEASE_FLG, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setValDa(sqlMAX020F010.prmFIXED_CD, XCM.clsConst.Enum_DiscchargeOutcome_Fix1.Decease)
					db.setValDa(sqlMAX020F010.prmDEATH_DISEASE_FLG, XCM.clsConst.Enum_CheckBox_Flg.CheckOn)

				'原死因（外因死因）件数取得用
				Case Enum_SQLID.SQLID_MTI_DEATH_CHK10
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_DEATH_CHK10)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmFIXED_CD, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setParamDa(sqlMAX020F010.prmDEATH_CAUSE_FLG, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setValDa(sqlMAX020F010.prmFIXED_CD, XCM.clsConst.Enum_DiscchargeOutcome_Fix1.Decease)
					db.setValDa(sqlMAX020F010.prmDEATH_CAUSE_FLG, XCM.clsConst.Enum_CheckBox_Flg.CheckOn)

				'剖検区分が有件数取得用
				Case Enum_SQLID.SQLID_MTI_DEATH_CHK11
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_DEATH_CHK11)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmFIXED_CD, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setParamDa(sqlMAX020F010.prmFIXED_CD_EX, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setParamDa(sqlMAX020F010.prmAUTOPSY_CHK, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setValDa(sqlMAX020F010.prmFIXED_CD, XCM.clsConst.Enum_DiscchargeOutcome_Fix1.Decease)
					db.setValDa(sqlMAX020F010.prmFIXED_CD_EX, XCM.clsConst.Enum_Decease_Lct_Fix1.Hsp)
					db.setValDa(sqlMAX020F010.prmAUTOPSY_CHK, XCM.clsConst.Enum_Chk.ChkOn)

				'剖検番号が有件数取得用
				Case Enum_SQLID.SQLID_MTI_DEATH_CHK12
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_DEATH_CHK12)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmFIXED_CD, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setParamDa(sqlMAX020F010.prmFIXED_CD_EX, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setValDa(sqlMAX020F010.prmFIXED_CD, XCM.clsConst.Enum_DiscchargeOutcome_Fix1.Decease)
					db.setValDa(sqlMAX020F010.prmFIXED_CD_EX, XCM.clsConst.Enum_Decease_Lct_Fix1.Hsp)


				'紹介タブ関連
				'開始経路紹介件数取得用
				Case Enum_SQLID.SQLID_MTI_HSP_CNL_ALL
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_HSP_CNL_ALL)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmFIXED_CD3, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setValDa(sqlMAX020F010.prmFIXED_CD3, XCM.clsConst.Enum_HspChannel_Fix3.Introduction)

				'医療機関コード件数取得用(開始経路が紹介)
				Case Enum_SQLID.SQLID_MTI_HSP_CNL_CHK1
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_HSP_CNL_CHK1)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmFIXED_CD3, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setValDa(sqlMAX020F010.prmFIXED_CD3, XCM.clsConst.Enum_HspChannel_Fix3.Introduction)

				'医療機関名件数取得用(開始経路が紹介)
				Case Enum_SQLID.SQLID_MTI_HSP_CNL_CHK2
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_HSP_CNL_CHK2)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmFIXED_CD3, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setValDa(sqlMAX020F010.prmFIXED_CD3, XCM.clsConst.Enum_HspChannel_Fix3.Introduction)

				'医師名件数取得用(開始経路が紹介)
				Case Enum_SQLID.SQLID_MTI_HSP_CNL_CHK3
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_HSP_CNL_CHK3)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmFIXED_CD3, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setValDa(sqlMAX020F010.prmFIXED_CD3, XCM.clsConst.Enum_HspChannel_Fix3.Introduction)

				'終了経路紹介件数取得用
				Case Enum_SQLID.SQLID_MTI_HSP_CNL_CHK4
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_HSP_CNL_CHK4)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmFIXED_CD3, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setValDa(sqlMAX020F010.prmFIXED_CD3, XCM.clsConst.Enum_DiscchargeCannel_fix2.Introduction)

				'医療機関コード件数取得用(終了経路が紹介)
				Case Enum_SQLID.SQLID_MTI_HSP_CNL_CHK5
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_HSP_CNL_CHK5)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmFIXED_CD3, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setValDa(sqlMAX020F010.prmFIXED_CD3, XCM.clsConst.Enum_DiscchargeCannel_fix2.Introduction)

				'医療機関名件数取得用(終了経路が紹介)
				Case Enum_SQLID.SQLID_MTI_HSP_CNL_CHK6
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_HSP_CNL_CHK6)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmFIXED_CD3, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setValDa(sqlMAX020F010.prmFIXED_CD3, XCM.clsConst.Enum_DiscchargeCannel_fix2.Introduction)

				'医師名件数取得用(終了経路が紹介)
				Case Enum_SQLID.SQLID_MTI_HSP_CNL_CHK7
					Me.setSubSql(db, sqlMAX020F010.sqlSel_MTI_HSP_CNL_CHK7)
					'追加設定パラメータ
					db.setParamDa(sqlMAX020F010.prmFIXED_CD3, XCM.clsDB.Enum_dbType.dbNVarChar)
					db.setValDa(sqlMAX020F010.prmFIXED_CD3, XCM.clsConst.Enum_DiscchargeCannel_fix2.Introduction)

				Case Else

			End Select
		Catch ex As Exception
			Throw
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' SQL文作成
	''' </summary>
	''' <remarks>
	''' 2011/11/17 新規作成 ACS)仙頭<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Sub setSubSql(ByRef db As XCM.clsDB, ByVal sql As String, Optional ByVal addTblCd As String = Nothing)
		Me.log(XCM.clsSysMst.logLevel.DBG, "setSubSql", "SQL文作成 Start")
		Dim where As String = Nothing
		Try
			where = Me.cliSearch.getSqlWhere(Me.sTBL_CD)
			If addTblCd IsNot Nothing Then
				where &= Me.cliSearch.getSqlWhere(addTblCd)
			End If
			db.setSQLDa(String.Format(sql, where))
			If Debugger.IsAttached = True Then Debug.Print(String.Format(sql, where))
			Me.cliSearch.setDbParamDa(db, Me.sTBL_CD)
			If addTblCd IsNot Nothing Then
				Me.cliSearch.setDbParamDa(db, addTblCd)
			End If

		Catch ex As Exception
			Throw
		Finally
			where = Nothing
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' 病名タブ実行処理
	''' </summary>
	''' <remarks>
	''' 2010/11/29 新規作成 ACS)福士<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Sub GetDiseaseCnt()
		Me.log(XCM.clsSysMst.logLevel.DBG, "GetDiseaseCnt", "病名タブ実行処理 Start")
		Dim icnt As Integer = 0

		Try
			Using db As New XCM.clsDB(XCM.clsSysMst.ctlConfigData)
				'病名タブ関連
				'病名総件数の取得
				icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_DISEASE_ALL)
				If icnt >= 0 Then
					Me.lbl136MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
					Me.lbl136MAX020F010.Refresh()
				End If

				'ICD10件数の取得
				icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_DISEASE_CHK1)
				If icnt >= 0 Then
					Me.lbl147MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
					Me.lbl147MAX020F010.Refresh()
				End If

				'ICD9件数の取得
				icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_DISEASE_CHK2)
				If icnt >= 0 Then
					Me.lbl149MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
					Me.lbl149MAX020F010.Refresh()
				End If

				'ICD10orICD9件数の取得
				icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_DISEASE_CHK3)
				If icnt >= 0 Then
					Me.lbl151MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
					Me.lbl151MAX020F010.Refresh()
				End If

				'大分類件数の取得
				If Me.chk152MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_DISEASE_CHK4)
					If icnt >= 0 Then
						Me.lbl153MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl153MAX020F010.Refresh()
					End If
				End If

				'中分類件数の取得
				If Me.chk155MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_DISEASE_CHK5)
					If icnt >= 0 Then
						Me.lbl156MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl156MAX020F010.Refresh()
					End If
				End If

				'小分類件数の取得
				If Me.chk158MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_DISEASE_CHK6)
					If icnt >= 0 Then
						Me.lbl159MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl159MAX020F010.Refresh()
					End If
				End If

				'３００分類件数の取得
				If Me.chk161MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_DISEASE_CHK7)
					If icnt >= 0 Then
						Me.lbl162MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl162MAX020F010.Refresh()
					End If
				End If

				'a分類件数の取得
				If Me.chk164MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_DISEASE_CHK8)
					If icnt >= 0 Then
						Me.lbl165MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl165MAX020F010.Refresh()
					End If
				End If

				'b分類件数の取得
				If Me.chk167MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_DISEASE_CHK9)
					If icnt >= 0 Then
						Me.lbl168MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl168MAX020F010.Refresh()
					End If
				End If

				'c分類件数の取得
				If Me.chk170MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_DISEASE_CHK10)
					If icnt >= 0 Then
						Me.lbl171MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl171MAX020F010.Refresh()
					End If
				End If

				'病名区分件数の取得
				If Me.chk143MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_DISEASE_CHK11)
					If icnt >= 0 Then
						Me.lbl144MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl144MAX020F010.Refresh()
					End If
				End If

				'病名転帰件数の取得
				If Me.chk173MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_DISEASE_CHK12)
					If icnt >= 0 Then
						Me.lbl174MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl174MAX020F010.Refresh()
					End If
				End If

				'発症日件数の取得
				If Me.chk176MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_DISEASE_CHK13)
					If icnt >= 0 Then
						Me.lbl177MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl177MAX020F010.Refresh()
					End If
				End If

				'診断日件数の取得
				If Me.chk179MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_DISEASE_CHK14)
					If icnt >= 0 Then
						Me.lbl180MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl180MAX020F010.Refresh()
					End If
				End If

				'終了日件数の取得
				If Me.chk182MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_DISEASE_CHK15)
					If icnt >= 0 Then
						Me.lbl183MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl183MAX020F010.Refresh()
					End If
				End If

				'死因分類件数の取得
				If Me.chk187MAX020F010.Checked = True Then
					'原死因が病名件数の取得
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_DISEASE_CHK16)
					If icnt >= 0 Then
						Me.lbl186MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl186MAX020F010.Refresh()
					End If
					'死因分類件数の取得
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_DISEASE_CHK17)
					If icnt >= 0 Then
						Me.lbl188MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl188MAX020F010.Refresh()
					End If
				End If

				'死因分類件数の取得
				If Me.chk192MAX020F010.Checked = True Then
					'原死因が病名件数の取得
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_DISEASE_CHK18)
					If icnt >= 0 Then
						Me.lbl191MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl191MAX020F010.Refresh()
					End If
					'死因分類件数の取得
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_DISEASE_CHK19)
					If icnt >= 0 Then
						Me.lbl193MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl193MAX020F010.Refresh()
					End If
				End If
			End Using

			'印刷ボタン使用可否制御（タブ用）
			Me.ChangePrtBtnAttrTabs()

			Me.showMsg("I0006", "検索", Nothing)	'終了メッセージ出力

		Catch ex As Exception
			Throw
		End Try

	End Sub

	'''---------------------------------------------
	''' <summary>
	''' 手術タブ実行処理
	''' </summary>
	''' <remarks>
	''' 2010/11/29 新規作成 ACS)福士<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Sub GetOpeCnt()
		Me.log(XCM.clsSysMst.logLevel.DBG, "GetOpeCnt", "手術タブ実行処理 Start")
		Dim icnt As Integer = 0
		Try
			Using db As New XCM.clsDB(XCM.clsSysMst.ctlConfigData)
				'手術タブ関連
				'手術総件数の取得
				icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_OPE_ALL)
				If icnt >= 0 Then
					Me.lbl198MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
					Me.lbl198MAX020F010.Refresh()
				End If

				'ICD9CM件数の取得
				If Me.chk207MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_OPE_CHK1)
					If icnt >= 0 Then
						Me.lbl208MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl208MAX020F010.Refresh()
					End If
				End If

				'大分類件数の取得
				If Me.chk210MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_OPE_CHK2)
					If icnt >= 0 Then
						Me.lbl211MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl211MAX020F010.Refresh()
					End If
				End If

				'中分類件数の取得
				If Me.chk213MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_OPE_CHK3)
					If icnt >= 0 Then
						Me.lbl214MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl214MAX020F010.Refresh()
					End If
				End If

				'３桁分類件数の取得
				If Me.chk216MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_OPE_CHK4)
					If icnt >= 0 Then
						Me.lbl217MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl217MAX020F010.Refresh()
					End If
				End If

				'開始日件数の取得
				If Me.chk219MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_OPE_CHK5)
					If icnt >= 0 Then
						Me.lbl220MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl220MAX020F010.Refresh()
					End If
				End If

				'開始時刻件数の取得
				If Me.chk222MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_OPE_CHK6)
					If icnt >= 0 Then
						Me.lbl223MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl223MAX020F010.Refresh()
					End If
				End If

				'終了日件数の取得
				If Me.chk225MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_OPE_CHK7)
					If icnt >= 0 Then
						Me.lbl226MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl226MAX020F010.Refresh()
					End If
				End If

				'終了時刻件数の取得
				If Me.chk228MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_OPE_CHK8)
					If icnt >= 0 Then
						Me.lbl229MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl229MAX020F010.Refresh()
					End If
				End If

				'対応病名件数の取得
				If Me.chk231MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_OPE_CHK9)
					If icnt >= 0 Then
						Me.lbl232MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl232MAX020F010.Refresh()
					End If
				End If

				'所要時間件数の取得
				If Me.chk234MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_OPE_CHK10)
					If icnt >= 0 Then
						Me.lbl235MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl235MAX020F010.Refresh()
					End If
				End If

				'医師件数の取得
				If Me.chk237MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_OPE_CHK11)
					If icnt >= 0 Then
						Me.lbl238MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl238MAX020F010.Refresh()
					End If
				End If

				'術前日数件数の取得
				If Me.chk240MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_OPE_CHK12)
					If icnt >= 0 Then
						Me.lbl241MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl241MAX020F010.Refresh()
					End If
				End If

				'手術区分件数の取得
				If Me.chk204MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_OPE_CHK13)
					If icnt >= 0 Then
						Me.lbl205MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl205MAX020F010.Refresh()
					End If
				End If

				'麻酔１件数の取得
				If Me.chk243MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_OPE_CHK14)
					If icnt >= 0 Then
						Me.lbl244MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl244MAX020F010.Refresh()
					End If
				End If

				'補助区分１件数の取得
				If Me.chk246MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_OPE_CHK15)
					If icnt >= 0 Then
						Me.lbl247MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl247MAX020F010.Refresh()
					End If
				End If

				'補助区分２件数の取得
				If Me.chk249MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_OPE_CHK16)
					If icnt >= 0 Then
						Me.lbl250MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl250MAX020F010.Refresh()
					End If
				End If

				'術後日数件数の取得
				If Me.chk252MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_OPE_CHK17)
					If icnt >= 0 Then
						Me.lbl253MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl253MAX020F010.Refresh()
					End If
				End If

				'点数表ｺｰﾄﾞ件数の取得
				If Me.chk255MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_OPE_CHK18)
					If icnt >= 0 Then
						Me.lbl256MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl256MAX020F010.Refresh()
					End If
				End If

				'備考１件数の取得
				If Me.chk258MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_OPE_CHK19)
					If icnt >= 0 Then
						Me.lbl259MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl259MAX020F010.Refresh()
					End If
				End If

				'備考２件数の取得
				If Me.chk261MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_OPE_CHK20)
					If icnt >= 0 Then
						Me.lbl262MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl262MAX020F010.Refresh()
					End If
				End If

			End Using

			'印刷ボタン使用可否制御（タブ用）
			Me.ChangePrtBtnAttrTabs()

			Me.showMsg("I0006", "検索", Nothing)	'終了メッセージ出力

		Catch ex As Exception
			Throw
		End Try

	End Sub

	'''---------------------------------------------
	''' <summary>
	''' 治療処置タブ実行処理
	''' </summary>
	''' <remarks>
	''' 2010/11/29 新規作成 ACS)福士<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Sub GetCareCnt()
		Me.log(XCM.clsSysMst.logLevel.DBG, "GetCareCnt", "治療処置タブ実行処理 Start")
		Dim icnt As Integer = 0
		Try
			Using db As New XCM.clsDB(XCM.clsSysMst.ctlConfigData)
				'治療処置タブ関連
				'治療処置総件数の取得
				icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_CARE_ALL)
				If icnt >= 0 Then
					Me.lbl267MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
					Me.lbl267MAX020F010.Refresh()
				End If

				'ICD9CM件数の取得
				If Me.chk276MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_CARE_CHK1)
					If icnt >= 0 Then
						Me.lbl277MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl277MAX020F010.Refresh()
					End If
				End If

				'大分類件数の取得
				If Me.chk279MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_CARE_CHK2)
					If icnt >= 0 Then
						Me.lbl280MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl280MAX020F010.Refresh()
					End If
				End If

				'中分類件数の取得
				If Me.chk282MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_CARE_CHK3)
					If icnt >= 0 Then
						Me.lbl283MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl283MAX020F010.Refresh()
					End If
				End If

				'３桁分類件数の取得
				If Me.chk285MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_CARE_CHK4)
					If icnt >= 0 Then
						Me.lbl286MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl286MAX020F010.Refresh()
					End If
				End If

				'実施日数件数取得用
				If Me.chk288MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_CARE_CHK5)
					If icnt >= 0 Then
						Me.lbl289MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl289MAX020F010.Refresh()
					End If
				End If

				'補助区分件数取得用
				If Me.chk291MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_CARE_CHK6)
					If icnt >= 0 Then
						Me.lbl292MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl292MAX020F010.Refresh()
					End If
				End If

				'治療処置区分件数取得用
				If Me.chk273MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_CARE_CHK7)
					If icnt >= 0 Then
						Me.lbl274MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl274MAX020F010.Refresh()
					End If
				End If
			End Using

			'印刷ボタン使用可否制御（タブ用）
			Me.ChangePrtBtnAttrTabs()

			Me.showMsg("I0006", "検索", Nothing)	'終了メッセージ出力

		Catch ex As Exception
			Throw
		Finally
			Me.Cursor = Cursors.Default
		End Try

	End Sub

	'''---------------------------------------------
	''' <summary>
	''' 検査タブ実行処理
	''' </summary>
	''' <remarks>
	''' 2010/11/29 新規作成 ACS)福士<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Sub GetTestCnt()
		Me.log(XCM.clsSysMst.logLevel.DBG, "GetTestCnt", "検査タブ実行処理 Start")
		Dim icnt As Integer = 0

		Try
			Using db As New XCM.clsDB(XCM.clsSysMst.ctlConfigData)
				'検査タブ関連
				'検査総件数の取得
				icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_TEST_ALL)
				If icnt >= 0 Then
					Me.lbl297MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
					Me.lbl297MAX020F010.Refresh()
				End If

				'ICD9CM件数の取得
				If Me.chk306MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_TEST_CHK1)
					If icnt >= 0 Then
						Me.lbl307MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl307MAX020F010.Refresh()
					End If
				End If

				'大分類件数の取得
				If Me.chk309MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_TEST_CHK2)
					If icnt >= 0 Then
						Me.lbl310MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl310MAX020F010.Refresh()
					End If
				End If

				'中分類件数の取得
				If Me.chk312MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_TEST_CHK3)
					If icnt >= 0 Then
						Me.lbl313MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl313MAX020F010.Refresh()
					End If
				End If

				'３桁分類件数の取得
				If Me.chk315MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_TEST_CHK4)
					If icnt >= 0 Then
						Me.lbl316MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl316MAX020F010.Refresh()
					End If
				End If

				'実施日件数の取得
				If Me.chk318MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_TEST_CHK5)
					If icnt >= 0 Then
						Me.lbl319MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl319MAX020F010.Refresh()
					End If
				End If

				'補助区分件数の取得
				If Me.chk321MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_TEST_CHK6)
					If icnt >= 0 Then
						Me.lbl322MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl322MAX020F010.Refresh()
					End If
				End If

				'検査区分件数の取得
				If Me.chk303MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_TEST_CHK7)
					If icnt >= 0 Then
						Me.lbl304MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl304MAX020F010.Refresh()
					End If
				End If
			End Using

			'印刷ボタン使用可否制御（タブ用）
			Me.ChangePrtBtnAttrTabs()

			Me.showMsg("I0006", "検索", Nothing)	'終了メッセージ出力

		Catch ex As Exception
			Throw
		End Try

	End Sub

	'''---------------------------------------------
	''' <summary>
	''' 死亡タブ実行処理
	''' </summary>
	''' <remarks>
	''' 2010/11/29 新規作成 ACS)福士<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Sub GetDeathCnt()
		Me.log(XCM.clsSysMst.logLevel.DBG, "GetDeathCnt", "死亡タブ実行処理 Start")
		Dim icnt As Integer = 0
		Try

			Using db As New XCM.clsDB(XCM.clsSysMst.ctlConfigData)

				'死亡タブ関連
				'終了転帰が死亡件数の取得
				icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_DEATH_ALL)
				If icnt >= 0 Then
					Me.lbl327MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
					Me.lbl327MAX020F010.Refresh()
				End If

				'重複患者を除いた死亡件数の取得
				icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_DEATH_CHK1)
				If icnt >= 0 Then
					Me.lbl329MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
					Me.lbl329MAX020F010.Refresh()
				End If

				'主病名件数の取得
				If Me.chk330MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_DEATH_CHK2)
					If icnt >= 0 Then
						Me.lbl331MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl331MAX020F010.Refresh()
					End If
				End If

				'院内死亡件数の取得
				If Me.chk333MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_DEATH_CHK3)
					If icnt >= 0 Then
						Me.lbl334MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl334MAX020F010.Refresh()
					End If
				End If

				'死亡日件数の取得
				If Me.chk336MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_DEATH_CHK4)
					If icnt >= 0 Then
						Me.lbl337MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl337MAX020F010.Refresh()
					End If
				End If

				'死亡時刻件数の取得
				If Me.chk339MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_DEATH_CHK5)
					If icnt >= 0 Then
						Me.lbl340MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl340MAX020F010.Refresh()
					End If
				End If

				'死亡区分件数の取得
				If Me.chk342MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_DEATH_CHK6)
					If icnt >= 0 Then
						Me.lbl343MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl343MAX020F010.Refresh()
					End If
				End If

				'剖検有無件数の取得
				If Me.chk345MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_DEATH_CHK7)
					If icnt >= 0 Then
						Me.lbl346MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl346MAX020F010.Refresh()
					End If
				End If

				'原死因件数の取得
				If Me.chk348MAX020F010.Checked = True Then
					'原死因件数の取得
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_DEATH_CHK8)
					If icnt >= 0 Then
						Me.lbl349MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl349MAX020F010.Refresh()
					End If
					'原死因（病名死因）件数の取得
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_DEATH_CHK9)
					If icnt >= 0 Then
						Me.lbl352MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl352MAX020F010.Refresh()
					End If
					'原死因（外因死因）件数の取得
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_DEATH_CHK10)
					If icnt >= 0 Then
						Me.lbl354MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl354MAX020F010.Refresh()
					End If
				End If

				'剖検区分件数の取得
				icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_DEATH_CHK11)
				If icnt >= 0 Then
					Me.lbl357MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
					Me.lbl357MAX020F010.Refresh()
				End If

				'剖検番号件数の取得
				If Me.chk358MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_DEATH_CHK12)
					If icnt >= 0 Then
						Me.lbl359MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl359MAX020F010.Refresh()
					End If
				End If
			End Using

			'印刷ボタン使用可否制御（タブ用）
			Me.ChangePrtBtnAttrTabs()

			Me.showMsg("I0006", "検索", Nothing)	'終了メッセージ出力

		Catch ex As Exception
			Throw
		End Try

	End Sub

	'''---------------------------------------------
	''' <summary>
	''' 紹介タブ実行処理
	''' </summary>
	''' <remarks>
	''' 2010/11/29 新規作成 ACS)福士<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Sub GetHspCnlCnt()
		Me.log(XCM.clsSysMst.logLevel.DBG, "GetHspCnlCnt", "紹介タブ実行処理 Start")
		Dim icnt As Integer = 0
		Try
			Using db As New XCM.clsDB(XCM.clsSysMst.ctlConfigData)
				'紹介タブ関連
				'開始経路紹介件数の取得
				icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_HSP_CNL_ALL)
				If icnt >= 0 Then
					Me.lbl364MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
					Me.lbl364MAX020F010.Refresh()
				End If

				'医療機関コード件数の取得(開始経路が紹介)
				If Me.chk365MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_HSP_CNL_CHK1)
					If icnt >= 0 Then
						Me.lbl366MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl366MAX020F010.Refresh()
					End If
				End If

				'医療機関名件数の取得(開始経路が紹介)
				If Me.chk368MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_HSP_CNL_CHK2)
					If icnt >= 0 Then
						Me.lbl369MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl369MAX020F010.Refresh()
					End If
				End If

				'医師名件数の取得(開始経路が紹介)
				If Me.chk371MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_HSP_CNL_CHK3)
					If icnt >= 0 Then
						Me.lbl372MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl372MAX020F010.Refresh()
					End If
				End If

				'終了経路紹介件数の取得
				icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_HSP_CNL_CHK4)
				If icnt >= 0 Then
					Me.lbl375MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
					Me.lbl375MAX020F010.Refresh()
				End If

				'医療機関コード件数の取得(終了経路が紹介)
				If Me.chk376MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_HSP_CNL_CHK5)
					If icnt >= 0 Then
						Me.lbl377MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl377MAX020F010.Refresh()
					End If
				End If

				'医療機関名件数の取得(終了経路が紹介)
				If Me.chk379MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_HSP_CNL_CHK6)
					If icnt >= 0 Then
						Me.lbl380MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl380MAX020F010.Refresh()
					End If
				End If

				'医師名件数の取得(終了経路が紹介)
				If Me.chk382MAX020F010.Checked = True Then
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_HSP_CNL_CHK7)
					If icnt >= 0 Then
						Me.lbl383MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl383MAX020F010.Refresh()
					End If
				End If
			End Using

			'印刷ボタン使用可否制御（タブ用）
			Me.ChangePrtBtnAttrTabs()

			Me.showMsg("I0006", "検索", Nothing)	'終了メッセージ出力

		Catch ex As Exception
			Throw
		Finally
			Me.Cursor = Cursors.Default
		End Try

	End Sub

	'''---------------------------------------------
	''' <summary>
	''' 印刷ボタン使用可否制御
	''' </summary>
	''' <remarks>
	''' 2010/11/29 新規作成 ACS)福士<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Sub ChangePrtBtnAttr()
		Me.log(XCM.clsSysMst.logLevel.DBG, "ChangePrtBtnAttr", "印刷ボタン使用可否制御 Start")

		Try
			Dim icnt As Integer = 0
			Dim iidx As Integer = 0
			Dim flg As Boolean = False	'True:印刷ボタン押下可
			Using db As New XCM.clsDB(XCM.clsSysMst.ctlConfigData)


				'入退院側の条件が有効の場合
				If Me.chk025MAX000F020.Checked = True OrElse _
					Me.chk029MAX000F020.Checked = True OrElse _
					Me.chk031MAX000F020.Checked = True Then

					'入退院歴
					For Each lbl As System.Windows.Forms.Label In lblObjs_HSP
						Select Case lbl.Name
							'入院科歴
							Case Me.lbl014MAX020F010.Name
								If Me.chk013MAX020F010.Checked = True Then
									'異常データが存在すれば押下可能に
									icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_HSP_CHK20)
									If icnt > 0 Then
										flg = True
									End If
								End If
							'主科科歴
							Case Me.lbl017MAX020F010.Name
								If Me.chk016MAX020F010.Checked = True Then
									'異常データが存在すれば押下可能に
									icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_HSP_CHK21)
									If icnt > 0 Then
										flg = True
									End If
								End If
							'退院科歴
							Case Me.lbl020MAX020F010.Name
								If Me.chk019MAX020F010.Checked = True Then
									'異常データが存在すれば押下可能に
									icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_HSP_CHK22)
									If icnt > 0 Then
										flg = True
									End If
								End If
							'主病名
							Case Me.lbl057MAX020F010.Name
								If Me.chk056MAX020F010.Checked = True Then
									'管理単位を取得しSQLを決定
									Select Case eUNIT_CD
										Case XCM.clsConst.Enum_LendUnit.Each_Patient, XCM.clsConst.Enum_LendUnit.Each_Hosp, XCM.clsConst.Enum_LendUnit.Each_Dept
											'異常データが存在すれば押下可能に
											icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_HSP_CHK23)
											If icnt > 0 Then
												flg = True
											End If
										Case Else
											'処理しない
									End Select
								End If
							'入院契機
							Case Me.lbl060MAX020F010.Name
								If Me.chk059MAX020F010.Checked = True Then
									'異常データが存在すれば押下可能に
									icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_HSP_CHK24)
									If icnt > 0 Then
										flg = True
									End If
								End If
							'医療資源１位
							Case Me.lbl064MAX020F010.Name
								If Me.chk062MAX020F010.Checked = True Then
									'異常データが存在すれば押下可能に
									icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_HSP_CHK25)
									If icnt > 0 Then
										flg = True
									End If
								End If
							'医療資源２位
							Case Me.lbl067MAX020F010.Name
								If Me.chk062MAX020F010.Checked = True Then
									'異常データが存在すれば押下可能に
									icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_HSP_CHK26)
									If icnt > 0 Then
										flg = True
									End If
								End If
							'上記以外
							Case Else
								'入退院総件数と比較
								If String.IsNullOrEmpty(Me.lbl009MAX020F010.Text) = False AndAlso _
									CInt(Me.lbl009MAX020F010.Text) > 0 Then
									If Me.lbl009MAX020F010.Text <> lbl.Text AndAlso _
									lbl.Text <> String.Empty Then
										flg = True
									End If
								End If
						End Select

						'印刷ボタン制御
						iidx = Array.IndexOf(lblObjs_HSP, lbl)
						If iidx <> -1 Then
							Me.btnObjs_HSP(iidx).Enabled = flg
						End If
						flg = False
					Next
				End If
					'科歴
					For Each lbl As System.Windows.Forms.Label In lblObjs_CH
						iidx = Array.IndexOf(lblObjs_CH, lbl)
						Select Case lbl.Name
							'主病名
							Case Me.lbl131MAX020F010.Name
								'管理単位を取得しSQLを決定
								Select Case eUNIT_CD
									Case XCM.clsConst.Enum_LendUnit.Each_Patient, XCM.clsConst.Enum_LendUnit.Each_Hosp, XCM.clsConst.Enum_LendUnit.Each_Dept
										If Me.chk130MAX020F010.Checked = True Then
											'異常データが存在すれば押下可能に
											icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_CH_CHK22)
											If icnt > 0 Then
												flg = True
											End If
										End If
									Case Else
										'何もしない
								End Select
							'上記以外
							Case Else
								'科歴総件数と比較
								If String.IsNullOrEmpty(Me.lbl072MAX020F010.Text) = False AndAlso _
									CInt(Me.lbl072MAX020F010.Text) > 0 AndAlso _
									Me.lbl072MAX020F010.Text <> lbl.Text AndAlso _
									Me.chkObjs_CH(iidx).Checked = True Then
										flg = True
								End If
						End Select
						'印刷ボタン制御
						If iidx <> -1 Then
							Me.btnObjs_CH(iidx).Enabled = flg
						End If
						flg = False
					Next
			End Using
		Catch ex As Exception
			Throw
		Finally

		End Try

	End Sub

	'''---------------------------------------------
	''' <summary>
	''' 印刷ボタン使用可否制御（タブ用）
	''' </summary>
	''' <remarks>
	''' 2010/11/29 新規作成 ACS)福士<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Sub ChangePrtBtnAttrTabs()
		Me.log(XCM.clsSysMst.logLevel.DBG, "ChangePrtBtnAttrTabs", "印刷ボタン使用可否制御（タブ用） Start")

		Try
			Dim icnt As Integer = 0
			Dim iidx As Integer = 0
			Dim flg As Boolean = False	'True:印刷ボタン押下可

			Select Case Me.tab133MAX020F010.SelectedIndex
				Case 0
					'病名タブ
					For Each lbl As System.Windows.Forms.Label In lblObjs_DISEASE
						Select Case lbl.Name
							'病名
							Case Me.lbl136MAX020F010.Name
								'チェック状態がON かつ 病名とICD10orICD9の件数が一致しない場合使用可
								If String.IsNullOrEmpty(Me.lbl151MAX020F010.Text) = False AndAlso _
									CInt(Me.lbl151MAX020F010.Text) > 0 AndAlso _
									Me.chk135MAX020F010.Checked = True AndAlso _
									Me.lbl151MAX020F010.Text <> lbl.Text Then
									flg = True
								End If
							'大分類
							Case Me.lbl153MAX020F010.Name
								'チェック状態がON かつ ICD10と件数が一致しない場合使用可
								If String.IsNullOrEmpty(Me.lbl147MAX020F010.Text) = False AndAlso _
									CInt(Me.lbl147MAX020F010.Text) > 0 AndAlso _
									Me.chk152MAX020F010.Checked = True AndAlso _
									Me.lbl147MAX020F010.Text <> lbl.Text Then
									flg = True
								End If
							'中分類
							Case Me.lbl156MAX020F010.Name
								'チェック状態がON かつ ICD10と件数が一致しない場合使用可
								If String.IsNullOrEmpty(Me.lbl147MAX020F010.Text) = False AndAlso _
									CInt(Me.lbl147MAX020F010.Text) > 0 AndAlso _
									Me.chk155MAX020F010.Checked = True AndAlso _
									Me.lbl147MAX020F010.Text <> lbl.Text Then
									flg = True
								End If
							'小分類
							Case Me.lbl159MAX020F010.Name
								'チェック状態がON かつ ICD10と件数が一致しない場合使用可
								If String.IsNullOrEmpty(Me.lbl147MAX020F010.Text) = False AndAlso _
									CInt(Me.lbl147MAX020F010.Text) > 0 AndAlso _
									Me.chk158MAX020F010.Checked = True AndAlso _
									Me.lbl147MAX020F010.Text <> lbl.Text Then
									flg = True
								End If
							'３００分類
							Case Me.lbl162MAX020F010.Name
								'チェック状態がON かつ ICD10と件数が一致しない場合使用可
								If String.IsNullOrEmpty(Me.lbl147MAX020F010.Text) = False AndAlso _
									CInt(Me.lbl147MAX020F010.Text) > 0 AndAlso _
									Me.chk161MAX020F010.Checked = True AndAlso _
									Me.lbl147MAX020F010.Text <> lbl.Text Then
									flg = True
								End If
							'a分類
							Case Me.lbl165MAX020F010.Name
								'チェック状態がON かつ ICD10と件数が一致しない場合使用可
								If String.IsNullOrEmpty(Me.lbl147MAX020F010.Text) = False AndAlso _
									CInt(Me.lbl147MAX020F010.Text) > 0 AndAlso _
									Me.chk164MAX020F010.Checked = True AndAlso _
									Me.lbl147MAX020F010.Text <> lbl.Text Then
									flg = True
								End If
							'b分類
							Case Me.lbl168MAX020F010.Name
								'チェック状態がON かつ ICD10と件数が一致しない場合使用可
								If String.IsNullOrEmpty(Me.lbl147MAX020F010.Text) = False AndAlso _
									CInt(Me.lbl147MAX020F010.Text) > 0 AndAlso _
									Me.chk167MAX020F010.Checked = True AndAlso _
									Me.lbl147MAX020F010.Text <> lbl.Text Then
									flg = True
								End If
							'c分類
							Case Me.lbl171MAX020F010.Name
								'チェック状態がON かつ ICD10と件数が一致しない場合使用可
								If String.IsNullOrEmpty(Me.lbl147MAX020F010.Text) = False AndAlso _
									CInt(Me.lbl147MAX020F010.Text) > 0 AndAlso _
									Me.chk170MAX020F010.Checked = True AndAlso _
									Me.lbl147MAX020F010.Text <> lbl.Text Then
									flg = True
								End If
							'病名区分
							Case Me.lbl144MAX020F010.Name
								'チェック状態がON かつ ICD10と件数が一致しない場合使用可
								If String.IsNullOrEmpty(Me.lbl147MAX020F010.Text) = False AndAlso _
									CInt(Me.lbl147MAX020F010.Text) > 0 AndAlso _
									Me.chk143MAX020F010.Checked = True AndAlso _
									Me.lbl147MAX020F010.Text <> lbl.Text Then
									flg = True
								End If
							'病名転帰
							Case Me.lbl174MAX020F010.Name
								'チェック状態がON かつ ICD10と件数が一致しない場合使用可
								If String.IsNullOrEmpty(Me.lbl147MAX020F010.Text) = False AndAlso _
									CInt(Me.lbl147MAX020F010.Text) > 0 AndAlso _
									Me.chk173MAX020F010.Checked = True AndAlso _
									Me.lbl147MAX020F010.Text <> lbl.Text Then
									flg = True
								End If
							'発症日
							Case Me.lbl177MAX020F010.Name
								'チェック状態がON かつ ICD10と件数が一致しない場合使用可
								If String.IsNullOrEmpty(Me.lbl147MAX020F010.Text) = False AndAlso _
									CInt(Me.lbl147MAX020F010.Text) > 0 AndAlso _
									Me.chk176MAX020F010.Checked = True AndAlso _
									Me.lbl147MAX020F010.Text <> lbl.Text Then
									flg = True
								End If
							'診断日
							Case Me.lbl180MAX020F010.Name
								'チェック状態がON かつ ICD10と件数が一致しない場合使用可
								If String.IsNullOrEmpty(Me.lbl147MAX020F010.Text) = False AndAlso _
									CInt(Me.lbl147MAX020F010.Text) > 0 AndAlso _
									Me.chk179MAX020F010.Checked = True AndAlso _
									Me.lbl147MAX020F010.Text <> lbl.Text Then
									flg = True
								End If
							'終了日
							Case Me.lbl183MAX020F010.Name
								'チェック状態がON かつ ICD10と件数が一致しない場合使用可
								If String.IsNullOrEmpty(Me.lbl147MAX020F010.Text) = False AndAlso _
									CInt(Me.lbl147MAX020F010.Text) > 0 AndAlso _
									Me.chk182MAX020F010.Checked = True AndAlso _
									Me.lbl147MAX020F010.Text <> lbl.Text Then
									flg = True
								End If
							'死因分類(クラス設計書№237)
							Case Me.lbl188MAX020F010.Name
								'チェック状態がON かつ 原死因が病名と件数が一致しない場合使用可
								If String.IsNullOrEmpty(Me.lbl186MAX020F010.Text) = False AndAlso _
									CInt(Me.lbl186MAX020F010.Text) > 0 AndAlso _
									Me.chk187MAX020F010.Checked = True AndAlso _
									Me.lbl186MAX020F010.Text <> lbl.Text Then
									flg = True
								End If
							'死因分類(クラス設計書№242)
							Case Me.lbl193MAX020F010.Name
								'チェック状態がON かつ 原死因が外因と件数が一致しない場合使用可
								If String.IsNullOrEmpty(Me.lbl191MAX020F010.Text) = False AndAlso _
									CInt(Me.lbl191MAX020F010.Text) > 0 AndAlso _
									Me.chk192MAX020F010.Checked = True AndAlso _
									Me.lbl191MAX020F010.Text <> lbl.Text Then
									flg = True
								End If
						End Select

						'印刷ボタン制御
						iidx = Array.IndexOf(lblObjs_DISEASE, lbl)
						If iidx <> -1 Then
							Me.btnObjs_DISEASE(iidx).Enabled = flg
						End If
						flg = False
					Next
				Case 1
					'手術タブ
					For Each lbl As System.Windows.Forms.Label In lblObjs_OPE
						'チェック状態がON かつ 手術の件数と一致しない場合使用可
						iidx = Array.IndexOf(lblObjs_OPE, lbl)
						If String.IsNullOrEmpty(Me.lbl198MAX020F010.Text) = False AndAlso _
							CInt(Me.lbl198MAX020F010.Text) > 0 AndAlso _
							Me.chkObjs_OPE(iidx).Checked = True AndAlso _
							Me.lbl198MAX020F010.Text <> lbl.Text Then
								flg = True
						End If
						'印刷ボタン制御
						If iidx <> -1 Then
							Me.btnObjs_OPE(iidx).Enabled = flg
						End If
						flg = False
					Next
				Case 2
					'治療処理タブ
					For Each lbl As System.Windows.Forms.Label In lblObjs_CARE
						'チェック状態がON かつ 手術の件数と一致しない場合使用可
						iidx = Array.IndexOf(lblObjs_CARE, lbl)
						If String.IsNullOrEmpty(Me.lbl267MAX020F010.Text) = False AndAlso _
							CInt(Me.lbl267MAX020F010.Text) > 0 AndAlso _
							Me.chkObjs_CARE(iidx).Checked = True AndAlso _
							Me.lbl267MAX020F010.Text <> lbl.Text Then
								flg = True
						End If
						'印刷ボタン制御
						If iidx <> -1 Then
							Me.btnObjs_CARE(iidx).Enabled = flg
						End If
						flg = False
					Next
				Case 3
					'検査タブ
					For Each lbl As System.Windows.Forms.Label In lblObjs_TEST
						'チェック状態がON かつ 手術の件数と一致しない場合使用可
						iidx = Array.IndexOf(lblObjs_TEST, lbl)
						If String.IsNullOrEmpty(Me.lbl297MAX020F010.Text) = False AndAlso _
							CInt(Me.lbl297MAX020F010.Text) > 0 AndAlso _
							Me.chkObjs_TEST(iidx).Checked = True AndAlso _
							Me.lbl297MAX020F010.Text <> lbl.Text Then
								flg = True
						End If
						'印刷ボタン制御
						If iidx <> -1 Then
							Me.btnObjs_TEST(iidx).Enabled = flg
						End If
						flg = False
					Next
				Case 4
					'死亡タブ
					'終了転帰「死亡」の重複
					Dim lblTarget As System.Windows.Forms.Label = Nothing
					Select Case Me.strENV0059
						Case clsConst.Enum_EndOutComeDupDeath.ImPossible
							'重複なしの場合、重複患者を除いた死亡の件数と一致しない場合使用可
							lblTarget = Me.lbl329MAX020F010
						Case clsConst.Enum_EndOutComeDupDeath.Possible
							'重複ありの場合、終了転帰が死亡の件数と一致しない場合使用可
							lblTarget = Me.lbl327MAX020F010
						Case Else

					End Select

					If lblTarget IsNot Nothing Then
						For Each lbl As System.Windows.Forms.Label In lblObjs_DEATH
							'チェック状態がON かつ 上記で算出した件数と一致しない場合使用可
							iidx = Array.IndexOf(lblObjs_DEATH, lbl)
							Select Case lbl.Name
								Case Me.lbl359MAX020F010.Name
									'剖検番号
									If String.IsNullOrEmpty(Me.lbl357MAX020F010.Text) = False AndAlso _
										CInt(Me.lbl357MAX020F010.Text) > 0 AndAlso _
										Me.chkObjs_DEATH(iidx).Checked = True AndAlso _
										Me.lbl357MAX020F010.Text <> Me.lbl359MAX020F010.Text Then
										flg = True
									End If
								Case Else
									If String.IsNullOrEmpty(lblTarget.Text) = False AndAlso _
										CInt(lblTarget.Text) > 0 AndAlso _
										Me.chkObjs_DEATH(iidx).Checked = True AndAlso _
										lblTarget.Text <> lbl.Text Then
											flg = True
									End If
							End Select

							'印刷ボタン制御
							If iidx <> -1 Then
								Me.btnObjs_DEATH(iidx).Enabled = flg
							End If
							flg = False
						Next
					End If
				Case 5
					'紹介タブ
					'開始経路
					For Each lbl As System.Windows.Forms.Label In lblObjs_STINTRO
						Select Case lbl.Name
							'医療機関コード(クラス設計書№414)
							Case Me.lbl366MAX020F010.Name
								'チェック状態がON かつ 開始経路が紹介の件数が一致しない場合使用可
								If String.IsNullOrEmpty(Me.lbl364MAX020F010.Text) = False AndAlso _
									CInt(Me.lbl364MAX020F010.Text) > 0 AndAlso _
									Me.chk365MAX020F010.Checked = True AndAlso _
									Me.lbl364MAX020F010.Text <> lbl.Text Then
									flg = True
								End If
							'医療機関名(クラス設計書№417)
							Case Me.lbl369MAX020F010.Name
								'チェック状態がON かつ 開始経路が紹介の件数が一致しない場合使用可
								If String.IsNullOrEmpty(Me.lbl364MAX020F010.Text) = False AndAlso _
									CInt(Me.lbl364MAX020F010.Text) > 0 AndAlso _
									Me.chk368MAX020F010.Checked = True AndAlso _
									Me.lbl364MAX020F010.Text <> lbl.Text Then
									flg = True
								End If
							'医師名(クラス設計書№420)
							Case Me.lbl372MAX020F010.Name
								'チェック状態がON かつ 開始経路が紹介の件数が一致しない場合使用可
								If String.IsNullOrEmpty(Me.lbl364MAX020F010.Text) = False AndAlso _
									CInt(Me.lbl364MAX020F010.Text) > 0 AndAlso _
									Me.chk371MAX020F010.Checked = True AndAlso _
									Me.lbl364MAX020F010.Text <> lbl.Text Then
									flg = True
								End If
						End Select
						'印刷ボタン制御
						iidx = Array.IndexOf(lblObjs_STINTRO, lbl)
						If iidx <> -1 Then
							Me.btnObjs_STINTRO(iidx).Enabled = flg
						End If
						flg = False
					Next

					'終了経路
					For Each lbl As System.Windows.Forms.Label In lblObjs_ENINTRO
						Select Case lbl.Name
							'医療機関コード(クラス設計書№414)
							Case Me.lbl377MAX020F010.Name
								'チェック状態がON かつ 開始経路が紹介の件数が一致しない場合使用可
								If String.IsNullOrEmpty(Me.lbl375MAX020F010.Text) = False AndAlso _
									CInt(Me.lbl375MAX020F010.Text) > 0 AndAlso _
									Me.chk376MAX020F010.Checked = True AndAlso _
									Me.lbl375MAX020F010.Text <> lbl.Text Then
									flg = True
								End If
							'医療機関名(クラス設計書№417)
							Case Me.lbl380MAX020F010.Name
								'チェック状態がON かつ 開始経路が紹介の件数が一致しない場合使用可
								If String.IsNullOrEmpty(Me.lbl375MAX020F010.Text) = False AndAlso _
									CInt(Me.lbl375MAX020F010.Text) > 0 AndAlso _
									Me.chk379MAX020F010.Checked = True AndAlso _
									Me.lbl375MAX020F010.Text <> lbl.Text Then
									flg = True
								End If
							'医師名(クラス設計書№420)
							Case Me.lbl383MAX020F010.Name
								'チェック状態がON かつ 開始経路が紹介の件数が一致しない場合使用可
								If String.IsNullOrEmpty(Me.lbl375MAX020F010.Text) = False AndAlso _
									CInt(Me.lbl375MAX020F010.Text) > 0 AndAlso _
									Me.chk382MAX020F010.Checked = True AndAlso _
									Me.lbl375MAX020F010.Text <> lbl.Text Then
									flg = True
								End If
						End Select
						'印刷ボタン制御
						iidx = Array.IndexOf(lblObjs_ENINTRO, lbl)
						If iidx <> -1 Then
							Me.btnObjs_ENINTRO(iidx).Enabled = flg
						End If
						flg = False
					Next
				Case Else

			End Select

		Catch ex As Exception
			Throw
		Finally

		End Try

	End Sub

#End Region

#Region "オーバーライドメソッド"

	'''---------------------------------------------
	''' <summary>
	''' データ検索処理
	''' </summary>
	''' <remarks>
	''' 2010/11/19 新規作成 ACS)福士<BR/>
	''' </remarks>
	'''---------------------------------------------
	Protected Overrides Sub SelProc()
		Me.log(XCM.clsSysMst.logLevel.DBG, "SelProc", "データ検索処理 Start")
		Try
			Me.Cursor = Cursors.WaitCursor

			Dim icnt As Integer = 0
			'入力チェック
			If Me.ChkData() = True AndAlso Me.cliSearch.getSearch(Me) = True Then
				'ステータスバーにメッセージ表示
				Me.showMsgBar("I0021", Enum_MsgIcon.None, Nothing, Nothing)
				Me.sst001frmBase.Refresh()

				'検索条件入力不可
				Me.btn035MAX000F020.Select()
				Me.grp004MAX000F020.Enabled = False

				Using db As New XCM.clsDB(XCM.clsSysMst.ctlConfigData)
					'入退院側の条件が有効の場合
					If Me.chk025MAX000F020.Checked = True OrElse _
					   Me.chk029MAX000F020.Checked = True OrElse _
					   Me.chk031MAX000F020.Checked = True Then
						'入退院検索条件が有効の場合
						'WHERE句生成条件を入退院側に設定
						Me.sTBL_CD = clsMAXCOMMON.CST_TABLECD_MTI_HSP

						'入退院情報関連
						'入退院総件数の取得
						icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_HSP_ALL)
						If icnt >= 0 Then
							Me.lbl009MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
							Me.lbl009MAX020F010.Refresh()
						End If

						'病歴番号件数の取得
						If Me.chk010MAX020F010.Checked = True Then
							icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_HSP_CHK1)
							If icnt >= 0 Then
								Me.lbl011MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
								Me.lbl011MAX020F010.Refresh()
							End If
						End If

						'入院科歴件数の取得
						If Me.chk013MAX020F010.Checked = True Then
							icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_HSP_CHK2)
							If icnt >= 0 Then
								Me.lbl014MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
								Me.lbl014MAX020F010.Refresh()
							End If
						End If

						'主科科歴件数の取得
						If Me.chk016MAX020F010.Checked = True Then
							icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_HSP_CHK3)
							If icnt >= 0 Then
								Me.lbl017MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
								Me.lbl017MAX020F010.Refresh()
							End If
						End If

						'退院科歴件数の取得
						If Me.chk019MAX020F010.Checked = True Then
							icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_HSP_CHK4)
							If icnt >= 0 Then
								Me.lbl020MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
								Me.lbl020MAX020F010.Refresh()
							End If
						End If

						'診療科件数の取得
						If Me.chk022MAX020F010.Checked = True Then
							icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_HSP_CHK5)
							If icnt >= 0 Then
								Me.lbl023MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
								Me.lbl023MAX020F010.Refresh()
							End If
						End If

						'病棟件数の取得
						If Me.chk025MAX020F010.Checked = True Then
							icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_HSP_CHK6)
							If icnt >= 0 Then
								Me.lbl026MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
								Me.lbl026MAX020F010.Refresh()
							End If
						End If

						'在院日数件数の取得
						If Me.chk028MAX020F010.Checked = True Then
							icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_HSP_CHK7)
							If icnt >= 0 Then
								Me.lbl029MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
								Me.lbl029MAX020F010.Refresh()
							End If
						End If

						'医師件数の取得
						If Me.chk031MAX020F010.Checked = True Then
							icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_HSP_CHK8)
							If icnt >= 0 Then
								Me.lbl032MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
								Me.lbl032MAX020F010.Refresh()
							End If
						End If

						'入院日件数の取得
						If Me.chk034MAX020F010.Checked = True Then
							icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_HSP_CHK9)
							If icnt >= 0 Then
								Me.lbl035MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
								Me.lbl035MAX020F010.Refresh()
							End If
						End If

						'予定緊急件数の取得
						If Me.chk037MAX020F010.Checked = True Then
							icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_HSP_CHK10)
							If icnt >= 0 Then
								Me.lbl038MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
								Me.lbl038MAX020F010.Refresh()
							End If
						End If

						'入院目的件数の取得
						If Me.chk040MAX020F010.Checked = True Then
							icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_HSP_CHK11)
							If icnt >= 0 Then
								Me.lbl041MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
								Me.lbl041MAX020F010.Refresh()
							End If
						End If

						'入院形態件数の取得
						If Me.chk043MAX020F010.Checked = True Then
							icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_HSP_CHK12)
							If icnt >= 0 Then
								Me.lbl044MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
								Me.lbl044MAX020F010.Refresh()
							End If
						End If

						'救急車有無件数の取得
						If Me.chk046MAX020F010.Checked = True Then
							icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_HSP_CHK13)
							If icnt >= 0 Then
								Me.lbl047MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
								Me.lbl047MAX020F010.Refresh()
							End If
						End If

						'退院日件数の取得
						If Me.chk049MAX020F010.Checked = True Then
							icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_HSP_CHK14)
							If icnt >= 0 Then
								Me.lbl050MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
								Me.lbl050MAX020F010.Refresh()
							End If
						End If

						'退院転帰件数の取得
						If Me.chk052MAX020F010.Checked = True Then
							icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_HSP_CHK15)
							If icnt >= 0 Then
								Me.lbl053MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
								Me.lbl053MAX020F010.Refresh()
							End If
						End If

						'主病名件数の取得
						If Me.chk056MAX020F010.Checked = True Then
							icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_HSP_CHK16)
							If icnt >= 0 Then
								Me.lbl057MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
								Me.lbl057MAX020F010.Refresh()
							End If
						End If

						'入院契機件数の取得
						If Me.chk059MAX020F010.Checked = True Then
							icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_HSP_CHK17)
							If icnt >= 0 Then
								Me.lbl060MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
								Me.lbl060MAX020F010.Refresh()
							End If
						End If

						'医療資源投入件数の取得
						If Me.chk062MAX020F010.Checked = True Then
							'医療資源投入１位件数の取得
							icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_HSP_CHK18)
							If icnt >= 0 Then
								Me.lbl064MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
								Me.lbl064MAX020F010.Refresh()
							End If
							'医療資源投入２位件数の取得
							icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_HSP_CHK19)
							If icnt >= 0 Then
								Me.lbl067MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
								Me.lbl067MAX020F010.Refresh()
							End If
						End If
					Else
						'科歴検索条件が有効の場合
						'WHERE句生成条件を科歴条件に設定
						Me.sTBL_CD = clsMAXCOMMON.CST_TABLECD_MTI_CH
					End If

					'科歴情報関連
					'科歴情報総件数の取得
					icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_CH_ALL)
					If icnt >= 0 Then
						Me.lbl072MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
						Me.lbl072MAX020F010.Refresh()
					End If

					'病歴番号件数の取得
					If Me.chk073MAX020F010.Checked = True Then
						icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_CH_CHK1)
						If icnt >= 0 Then
							Me.lbl074MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
							Me.lbl074MAX020F010.Refresh()
						End If
					End If

					'郵便番号件数の取得
					If Me.chk076MAX020F010.Checked = True Then
						icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_CH_CHK2)
						If icnt >= 0 Then
							Me.lbl077MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
							Me.lbl077MAX020F010.Refresh()
						End If
					End If

					'診療圏件数の取得
					If Me.chk079MAX020F010.Checked = True Then
						icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_CH_CHK3)
						If icnt >= 0 Then
							Me.lbl080MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
							Me.lbl080MAX020F010.Refresh()
						End If
					End If

					'診療科件数の取得
					If Me.chk082MAX020F010.Checked = True Then
						icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_CH_CHK4)
						If icnt >= 0 Then
							Me.lbl083MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
							Me.lbl083MAX020F010.Refresh()
						End If
					End If

					'主病棟件数の取得
					If Me.chk085MAX020F010.Checked = True Then
						icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_CH_CHK5)
						If icnt >= 0 Then
							Me.lbl086MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
							Me.lbl086MAX020F010.Refresh()
						End If
					End If

					'在院日数件数の取得
					If Me.chk088MAX020F010.Checked = True Then
						icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_CH_CHK6)
						If icnt >= 0 Then
							Me.lbl089MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
							Me.lbl089MAX020F010.Refresh()
						End If
					End If

					'代表医師件数の取得
					If Me.chk091MAX020F010.Checked = True Then
						icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_CH_CHK7)
						If icnt >= 0 Then
							Me.lbl092MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
							Me.lbl092MAX020F010.Refresh()
						End If
					End If

					'開始日件数の取得
					If Me.chk094MAX020F010.Checked = True Then
						icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_CH_CHK8)
						If icnt >= 0 Then
							Me.lbl095MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
							Me.lbl095MAX020F010.Refresh()
						End If
					End If

					'開始時年齢件数の取得
					If Me.chk097MAX020F010.Checked = True Then
						icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_CH_CHK9)
						If icnt >= 0 Then
							Me.lbl098MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
							Me.lbl098MAX020F010.Refresh()
						End If
					End If

					'開始経路件数の取得
					If Me.chk100MAX020F010.Checked = True Then
						'開始経路件数の取得
						icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_CH_CHK10)
						If icnt >= 0 Then
							Me.lbl101MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
							Me.lbl101MAX020F010.Refresh()
						End If
						'開始経路(紹介)件数の取得
						icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_CH_CHK11)
						If icnt >= 0 Then
							Me.lbl104MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
							Me.lbl104MAX020F010.Refresh()
						End If
						'開始経路(転科)件数の取得
						icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_CH_CHK12)
						If icnt >= 0 Then
							Me.lbl106MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
							Me.lbl106MAX020F010.Refresh()
						End If
						'開始経路(兼科)件数の取得
						icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_CH_CHK13)
						If icnt >= 0 Then
							Me.lbl108MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
							Me.lbl108MAX020F010.Refresh()
						End If
					End If

					'終了日件数の取得
					If Me.chk110MAX020F010.Checked = True Then
						icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_CH_CHK14)
						If icnt >= 0 Then
							Me.lbl111MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
							Me.lbl111MAX020F010.Refresh()
						End If
					End If

					'終了時年齢件数の取得
					If Me.chk113MAX020F010.Checked = True Then
						icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_CH_CHK15)
						If icnt >= 0 Then
							Me.lbl114MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
							Me.lbl114MAX020F010.Refresh()
						End If
					End If

					'終了経路件数の取得
					If Me.chk116MAX020F010.Checked = True Then
						'終了経路件数の取得
						icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_CH_CHK16)
						If icnt >= 0 Then
							Me.lbl117MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
							Me.lbl117MAX020F010.Refresh()
						End If
						'終了経路(紹介)件数の取得
						icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_CH_CHK17)
						If icnt >= 0 Then
							Me.lbl120MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
							Me.lbl120MAX020F010.Refresh()
						End If
						'終了経路(転科)件数の取得
						icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_CH_CHK18)
						If icnt >= 0 Then
							Me.lbl122MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
							Me.lbl122MAX020F010.Refresh()
						End If
					End If

					'終了転帰件数の取得
					If Me.chk124MAX020F010.Checked = True Then
						'終了転帰件数の取得
						icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_CH_CHK19)
						If icnt >= 0 Then
							Me.lbl125MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
							Me.lbl125MAX020F010.Refresh()
						End If
						'終了転帰(死亡)件数の取得
						icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_CH_CHK20)
						If icnt >= 0 Then
							Me.lbl128MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
							Me.lbl128MAX020F010.Refresh()
						End If
					End If

					'主病名件数の取得
					If Me.chk130MAX020F010.Checked = True Then
						icnt = Me.GetAllCnt(db, Enum_SQLID.SQLID_MTI_CH_CHK21)
						If icnt >= 0 Then
							Me.lbl131MAX020F010.Text = icnt.ToString(XCM.clsConst.CST_KENSU_FORMAT)
							Me.lbl131MAX020F010.Refresh()
						End If
					End If
				End Using

				'タブ内の実行(F8)ボタンを押下可能
				For Each btn As System.Windows.Forms.Button In btnObjs_EXEC_TAB
					btn.Enabled = True
				Next

				'印刷ボタン使用可否制御
				Me.ChangePrtBtnAttr()

				Me.showMsg("I0006", "検索", Nothing)	'終了メッセージ出力

			End If
		Catch ex As Exception
			Throw
		Finally
			'メッセージバー表示クリア
			Me.clearMsgBar()
			Me.Cursor = Cursors.Default
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' 入力チェック
	''' </summary>
	''' <returns>True:正常、False:入力値異常</returns>
	''' <remarks>
	''' 2010/11/29 新規作成 ACS)福士<BR/>
	''' </remarks>
	'''---------------------------------------------
	Protected Overrides Function ChkData() As Boolean
		Me.log(XCM.clsSysMst.logLevel.DBG, "ChkData", "入力チェック Start")
		Dim ret As Boolean = False
		Try
			'Validatedのチェック
			If Me.ValidateChildren() = True Then
				'チェックされているが、入力されていない項目を走査する
				'診療科
				If Me.chk001MAX020F010.Checked = True Then
					If String.IsNullOrEmpty(Me.cmb002MAX020F010.Text) = True Then
						Me.addErrList("E0016", Me.cmb002MAX020F010.Name, Me.chk001MAX020F010.Text, Me.chk001MAX020F010.Text, Nothing)
					End If
				End If
				'登録状況
				If Me.chk004MAX020F010.Checked = True Then
					If String.IsNullOrEmpty(Me.cmb005MAX020F010.Text) = True Then
						Me.addErrList("E0016", Me.cmb005MAX020F010.Name, Me.chk004MAX020F010.Text, Me.chk004MAX020F010.Text, Nothing)
					End If
				End If
			End If

			'検索条件入力チェック
			ret = MyBase.ChkData()
		Catch ex As Exception
			Throw
		End Try
		Return ret
	End Function

	'''---------------------------------------------
	''' <summary>
	''' 帳票出力処理
	''' </summary>
	''' <remarks>
	''' 2010/11/24 新規作成 ACS)福士<BR/>
	''' </remarks>
	'''---------------------------------------------
	Protected Overrides Sub PrintReport(ByVal obtn As System.Windows.Forms.Button)
		Me.log(XCM.clsSysMst.logLevel.DBG, "PrintReport", "帳票出力処理 Start")
		Try
			Dim sCondition As String = Nothing
			Dim sTitle As String = Nothing
			Dim bprtflg As Boolean = False

			'帳票出力用検索条件文字列取得
			sCondition = Me.GetSearchCondString

			'帳票出力用検索条件取得
			sTitle = Me.GetPrintTitle(obtn)

			'印刷・プレビュー判定
			bprtflg = Me.rdo002MAX000F020.Checked

			Select Case True
				'入退院対象一覧
				Case obtn Is Me.btn012MAX020F010 OrElse _
					 obtn Is Me.btn015MAX020F010 OrElse _
					 obtn Is Me.btn018MAX020F010 OrElse _
					 obtn Is Me.btn021MAX020F010 OrElse _
					 obtn Is Me.btn024MAX020F010 OrElse _
					 obtn Is Me.btn027MAX020F010 OrElse _
					 obtn Is Me.btn030MAX020F010 OrElse _
					 obtn Is Me.btn033MAX020F010 OrElse _
					 obtn Is Me.btn036MAX020F010 OrElse _
					 obtn Is Me.btn039MAX020F010 OrElse _
					 obtn Is Me.btn042MAX020F010 OrElse _
					 obtn Is Me.btn045MAX020F010 OrElse _
					 obtn Is Me.btn048MAX020F010 OrElse _
					 obtn Is Me.btn051MAX020F010 OrElse _
					 obtn Is Me.btn054MAX020F010 OrElse _
					 obtn Is Me.btn061MAX020F010 OrElse _
					 obtn Is Me.btn065MAX020F010 OrElse _
					 obtn Is Me.btn068MAX020F010
					Using cliRpt As New MAX020R010(Me, bprtflg, sTitle, sCondition, Me.cliSearch, Me.sTBL_CD, obtn.Name)
						'帳票出力処理
						cliRpt.exeReport()
					End Using
				'科歴
				Case obtn Is Me.btn075MAX020F010 OrElse _
					 obtn Is Me.btn078MAX020F010 OrElse _
					 obtn Is Me.btn081MAX020F010 OrElse _
					 obtn Is Me.btn084MAX020F010 OrElse _
					 obtn Is Me.btn087MAX020F010 OrElse _
					 obtn Is Me.btn090MAX020F010 OrElse _
					 obtn Is Me.btn093MAX020F010 OrElse _
					 obtn Is Me.btn096MAX020F010 OrElse _
					 obtn Is Me.btn099MAX020F010 OrElse _
					 obtn Is Me.btn102MAX020F010 OrElse _
					 obtn Is Me.btn112MAX020F010 OrElse _
					 obtn Is Me.btn115MAX020F010 OrElse _
					 obtn Is Me.btn118MAX020F010 OrElse _
					 obtn Is Me.btn126MAX020F010
					Using cliRpt As New MAX020R020(Me, bprtflg, sTitle, sCondition, Me.cliSearch, Me.sTBL_CD, obtn.Name)
						'帳票出力処理
						cliRpt.exeReport()
					End Using
				'病名タブ
				Case obtn Is Me.btn137MAX020F010 OrElse _
					 obtn Is Me.btn145MAX020F010 OrElse _
					 obtn Is Me.btn154MAX020F010 OrElse _
					 obtn Is Me.btn157MAX020F010 OrElse _
					 obtn Is Me.btn160MAX020F010 OrElse _
					 obtn Is Me.btn163MAX020F010 OrElse _
					 obtn Is Me.btn166MAX020F010 OrElse _
					 obtn Is Me.btn169MAX020F010 OrElse _
					 obtn Is Me.btn172MAX020F010 OrElse _
					 obtn Is Me.btn175MAX020F010 OrElse _
					 obtn Is Me.btn178MAX020F010 OrElse _
					 obtn Is Me.btn181MAX020F010 OrElse _
					 obtn Is Me.btn184MAX020F010 OrElse _
					 obtn Is Me.btn189MAX020F010 OrElse _
					 obtn Is Me.btn194MAX020F010
					Using cliRpt As New MAX020R020(Me, bprtflg, sTitle, sCondition, Me.cliSearch, Me.sTBL_CD, obtn.Name)
						'帳票出力処理
						cliRpt.exeReport()
					End Using
				'手術タブ
				Case obtn Is Me.btn206MAX020F010 OrElse _
					 obtn Is Me.btn209MAX020F010 OrElse _
					 obtn Is Me.btn212MAX020F010 OrElse _
					 obtn Is Me.btn215MAX020F010 OrElse _
					 obtn Is Me.btn218MAX020F010 OrElse _
					 obtn Is Me.btn221MAX020F010 OrElse _
					 obtn Is Me.btn224MAX020F010 OrElse _
					 obtn Is Me.btn227MAX020F010 OrElse _
					 obtn Is Me.btn230MAX020F010 OrElse _
					 obtn Is Me.btn233MAX020F010 OrElse _
					 obtn Is Me.btn236MAX020F010 OrElse _
					 obtn Is Me.btn239MAX020F010 OrElse _
					 obtn Is Me.btn242MAX020F010 OrElse _
					 obtn Is Me.btn245MAX020F010 OrElse _
					 obtn Is Me.btn248MAX020F010 OrElse _
					 obtn Is Me.btn251MAX020F010 OrElse _
					 obtn Is Me.btn254MAX020F010 OrElse _
					 obtn Is Me.btn257MAX020F010 OrElse _
					 obtn Is Me.btn260MAX020F010 OrElse _
					 obtn Is Me.btn263MAX020F010
					Using cliRpt As New MAX020R020(Me, bprtflg, sTitle, sCondition, Me.cliSearch, Me.sTBL_CD, obtn.Name)
						'帳票出力処理
						cliRpt.exeReport()
					End Using
				'治療処置タブ
				Case obtn Is Me.btn275MAX020F010 OrElse _
					 obtn Is Me.btn278MAX020F010 OrElse _
					 obtn Is Me.btn281MAX020F010 OrElse _
					 obtn Is Me.btn284MAX020F010 OrElse _
					 obtn Is Me.btn287MAX020F010 OrElse _
					 obtn Is Me.btn290MAX020F010 OrElse _
					 obtn Is Me.btn293MAX020F010
					Using cliRpt As New MAX020R020(Me, bprtflg, sTitle, sCondition, Me.cliSearch, Me.sTBL_CD, obtn.Name)
						'帳票出力処理
						cliRpt.exeReport()
					End Using
				'検査タブ
				Case obtn Is Me.btn305MAX020F010 OrElse _
					 obtn Is Me.btn308MAX020F010 OrElse _
					 obtn Is Me.btn311MAX020F010 OrElse _
					 obtn Is Me.btn314MAX020F010 OrElse _
					 obtn Is Me.btn317MAX020F010 OrElse _
					 obtn Is Me.btn320MAX020F010 OrElse _
					 obtn Is Me.btn323MAX020F010
					Using cliRpt As New MAX020R020(Me, bprtflg, sTitle, sCondition, Me.cliSearch, Me.sTBL_CD, obtn.Name)
						'帳票出力処理
						cliRpt.exeReport()
					End Using
				'紹介タブ
				Case obtn Is Me.btn367MAX020F010 OrElse _
					 obtn Is Me.btn370MAX020F010 OrElse _
					 obtn Is Me.btn373MAX020F010 OrElse _
					 obtn Is Me.btn378MAX020F010 OrElse _
					 obtn Is Me.btn381MAX020F010 OrElse _
					 obtn Is Me.btn384MAX020F010
					Using cliRpt As New MAX020R020(Me, bprtflg, sTitle, sCondition, Me.cliSearch, Me.sTBL_CD, obtn.Name)
						'帳票出力処理
						cliRpt.exeReport()
					End Using
				'主病名入退院一覧
				Case obtn Is Me.btn058MAX020F010
					Using cliRpt As New MAX020R030(Me, bprtflg, sTitle, sCondition, Me.cliSearch, Me.sTBL_CD, obtn.Name)
						'帳票出力処理
						cliRpt.exeReport()
					End Using
				'主病名科歴一覧
				Case obtn Is Me.btn132MAX020F010
					Using cliRpt As New MAX020R040(Me, bprtflg, sTitle, sCondition, Me.cliSearch, Me.sTBL_CD, obtn.Name)
						'帳票出力処理
						cliRpt.exeReport()
					End Using
				'死亡タブ
				Case obtn Is Me.btn332MAX020F010 OrElse _
					 obtn Is Me.btn335MAX020F010 OrElse _
					 obtn Is Me.btn338MAX020F010 OrElse _
					 obtn Is Me.btn341MAX020F010 OrElse _
					 obtn Is Me.btn344MAX020F010 OrElse _
					 obtn Is Me.btn347MAX020F010 OrElse _
					 obtn Is Me.btn350MAX020F010 OrElse _
					 obtn Is Me.btn360MAX020F010
					Using cliRpt As New MAX020R050(Me, bprtflg, sTitle, sCondition, Me.cliSearch, Me.sTBL_CD, obtn.Name)
						'帳票出力処理
						cliRpt.exeReport()
					End Using
				Case Else

			End Select
		Catch ex As Exception
			Throw
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' 検索条件文字列生成（帳票出力用）
	''' </summary>
	''' <returns>検索条件文字列</returns>
	''' <remarks>
	''' 2010/11/29 新規作成 ACS)福士<BR/>
	''' </remarks>
	'''---------------------------------------------
	Protected Overrides Function GetSearchCondString() As String
		Me.log(XCM.clsSysMst.logLevel.DBG, "GetSearchCondString", "検索条件文字列生成（帳票出力用） Start")
		Dim sCndStr As String = Nothing
		Try

			'診療科にチェックが入っている場合
			If Me.chk001MAX020F010.Checked = True Then
				If String.IsNullOrEmpty(sCndStr) = False Then
					sCndStr &= vbCrLf
				Else
					sCndStr = vbNullString
				End If
				sCndStr &= (Me.chk001MAX020F010.Text & "：" _
							& Me.lbl003MAX020F010.Text)
			End If

			'病棟にチェックが入っている場合
			If Me.chk004MAX020F010.Checked = True Then
				If String.IsNullOrEmpty(sCndStr) = False Then
					sCndStr &= vbCrLf
				Else
					sCndStr = vbNullString
				End If
				sCndStr &= (Me.chk004MAX020F010.Text & "：" _
							& Me.lbl006MAX020F010.Text)
			End If

			If String.IsNullOrEmpty(sCndStr) = False Then
					sCndStr &= vbCrLf
				Else
					sCndStr = vbNullString
			End If
			'その他の検索条件が入っている場合
			sCndStr &= MyBase.GetSearchCondString()

			Return sCndStr
		Catch ex As Exception
			Throw
		End Try
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' チェックボックスクリック
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/11/29 新規作成 ACS)福士<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Protected Overrides Sub CheckBox_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
		Me.log(XCM.clsSysMst.logLevel.NRM, "CheckBox_Click", "チェックボックスクリック Start")
		Try
			Dim chkFlg As Boolean = True

			Select Case True
				'入退院歴数チェックボックスの場合
				Case sender Is Me.chk008MAX020F010
					For Each tmpchk As XCM.BT_CheckBox In Me.chkObjs_HSP
						tmpchk.Checked = sender.checked
					Next tmpchk
					Exit Sub

				'科歴数チェックボックスの場合
				Case sender Is Me.chk071MAX020F010
					For Each tmpchk As XCM.BT_CheckBox In Me.chkObjs_CH
						tmpchk.Checked = sender.checked
					Next tmpchk
					Exit Sub

				'病名チェックボックスの場合
				Case sender Is Me.chk135MAX020F010
					For Each tmpchk As XCM.BT_CheckBox In Me.chkObjs_DISEASE
						tmpchk.Checked = sender.checked
					Next tmpchk
					Exit Sub

				'手術チェックボックスの場合
				Case sender Is Me.chk197MAX020F010
					For Each tmpchk As XCM.BT_CheckBox In Me.chkObjs_OPE
						tmpchk.Checked = sender.checked
					Next tmpchk
					Exit Sub

				'治療処置チェックボックスの場合
				Case sender Is Me.chk266MAX020F010
					For Each tmpchk As XCM.BT_CheckBox In Me.chkObjs_CARE
						tmpchk.Checked = sender.checked
					Next tmpchk
					Exit Sub

				'検査チェックボックスの場合
				Case sender Is Me.chk296MAX020F010
					For Each tmpchk As XCM.BT_CheckBox In Me.chkObjs_TEST
						tmpchk.Checked = sender.checked
					Next tmpchk
					Exit Sub

				'死亡チェックボックスの場合
				Case sender Is Me.chk326MAX020F010
					For Each tmpchk As XCM.BT_CheckBox In Me.chkObjs_DEATH
						tmpchk.Checked = sender.checked
					Next tmpchk
					Exit Sub

				'開始経路が「紹介」チェックボックスの場合
				Case sender Is Me.chk363MAX020F010
					For Each tmpchk As XCM.BT_CheckBox In Me.chkObjs_STINTRO
						tmpchk.Checked = sender.checked
					Next tmpchk
					Exit Sub

				'終了経路が「紹介」チェックボックスの場合
				Case sender Is Me.chk374MAX020F010
					For Each tmpchk As XCM.BT_CheckBox In Me.chkObjs_ENINTRO
						tmpchk.Checked = sender.checked
					Next tmpchk
					Exit Sub

				'その他チェックボックスの場合
				Case Else
					'入退院数系チェックボックスの場合
					If Array.IndexOf(Me.chkObjs_HSP, sender) >= 0 AndAlso _
					   sender.checked = False Then
						Me.chk008MAX020F010.Checked = sender.checked
					End If

					'科歴数系チェックボックスの場合
					If Array.IndexOf(Me.chkObjs_CH, sender) >= 0 AndAlso _
					   sender.checked = False Then
						Me.chk071MAX020F010.Checked = False
					End If

					'病名系チェックボックスの場合
					If Array.IndexOf(Me.chkObjs_DISEASE, sender) >= 0 AndAlso _
					   sender.checked = False Then
						Me.chk135MAX020F010.Checked = False
					End If

					'手術系チェックボックスの場合
					If Array.IndexOf(Me.chkObjs_OPE, sender) >= 0 AndAlso _
					   sender.checked = False Then
						Me.chk197MAX020F010.Checked = False
					End If

					'治療処置系チェックボックスの場合
					If Array.IndexOf(Me.chkObjs_CARE, sender) >= 0 AndAlso _
					   sender.checked = False Then
						Me.chk266MAX020F010.Checked = False
					End If

					'検査系チェックボックスの場合
					If Array.IndexOf(Me.chkObjs_TEST, sender) >= 0 AndAlso _
					   sender.checked = False Then
						Me.chk296MAX020F010.Checked = False
					End If

					'死亡系チェックボックスの場合
					If Array.IndexOf(Me.chkObjs_DEATH, sender) >= 0 AndAlso _
					   sender.checked = False Then
						Me.chk326MAX020F010.Checked = False
					End If

					'開始経路が「紹介」系チェックボックスの場合
					If Array.IndexOf(Me.chkObjs_STINTRO, sender) >= 0 AndAlso _
					   sender.checked = False Then
						Me.chk363MAX020F010.Checked = False
					End If

					'終了経路が「紹介」系チェックボックスの場合
					If Array.IndexOf(Me.chkObjs_ENINTRO, sender) >= 0 AndAlso _
					   sender.checked = False Then
						Me.chk374MAX020F010.Checked = False
					End If

			End Select
			MyBase.CheckBox_Click(sender, e)
		Catch ex As Exception
			Me.ErrorProc(ex)
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' 画面初期化
	''' </summary>
	''' <remarks>
	''' 2010/11/29 新規作成 ACS)福士<BR/>
	''' </remarks>
	'''---------------------------------------------
	Protected Overrides Sub ClearDsp(Optional ByVal type As ENUM_SET_CONTROL = ENUM_SET_CONTROL.ENUM_CLEAR)
		Me.log(XCM.clsSysMst.logLevel.DBG, "ClearDsp", "画面初期化 Start")
		Try
			'画面のクリア
			MyClass.setControl(Me.grp004MAX000F020, type)
			MyClass.setControl(Me.grp007MAX020F010, type)
			MyClass.setControl(Me.grp070MAX020F010, type)
			MyClass.setControl(Me.tab133MAX020F010, type)

			'検索条件入力可能
			Me.grp004MAX000F020.Enabled = True

			'タブ内ラジオボタンをデフォルト選択
			Me.rdo139MAX020F010.Checked = True
			Me.rdo200MAX020F010.Checked = True
			Me.rdo269MAX020F010.Checked = True
			Me.rdo299MAX020F010.Checked = True

			'印刷ボタンを押下不可
			For Each btn As System.Windows.Forms.Button In btnObjs_Prt
				btn.Enabled = False
			Next

			'タブ内の実行(F8)ボタンを押下不可
			For Each btn As System.Windows.Forms.Button In btnObjs_EXEC_TAB
				btn.Enabled = False
			Next

			MyBase.ClearDsp(type)

			Me.chk001MAX020F010.Select()
		Catch ex As Exception
			Throw
		Finally
			Me.Cursor = Cursors.Default
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' Ｆ８キー押下処理
	''' </summary>
	''' <returns></returns>
	''' <remarks>
	''' 2010/11/29 新規作成 ACS)福士<BR/>
	''' </remarks>
	'''---------------------------------------------
	Public Overrides Function F8KeyProc() As Boolean
		Me.log(XCM.clsSysMst.logLevel.DBG, "F8KeyProc", "Ｆ８キー押下処理 Start")
		Try
			Me.Cursor = Cursors.WaitCursor
			'検索処理
			If Me.cliSearch.getSearch(Me) = False Then Return True
			Select Case Me.tab133MAX020F010.SelectedIndex
				Case 0 : If Me.btn195MAX020F010.Enabled = True Then Me.GetDiseaseCnt() '病名タブ実行処理
				Case 1 : If Me.btn264MAX020F010.Enabled = True Then Me.GetOpeCnt() '手術タブ実行処理
				Case 2 : If Me.btn294MAX020F010.Enabled = True Then Me.GetCareCnt() '治療処理タブ実行処理
				Case 3 : If Me.btn324MAX020F010.Enabled = True Then Me.GetTestCnt() '検査タブ実行処理
				Case 4 : If Me.btn361MAX020F010.Enabled = True Then Me.GetDeathCnt() '死亡タブ実行処理
				Case 5 : If Me.btn385MAX020F010.Enabled = True Then Me.GetHspCnlCnt() '紹介タブ実行処理
				Case Else
					Return False
			End Select
			Return True
		Catch ex As Exception
			Me.ErrorProc(ex)
		Finally
			Me.Cursor = Cursors.Default

		End Try
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' Ｆ１０キー押下処理
	''' </summary>
	''' <returns></returns>
	''' <remarks>
	''' 2010/10/25 新規作成 ACS)仙頭<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Overrides Function F10KeyProc() As Boolean
		DirectCast(Me.TopLevelControl, frmBase).log(clsSysMst.logLevel.NRM, "F10KeyProc", "Ｆ１０キー押下処理 START")
		Try
			If Me.tab133MAX020F010.SelectedIndex >= Me.tab133MAX020F010.TabPages.Count - 1 Then
				Me.tab133MAX020F010.SelectedIndex = 0
			Else
				Me.tab133MAX020F010.SelectedIndex += 1
			End If
			Return True
		Catch ex As Exception
			Throw
		End Try
	End Function

#End Region

End Class